\scheda{defcar}
\tipo{S}
\scopo
Definisce i parametri per il tracciamento dei caratteri.

\ccall
defcar(isp,ryx,dst)
int isp;
float ryx,dst;
\endccall

\param
\prm{isp}Variabile o costante intera contenente la spaziatura
orizzontale dei caratteri: specifica la distanza, in unit\`a grafiche,
tra i punti di riferimento di due caratteri consecutivi.
\prm{ryx}Variabile o costante reale contenente il rapporto tra
l'$\,$altezza e la larghezza del reticolo su cui \`e tracciato il
carattere. Ad esempio, un rapporto 4 significa che l'$\,$altezza del
reticolo viene moltiplicata per 2, e la larghezza divisa per 2, in modo
che il lato verticale sia 4 volte quello orizzontale.
\prm{dst}Variabile o costante reale contenente il fattore di
inclinazione di un carattere: durante il tracciamento, ogni segmento
verticale di altezza $\delta u$ viene inclinato sommandogli uno
spostamento $\delta x={\tt dst}\,\delta y$ in modo da simulare una
scrittura in corsivo.

\valdef
La spaziatura \`e di 8 unit\`a grafiche; il rapporto tra altezza e 
larghezza \`e 1; l'$\,$inclinazione \`e 0.

\limit
{\tt isp} deve essere compreso tra 7 e 255 (estremi inclusi); una spaziatura 
inferiore a 7 provocherebbe la sovrapposizione dei caratteri.
\par
{\tt ryx} deve essere compreso tra 1/1023 e 1023; limiti cos{\'\i} ampi
in realt\`a non hanno senso, e sono stabiliti solo per ragioni di
consistenza interna della libreria, in particolare della codifica sul
file grafico. Di fatto, ha senso solo far uso di fattori relativamente
piccoli.
\par
{\tt dst} non deve superare 1023 in valore assoluto; un valore negativo 
significa che il simbolo deve essere inclinato verso sinistra, un valore 
positivo provoca un'$\,$inclinazione verso destra (come per il corsivo 
abituale). Limiti cos{\'\i} ampi in realt\`a 
non hanno senso, e sono stabiliti solo per ragioni di consistenza 
interna della libreria, in particolare della codifica sul file grafico. 
Di fatto, ha senso solo far uso di valori relativamente piccoli: si noti 
che un valore 1 provoca gi\`a un'$\,$inclinazione di 45 gradi.

\conderr
\errit{LGE\_DEFCAR}Uno dei valori specificati nella chiamata non
rispetta i limiti fissati. Se ${\tt isp}<7$ viene usato~7; se ${\tt
isp}>255$ viene usato~255. Se ${\tt ryx}<(1/1023)$ viene usato~1/1023;
se ${\tt ryx}>1023$ viene usato~1023. Se ${\tt dst}<(-1023)$ viene
usato~-1023; se ${\tt dst}>1023$ viene usato~1023.

