\scheda{deferr}
\tipo{S}
\scopo
Determina l'$\,$azione da compiere in caso di errore. La definizione
\`e permanente.

\ccall
deferr(k,liv,stampa,conta)
int k,liv,stampa,conta;
\endccall

\param
\prm{k}Variabile o costante intera contenente il codice dell'$\,$errore
che si intende definire.
\prm{liv}Variabile o costante intera che determina se l'$\,$errore
deve essere considerato fatale oppure no. Pu\`o assumere i valori:
\paritm{$=0$}l'$\,$errore \`e di tipo WARNING: segnala una situazione
che potrebbe essere anomala, ma non necessariamnte un errore.
\paritm{$=1$}l'$\,$errore \`e soggetto a conteggio; il programma viene
interrotto se l'errore si verifica 10 volte. In questo caso il
conteggio viene abilitato indipendentemente dal valore del parametro
conta, ed il valore corrente del contatore viene azzerato.
\paritm{$=2$}l'errore e' grave, e provoca l'interruzione immediata del
programma.
\paritm{$=3$}l'errore e' fatale, e provoca l'interruzione immediata
del programma. Si veda sotto per la differenza rispetto al caso 2,
errore grave.
\prm{stampa}Variabile o costante intera che controlla la stampa
della segnalazione di errore.
Pu\`o assumere i valori:
\paritm{$<0$}deve essere stampata una segnalazione la prima volta
che l'$\,$errore si verifica;
\paritm{$=0$}non deve essere stampata nessuna segnalazione;
\paritm{$>0$}deve essere stampata una segnalazione ogni volta che l'$\,$errore
si verifica.
\prm{conta}Variabile o costante intera che controlla il conteggio degli errori.
Pu\`o assumere i valori:
\paritm{$=0$}non deve essere mantenuto il conteggio;
\paritm{$>0$}il conteggio deve essere mantenuto.
\valdef
I valori per difetto assegnati a ciascun errore sono elencati
nella tabella degli errori.
\limit
Il codice {\tt k} deve essere uno di quelli previsti dalla tavola degli errori.
Se non lo \`e la chiamata viene ignorata con una segnalazione di
warning.
\par
Un errore fatale non puo' essere declassato.

\note
Gli errori di livell0 2 (errore grave) e 3 (errore fatale) vengono
trattati di fatto allo stesso modo. La sola differenza e' che un
errore fatale non puo' essere declassato ad un livello inferiore da
una chiamata successiva al sottoprogramma deferr. Questo evita il
declassamento di errori che renderebbero comunque inutile continuare
l'esecuzione del programma. Un errore grave puo' invece in ogni caso
essere declassato al livelli di errore soggetto a conteggio o a warning. 

Salvo il caso in cui un errore sia definito fatale, tutte le altre
operazioni di controllo (stampe e conteggi) vengono eseguite solo
se la gestione degli errori \`e abilitata (si veda il sottoprogramma
{\tt unerr})
\par
Il controllo sui messaggi da stampare solo la prima volta viene
reinizializzato dalla chiamata al sottoprogramma. Il messaggio verr\`a
quindi stampato nuovamente se l'$\,$errore si verifica.

