\scheda{defpag}
\tipo{S}
\scopo
Definisce le dimensioni della pagina, in unit\`a grafiche.

\ccall
int defpag(gxmax,gymax);
float gxmax,gymax;
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{gxmax}Variabile o costante reale contenente
l'$\,$estremo superiore consentito per le coordinate
grafico lungo l'$\,$asse $x$.
\prm{gymax}Variabile o costante reale contenente
l'$\,$estremo superiore consentito per le coordinate grafico
lungo l'$\,$asse $y$.

\valdef
Per le versioni interattive i limiti dipendono dal periferico,
in particolare se si tratta di un videografico, e sono indicati
nelle appendici della guida al sistema operativo.
Per la versione non interattiva i limiti sono tra $0$ e $1023$ su
ambedue i lati.

\limit
Il sottoprogramma {\tt defpag} pu\`o essere richiamato solo
immediatamente dopo la chiamata ai sottoprogrammi {\tt
inizio},\ina{Sottoprogramma>inizio} {\tt
pagina}\ina{Sottoprogramma>pagina}  o {\tt
canpag},\ina{Sottoprogramma>canpag}  in quanto non \`e possibile
modificare le dimensioni dell'$\,$area di lavoro a disegno gi\`a
iniziato.
Il limite massimo consentito per le dimensioni della pagina \`e di
$32767$ unit\`a grafiche su ambedue i lati.

\conderr
\errit{LGE\_PAGINA}La chiamata al sottoprogramma {\tt defpag} non segue
immediatamente quella ai sottoprogrammi {\tt inizio}, {\tt pagina} o
{\tt canpag}.
\errit{LGE\_ESTREMIPG}Gli estremi specificati per la pagina non 
rispettano le limitazioni richieste.

\note
La chiamata al sottoprogramma provoca la ridefinizione dell'$\,$area
grafica in modo che coincida con la pagina.

