\scheda{defpun}
\tipo{S}

\scopo
{\corsivo Interattiva:\quad}Determina se il punto deve essere
sostituito da un simbolo centrato. In quest'$\,$ultimo caso permette di
definire il simbolo da usare.
\par\noindent
{\corsivo File grafico:\quad}La chiamata non ha alcun effetto sul file grafico.

\ccall
defpun(isim,dim,rot)
int isim;
float dim,rot;
\endccall

\param
\prm{isim}Variabile o costante intera contenente il numero del simbolo
da usare. Pu\`o assumere il valore:
\paritm{$\le$0}il punto non viene sostituito da un simbolo centrato;
\paritm{$>0$}il punto viene sostituito dal simbolo {\tt isim}.
\prm{dim}Variabile o costante reale contenente la
dimensione del simbolo. Se negativo mantiene la dimensione corrente.
\prm{rot}Variabile o costante reale contenente l'$\,$angolo di
orientamento del simbolo, nelle unit\`a in uso per la misura degli
angoli. Se negativo viene mantenuto il valore corrente.
\valdef
Viene usato il simbolo 1, con dimensione 1 e angolo di rotazione 0.
\limit
{\tt isim} deve essere compreso tra 1 e 255 per identificare un simbolo,
oppure essere negativo o nullo.
\par
{\tt dim} deve essere positivo ed inferiore a 255.
\par
Le dimensioni dei simboli devono essere specificate come fattore di scala
sulle lunghezze, tenendo presente che la dimensione 1 corrisponde
ad un simbolo di circa 6 unit\`a grafiche (la dimensione esatta dipende dal
simbolo scelto).
\conderr
\errit{LGE\_SIMBOLOCENT}Il valore specificato in {\tt isim} non \`e
corretto: il simbolo richiesto non esiste.
\errit{LGE\_DIMCARATT}Le dimensioni specificate per i simboli non sono corrette.

\note
\`E consigliato l'$\,$uso dei primi 31 simboli, che sono stati predisposti
a questo scopo. Tuttavia qualunque carattere \`e utilizzabile come simbolo
centrato. In tal caso la centratura \`e approssimata.
\par
Per quanto riguarda la dimensione dei simboli, \`e in genere
sconsigliato l'$\,$uso di fattori di scala inferiori a 1, in quanto le
dimensioni troppo piccole possono interferire negativamente con la
capacit\`a di risoluzione del periferico.

