\scheda{defris}
\tipo{S}

\scopo
{\corsivo Interattiva:\quad}Determina la modalit\`a di riscalamento del disegno.
\par\noindent
{\corsivo File grafico:\quad}La chiamata non ha alcun effetto sul file grafico.

\ccall
defris(k)
int k;
\endccall

\param
\prm{k}Variabile o costante intera che specifica la modalit\`a
di riscalamento.
Pu\`o assumere i valori:
\paritm{-2}Riscalamento in modo da utilizzare tutta l'$\,$area disponibile,
con fattori di scala indipendenti sui due assi;
\paritm{-1}Riscalamento in modo da utilizzare tutta l'$\,$area disponibile,
con un fattore di scala unico per i due assi;
\paritm{0}Disabilita il riscalamento. Se la dimensione del disegno
supera i limiti fisici viene tagliata la parte non rappresentabile.
\paritm{1}Riscalamento solo se la dimensione del disegno supera i
limiti fisici, con un fattore di scala unico per i due assi;
\paritm{2}Riscalamento solo se la dimensione del disegno supera i
limiti fisici, con fattori di scala indipendenti sui due assi.

\valdef
Il riscalamento viene effettuato solo se la dimensione del disegno
supera i limiti fisici, con un fattore di scala unico per i due assi
({\tt k}=1)

\conderr
\errit{LGE\_RISCALAM}Il parametro {\tt k} non ha uno dei valori previsti.

\note
Il riscalamento pu\`o essere disabilitato al fine di forzare il
rispetto delle dimensioni, tracciando solo la parte effettivamente
visualizzabile. Questa modalit\`a pu\`o essere comoda per ottenere
disegni in scala.

