\scheda{defsim}
\tipo{S}

\scopo
Definisce un simbolo centrato, scelto tra quelli della tavola dei simboli
software, da usare nelle chiamate ai sottoprogrammi di tracciamento
di tali simboli ({\tt grsim}, {\tt utsim}, {\tt simlin}).

\ccall
defsim(isim,dim,rot)
int isim;
float dim,rot;
\endccall

\param
\prm{isim}Variabile o costante intera contenente il numero del simbolo
da usare.
\prm{dim}Variabile o costante reale contenente la dimensione del
simbolo.
\prm{rot}Variabile o costante reale contenente
l'$\,$angolo di orientamento del simbolo, nelle unit\`a in uso
per la misura degli angoli.
\valdef
Viene usato il simbolo 1, con dimensione 1 e angolo di rotazione 0.
\limit
{\tt isim} deve essere compreso tra 1 e 255.
\par
{\tt dim} deve essere positivo ed inferiore a 255.
\par
Le dimensioni dei simboli devono essere specificate come fattore di scala
sulle lunghezze, tenendo presente che la dimensione 1 corrisponde
ad un simbolo di circa 6 unit\`a grafiche (la dimensione esatta dipende dal
simbolo scelto).
\conderr
\errit{LGE\_SIMBOLOCENT}Il valore specificato in {\tt isim} non \`e
corretto: il simbolo richiesto non esiste.
\errit{LGE\_DIMCARATT}Le dimensioni specificate per i simboli non sono corrette.

\note
\`E consigliato l'$\,$uso dei primi 31 simboli, che sono stati predisposti
a questo scopo. Tuttavia qualunque carattere \`e utilizzabile come simbolo
centrato. In tal caso la centratura \`e approssimata.
\par
Per quanto riguarda la dimensione dei simboli,
\`e in genere sconsigliato l'$\,$uso di fattori di scala
inferiori a 1, in quanto le dimensioni troppo piccole possono
interferire negativamente con la capacit\`a di risoluzione del
periferico.

