\scheda{funrea}
\tipo{S}

\scopo
Traccia il grafico di una funzione reale di variabile reale
$y=f(x)$, ad un sol valore, per valori di $x$ compresi nell'$\,$intervallo
({\tt xmin},{\tt xmax}).

\ccall
funrea(f,xmin,xmax,iprec,modo,motr)
float (*f)();
float xmin,xmax;
int iprec,modo,motr[];
\endccall

\param
\prm{f}Nome di un sottoprogramma, che deve
essere scritto dall'$\,$utente, che definisce la funzione. 
\prm{xmin,xmax}Variabili o costanti intere contenenti gli
estremi dell'$\,$intervallo in $x$ per cui deve essere
tracciato il grafico.
\prm{iprec}Variabile o costante intera che fissa la precisione desiderata. 
Pu\`o
assumere valori compresi tra 1 (precisione minima) e 19
(precisione massima).
\prm{modo}Variabile o costante intera che specifica la modalit\`a di
tracciamento.
Pu\`o assumere i valori:
\paritm{$\ge$0}tracciamento a tratto continuo;
\paritm{<0}tratteggio.
\prm{motr}Vettore intero contenente la modalit\`a di tratteggio,
specificata secondo le regole descritte nella scheda del sottoprogramma
{\tt grtra}.
\ina{Sottoprogramma>grtra}
\valdef
La funzione deve essere continua e definita su tutto l'$\,$intervallo 
({\tt xmin},{\tt xmax}).
\par
Le coordinate devono essere lineari, pena la possibilit\`a di un non corretto
funzionamento del controllo sulla precisione del tracciamento,
con risultati non facilmente prevedibili.

\conderr
\errit{LGE\_SISTCOORD}Le coordinate in uso non sono lineari.
\errit{LGE\_PRECISIONE}Il valore specificato per la precisione non \`e
corretto.

