\scheda{inizio}
\tipo{S}
\scopo
{\corsivo Interattiva:\quad}Effettua le operazioni di aggancio del
periferico ed eventuale inizializzazione.
\par\noindent
{\corsivo File grafico:\quad}Effettua le operazioni di apertura e
scrittura di un record di identificazione su file grafico.

\ccall
\#include <stdio.h>
int inizio(k);
FILE *k;
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{k}Puntatore ad una struttura {\tt FILE}, che determina se il file
grafico \`e gi\`a stato assegnato dall'$\,$utente o se deve essere
aperto. Se ${\tt k}=0$ l'apertura del file viene effettuata dalla
libreria. Se ${\tt k}\ne 0$ si assume che {\tt k} sia il puntatore alla
struttura dati di un file gi\`a aperto dall'$\,$utente.

\limit
Se ${\tt k}\ne 0$ l'$\,$utente deve aver provveduto ad aprire il file
grafico con le istruzioni di assegnazione proprie del sistema sotto cui
lavora. Si veda a tal proposito la guida per l'$\,$utente relativa al
proprio sistema operativo. Il sottoprogramma si posiziona comunque 
all'inizio del file; quindi, in caso di file gi\`a utilizzato in 
precedenza dall'$\,$utente, il contenuto viene completamente riscritto.
Se l'$\,$assegnazione non \`e stata
effettuata, le operazioni di scrittura su file provocano errori la
cui gestione dipende dal sistema operativo usato. Il solo controllo 
eseguito dalla libreria \`e la correttezza del posizionamento iniziale.
\par
Il sottoprogramma {\tt inizio} deve essere richiamato una sola volta
prima di qualunque altra chiamata a sottoprogrammi della libreria
\mizar. Il mancato rispetto di questo limite pu\`o causare effetti
imprevedibili sia durante l'$\,$esecuzione del programma
dell'$\,$utente, sia durante l'eventuale $\,$esecuzione
dell'$\,$interprete.

\conderr
\errit{LGE\_INIZIO}Il sottoprogramma {\tt inizio} \`e gi\`a stato richiamato.
\errit{LGE\_OPENFGR}Si \`e verificato un errore durante l'$\,$apertura 
del file grafico.
\errit{LGE\_FGRSEEK}Il sottoprogramma \`e stato richiamato con ${\tt 
k}\ne 0$; per\`o l'$\,$operazione di posizionamento all'$\,$inizio del 
file si \`e conclusa con un errore.

\note
Gli errori controllati dal sottoprogramma sono tutti gravi, e provocano
normalmente l'interruzione dell'$\,$esecuzione. La restituzione del 
codice di errore si ha solo se l'$\,$utente ha disabilitato la gestione 
da parte della libreria.


