\scheda{istogr}
\tipo{F}
\scopo
Traccia un istogramma a partire da una serie di dati.

\ccall
k=istogr(dati,ndati,rdint,nint,imodo,
\qquad\qquad itot,ibuoni,xmin,xmax,ymin,ymax,
\qquad\qquad testx,ntestx,testy,ntesty)
     double dati[];
     int ndati;
     double rdint[];
     int nint;
     int imodo;
     int *itot;
     int *ibuoni;
     double xmin,xmax,ymin,ymax;
     char testx[];
     int ntestx;
     char testy[];
     int ntesty;
\endccall
\val
Restituisce lo stato finale. Normalmente vale 0. 
Se in uscita ISTOGR ha un valore non nullo, significa che 
si \`e verificata una delle situazioni seguenti:

\paritm{$\circ$}{\tt ndati} non \`e positivo, e non \`e stata specificata nessuna 
delle opzioni 1 e 2 (si veda pi\`u avanti la descrizione dl parametro 
imodo);
\paritm{$\circ$}{\tt nint} non \`e positivo;
\paritm{$\circ$}i valori forniti, o calcolati, di {\tt xmin} e 
{\tt xmax} non rispettano la 
condizione {\tt xmin<xmax}.
\prm{dati}Vettore  reale contenente i dati da analizzare.
\prm{ndati}Variabile o costante intera che specifica il numero di dati da 
analizzare; viene usata di fatto come dimensione di {\tt dati}. Se ha valore 0 
o negativo si assume che venga richiesto solo il tracciamento di dati 
precedentemente accumulati.
\prm{rdint}Vettore reale dove vengono memorizzati i valori da usare per il 
tracciamento dell'istogramma. Deve avere dimensione non inferiore a 
{\tt nint}. In uscita contiene i valori calcolati.
\prm{nint}Variabile o costante intera che specifica il numero di
suddivisoni dell'asse $x$ per il tracciamento dell'istogramma. Deve essere 
positivo.
\prm{imodo}Variabile o costante intera che specifica la modalit\`a di
tracciamento dell'istogramma. La tabella che segue elenca le opzioni 
assegnando a ciascuna un valore; il valore finale da assegnare a 
{\tt imodo} si ottiene sommando i valori  relativi alle opzioni scelte.
\paritm{1\ :}Accetta l'area utente cos\`\i\ come \`e definita all'atto della 
chiamata. In questo caso i valori dei parametri {\tt xmin,} {\tt
xmax,} {\tt ymin} e {\tt ymax} 
vengono ignorati, e vengono ignorate anche le opzioni 2, 4 e 8 che seguono. 
In caso contrario gli estremi dell'area utente 
vengono ridefiniti dal sottoprogramma stesso, che chiama il 
sottoprogramma {\tt utarea}.
\paritm{2\ :}Definisce gli estremi in $x$ dell'area utente mediante i parametri
{\tt xmin} e {\tt xmax}. In caso contrario gli estremi vengono calcolati dal
sottoprogramma stesso, scegliendo il minimo ed il massimo dei valori 
in {\tt dati}.
\paritm{4\ :}Definisce gli estremi in $y$ dell'area utente mediante i parametri
{\tt ymin} e {\tt ymax}; in tal caso viene ignorata l'opzione 8 che segue.
In caso contrario gli estremi vengono calcolati dal
sottoprogramma stesso, secondo la specifica dell'opzione 8 che segue.
\paritm{8\ :}Determina gli estremi in $y$ assumendo 0 e 1, oppure 0 e il
massimo dei valori in {\tt rdint}, secondo le specifiche dell'opzione 16 che
segue. In caso contrario l'estremo inferiore viene comunque posto 0, e
l'estremo superiore viene calcolato come il minimo tra 1 (o il numero
totale di dati, come spiegato per l'opzione 16) ed il massimo dei valori
in {\tt rdint} moltiplicato per 1.05. 
\paritm{16\ :}Prima del tracciamento rinormalizza i valori in {\tt rdint}
dividendoli per il numero totale di dati, ossia {\tt itot} oppure {\tt
ibuoni},
secondo le specifiche dell'opzione 32; In tal caso {\tt rdint} contiene la
frazione di dati che cadono in ciascun intervallo. In caso contrario
{\tt rdint} contiene il numero di dati che cadono in ciascun intervallo. 
\paritm{32\ :}Usa {\tt ibuoni} come numero totale di dati, escludendo dalla statistica 
quelli che non cadono all'interno dell'intervallo ({\tt xmin},{\tt xmax}).
\paritm{64\ :}Omette il tracciamento dell'istogramma.
In questo caso il sottoprogramma chiamante ha a sua 
disposizione i valori calcolati in {\tt rdint}, e le opzioni che seguono 
vengono tutte ignorate. In caso contrario si procede al tracciamento.
\paritm{128\ :}Omette il tracciamento di assi, scala ed etichette. In questo
caso i parametri {\tt testox}, {\tt ntestox}, {\tt testoy} e {\tt
ntestoy}  vengono ignorati. In
caso contrario viene chiamato il sottoprogramma {\tt quadro} o {\tt
quadre} (si veda l'opzione seguente) per il tracciamento degli assi 
e delle etichette. 
\paritm{256\ :}Per il tracciamento di assi, scala ed etichette chiama il 
sottoprogramma {\tt quadre} anzich\'e {\tt quadro}; in tal caso la
scala sull'asse $y$ 
viene scritta orizzontalmente anzich\'e verticalmente.
\paritm{512\ :}Non azzera i contatori in {\tt itot}, {\tt ibuoni} ed
{\tt rdati} prima di 
procedere all'analisi; in tal caso vengono accumulati i dati relativi a 
diverse chiamate prima di procedere al tracciamento.
\prm{\tt itot}Variabile intera che restituisce il numero totale di dati 
analizzati. Viene normalmente restituito un valore positivo. 
\prm{\tt ibuoni}Variabile intera che restituisce il numero totale di dati che 
cadono nell'intervallo ({\tt xmin},{\tt xmax}) specificato, e quindi effettivamente 
usati per il tracciamento.
\prm{\tt xmin}
\prm{\tt xmax}
\prm{\tt ymin}
\prm{\tt ymax}Variabili o costanti intere che specificano gli estremi degli 
assi. L'uso di tali valori \`e controllato dalle opzioni specificate in 
{\tt imodo}.
\prm{\tt testx}
\prm{\tt ntestx}
\prm{\tt testy}
\prm{\tt ntesty}Specificano le etichette per gli assi; si veda la descrizione 
nella scheda del sottoprogramma {\tt quadro}.
\conderr
\errit{IST\_WRNGNINT}Il valore di {\tt nint} non \`e positivo.  IL
numero di intervalli in un istogramma lo deve essere.

\errit{IST\_ARUTNONDEF}L'$\,$utente ha dato un valore non positivo a
{\tt ndati}.  Questo significa che intende chiamare il sottoprogramma
solo per procedere al tracciamento.  Ma in questo caso deve
specificare come clacolare l'$\,$area utente mediante i valori 1 e 2
in {\tt imodo}, che sono ambedue azzerati.

\errit{IST\_WRXMINMAX}Dalle specifiche date dall'$\,$utente risultano
dei valori inconsisteni per ({\tt xmin},{\tt xmax}),  Vi sono due
possibilit\`a: l'$\,$utente ha assegnato esplicitamente i valori come
parametri, ma risulta {\tt xmin}$ge${\tt xmax}, oppure l'$\,$utente ha
chiesto che vengano determinati direttamente dai dati, ma i valori nel
vettore {\tt dati} sono tutti eguali.

\note
Le opzioni 64 e 512 hanno lo scopo di permettere l'analisi di dati che, 
per qualche ragione, non sono tutti disponibili contemporaneamente in 
memoria. In tal caso \`e possibile richiamare pi\`u volte il 
sottoprogramma, e richiedere il tracciamento solo ad analisi avvenuta. 
Devono essere per\`o rispettate alcune condizioni di 
consistenza tra le chiamate. Precisamente: gli estremi ({\tt xmin}{\tt
,xmax}) non 
possono essere determinati direttamente dal sottoprogramma, quindi 
devono essere forniti o tramite la definizione dell'area utente (opzione 
1) oppure direttamente in {\tt xmin} e {\tt xmax} all'atto della 
chiamata, (opzione 2); il valore di {\tt nint} non deve 
cambiare nel corso delle diverse chiamate; il vettore {\tt rdint} e le 
variabili {\tt itot} e {\tt ibuoni} non devono essere modificate n\'e cambiate, 
perche il sottoprogramma ne fa uso per mantenere memoria dei dati 
gi\`a elaborati; l'opzione 16 pu\`o essere specificata solo 
all'ultima chiamata, quando si procede al tracciamento effettivo. In 
pratica: si effettua una prima chiamata con {\tt imodo=1+64} (estremi tramite 
area utente) o {\tt imodo=2+64} (estremi specificati in {\tt xmin} e
{\tt xmax}), e vengono 
azzerati i contatori prima di analizzare i dati; le 
chiamate successive specificheranno rispettivamente {\tt imodo=1+64+512} o 
{\tt imodo=2+64+512}, per inibire l'azzeramento dei contatori; l'ultima chiamata 
avr\`a {\tt imodo=1+512} oppure {\tt imodo=2+512}, ed eventualmente altre opzioni.
\hfill\break\noindent
Si tenga per\`o ben presente che ogni chiamata al sottoprogramma effettua 
tutti i controlli e ricalcola i coefficienti necessari per l'analisi dei 
dati, quindi \`e comunque consigliabile, per motivi di tempo, minimizzare 
il numero di chiamate.
