\scheda{numint}
\tipo{S}
\scopo
Scrive un numero intero nella posizione e con la dimensione e angolo di 
rotazione indicati.

\ccall
int numint(gx,gy,ipos,num,dim,rot,ncar);
float gx,gy;
int ipos;
long int num;
float dim,rot;
int *ncar;
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{gx,gy}Variabili o costanti intere contenenti la
posizione, in coordinate grafico, rispetto alla quale
deve essere allineato il numero.
\prm{ipos}Variabile o costante intera contenente la
modalit\`a di allineamento del numero rispetto
al punto {\tt (gx,gy)}. Pu\`o assumere i valori:
\paritm{$\lt 0$\ :}il numero viene scritto alla sinistra del punto; eventuali
colonne di numeri risultano allineate a destra;
\paritm{$=0$\ :}il numero viene centrato rispetto al punto;
\paritm{$\gt $0\ :}il numero viene scritto alla destra del punto;
eventuali colonne di numeri risultano allineate a sinistra.
\prm{num}Variabile o costante intera contenente il
numero da scrivere.
\prm{dim}Variabile o costante reale contenente la
dimensione dei caratteri.
\prm{rot}Variabile o costante reale contenente
l'$\,$angolo di rotazione della scritta, nelle $\,$unit\`a
correnti per la misura degli angoli.
\prm{ncar}Variabile intera in uscita: restituisce il numero di caratteri
effettivamente scritti.

\limit
La dimensione dei caratteri \`e soggetta alle limitazioni valide per le 
stringhe alfanumeriche. Si veda la scheda del sottoprogramma {\tt defdrs}.

\conderr
\errit{LGE\_STRALF}La posizione iniziale della stringa di caratteri \`e
esterna alla pagina.
\errit{LGE\_DIMCARATT}La dimensione specificata per i caratteri non 
rispetta le limitazioni richieste.

