\scheda{numrea}
\tipo{S}
\scopo
Scrive un numero reale nella posizione e con la dimensione e angolo di 
rotazione indicati.

\ccall
int numrea(gx,gy,ipos,rnum,ndec,dim,rot,ncar)
float gx,gy;
int ipos;
float rnum;
int ndec;
float dim,rot;
int *ncar;
\endccall

\val In caso di esecuzione corretta viene restituito zero; in caso di
errore viene restituito uno dei codici riportati sotto.

\param
\prm{gx,gy}Variabili o costanti reali contenenti la
posizione, in coordinate grafico, rispetto alla quale
deve essere allineato il numero.
\prm{ipos}Variabile o costante intera contenente la
modalit\`a di allineamento del numero rispetto
al punto {\tt (gx,gy)}. Pu\`o assumere i valori:
\paritm{$\lt 0$\ :}il numero viene scritto alla sinistra del punto; eventuali
colonne di numeri risultano allineate a destra;
\paritm{$=0$\ :}il numero viene centrato rispetto al punto;
\paritm{$\gt $0\ :}il numero viene scritto alla destra del punto;
eventuali colonne di numeri risultano allineate a sinistra.
\prm{rnum}Variabile o costante reale contenente il
numero da scrivere.
\prm{ndec}Variabile o costante intera contenente la
modalit\`a di scrittura: se positivo o nullo specifica il numero
di cifre decimali desiderate in formato {\tt f} (ad esempio, $0.61803$); 
se negativo il numero di cifre 
significative in formato {\tt e} (ad esempio, $6.1803\times 10^{-1}$).
\prm{dim}Variabile o costante reale contenente la
dimensione dei caratteri.
\prm{rot}Variabile o costante reale contenente
l'$\,$angolo di rotazione della scritta, nell'$\,$unit\`a
corrente per la misura degli angoli.
\prm{ncar}Variabile intera in uscita: restituisce il numero di caratteri
effettivamente scritti.

\limit
La dimensione dei caratteri \`e soggetta alle limitazioni valide per le 
stringhe alfanumeriche. Si veda la scheda del sottoprogramma {\tt defdrs}.

\conderr
\errit{LGE\_STRALF}La posizione iniziale della stringa di caratteri \`e
esterna alla pagina.
\errit{LGE\_DIMCARATT}La dimensione specificata per i caratteri non 
rispetta le limitazioni richieste.

\note
Se viene richiesto il formato {\tt f}, viene eseguito un controllo per
stabilire se il numero di cifre scritte supera la precisione della
macchina. In tal caso si passa automaticamente al formato {\tt e}.

