\scheda{stralf}
\tipo{S}
\scopo
Scrive una stringa di caratteri alfanumerici, specificandone dimensione 
e angolo di rotazione.

\ccall
int stralf(istr,ncar,dim,rot);
unsigned char istr[];
int ncar;
float dim,rot;
\endccall

\param
\prm{istr}Stringa di caratteri contenente la scritta.
\prm{ncar}Variabile o costante intera contenente il numero di caratteri
della stringa {\tt istr}.
\prm{dim}Variabile o costante reale contenente la dimensione dei
caratteri.
\prm{rot}Variabile o costante reale contenente l'$\,$angolo di
rotazione della stringa rispetto alla linea orizzontale (asse $x$),
nella unit\`a di misura degli angoli in uso.

\limit
La stringa non deve contenere il carattere {\tt NUL}, cio\`e il
carattere ASCII di valore 0. Se tale carattere viene incontrato, la
stringa viene considerata chiusa. Questo fatto permette di evitare di
contare il numero dei caratteri della stringa: a tal fine basta porre
un {\tt NUL} come ultimo carattere ed assegnare ad {\tt ncar} un valore
pi\'u alto di quello esatto.

La stringa viene scritta a partire dalla posizione corrente della penna.
A tal fine la posizione iniziale deve essere entro la pagina. Se ci\`o
non avviene, la chiamata \`e ignorata.

Il valore di {\tt dim} deve rispettare le limitazioni descritte nella 
scheda del sottoprogramma {\tt defdrs}.

\conderr
\errit{LGE\_STRALF}La posizione iniziale della stringa di caratteri \`e
esterna alla pagina.
\errit{LGE\_DIMCARATT}La dimensione specificata per i caratteri non 
rispetta le limitazioni richieste.

\note
La dimensione dei caratteri deve essere specificata come fattore di
scala sulle lunghezze, ricordando che la dimensione 1 corrisponde ad un
carattere che occupa normalmente un rettangolo di $6\times 10$ unit\`a
grafiche, con qualche eccezione per i caratteri che scendono sotto la
linea di scrittura o per alcuni simboli speciali. In ogni caso dopo il
tracciamento la penna viene posizionata 8 unit\`a grafiche a destra del
punto iniziale, lungo la linea di scrittura, in modo da consentire il
tracciamento del carattere successivo. Si osservi anche che la forma del
carattere e la spaziatura tra caratteri possono essere modificate 
mediante il sottoprogramma {\tt defcar}.\ina{Sottoprogramma>defcar}

La stringa pu\`o contenere qualunque carattere rappresentabile su 8
bit. I primi 32 caratteri (codice ottale tra 0 e 37, 0 e 31 decimale)
agiscono come caratteri di controllo, nel modo spiegato nel capitolo
dedicato ai caratteri. In particolare il carattere {\tt NUL} (codice
ASCII 0) agisce come terminatore della stringa.

La scrittura di caratteri software provoca lo spostamento della penna.
Si deve quindi procedere ad un riposizionamento (mediante i
sottoprogrammi di controllo della penna) prima di ricominciare a
tracciare. La posizione finale della penna \`e prevedibile solo a
prezzo di lunghi calcoli che renderebbero inefficiente il programma.

La penna si deve intendere posizionata solo in caso di chiamate
consecutive al sottoprogramma {\tt stralf}, senza altre chiamate intermedie.
In  tal caso le stringhe vengono scritte successivamente, e viene solo
annullato l'$\,$effetto dei caratteri di controllo sul livello di
scrittura, la dimensione dei caratteri, l'$\,$alfabeto.

