\scheda{utarea}
\tipo{S}
\scopo
Definisce gli estremi dell'$\,$area utente nelle coordinate scelte
dall'$\,$utente stesso. In caso di coordinate polari {\tt xmin,xmax} si 
riferiscono al raggio, e {\tt ymin,ymax} si riferiscono all'$\,$angolo.

\ccall
int utarea(xmin,xmax,ymin,ymax)
\endccall

\val In caso di esecuzione corretta viene restituito zero; in caso di
errore viene restituito uno dei codici riportati sotto.

\param
\prm{xmin}
\prm{xmax}Variabili o costanti reale contenenti gli estremi, 
in coordinate utente, lungo l'$\,$asse $x$.
\prm{ymin}
\prm{ymax}Variabili o costanti reale contenenti gli estremi, 
in coordinate utente, lungo l'$\,$asse $y$.

\valdef
L'$\,$area utente coincide con la pagina, e le coordinate utente coincidono
con le coordinate grafico. Le chiamate ai sottoprogrammi {\tt grarea} e 
{\tt defpag} non modificano gli estremi dell'$\,$area utente.

\limit
Devono essere verificate le condizioni ${\tt xmin}<{\tt xmax}$, ${\tt
ymin}<{\tt ymax}$. Inoltre devono essere rispettate le limitazioni
dovute al sistema di coordinate in uso: gli estremi su assi logaritmici
devono essere ambedue positivi; in caso di coordinate polari deve essere
${\tt xmin}\ge 0$.

\conderr
\errit{LGE\_ESTREMIARUT}Non sono rispettate le condizioni di ordinamento
sugli estremi.

\note
Il sottoprogramma controlla solo le condizioni di ordinamento sugli
estremi, e non la consistenza col sistema di coordinate in uso. Questo
in quanto la definizione del sistema di coordinate 
(sottoprogramma {\tt coord})\ina{Sottoprogramma>coord} potrebbe avvenire
successivamente a quella dell'$\,$area utente.
