\scheda{utcer}
\tipo{S}

\scopo
Traccia una circonferenza in coordinate utente, centrata nella posizione 
corrente della penna.

\ccall
utcer(raggio,modo,motr)
float raggio;
int modo,motr[];
\endccall

\param
\prm{raggio}Variabile o costante reale che specifica il raggio della 
circonferenza, nelle stesse unit\`a della scala.
\prm{modo}Variabile o costante intera che specifica la modalit\`a di 
tracciamento. Pu\`o assumere i valori:
\paritm{$\ge$0}tracciamento a linea continua;
\paritm{$<0$}linea tratteggiata.
\prm{motr}Vettore intero di al pi\'u 11 elementi, che specifica la
modalit\`a di tratteggio: si veda la scheda del sottoprogramma {\tt
grtra}.

\limit
Il sottoprogramma pu\`o essere usato solo con coordinate lineari. Per il 
tracciamento di circonferenze in coordinate polari o logaritmiche si 
faccia uso del sottoprogramma {\tt grcer}.
\par\blankq
Il sottoprogramma non tiene conto di deformazioni dovute alle differenze 
di scala tra gli assi; in altre parole, viene semplicemente tracciata la 
curva di equazione $x=x_0+r \cos t$, $y=y_0+r \sin t$, per $t$ che percorre 
l'$\,$angolo giro. Di conseguenza, salvo scelte oculate dei fattori di 
scala, la curva risultante sar\`a, nella maggior parte dei casi, 
un'$\,$ellisse. Se si vuole la certezza che la curva sia un cerchio, si usi 
il sottoprogramma {\tt grcer}.

\conderr
\errit{LGE\_SISTCOORD}Le coordinate in uso non sono lineari. La
chiamata viene ignorata.

\note
Alla fine del tracciamento la penna viene riposizionata al punto 
iniziale (al centro della circonferenza).

