\scheda{utellisse}
\tipo{S}

\scopo
Traccia un\:ellisse in coordinate utente, centrata nella posizione 
corrente della penna, con semiasse maggiore, eccentricit\`a e angolo
del pericentro assegnati. 

\ccall
utellisse(double sas,double ecc, double psi,int modo,int *motr)
\endccall

\param
\prm{sas}Variabile o costante reale che specifica il semiasse maggiore
dell\:ellisse, nelle stesse unit\`a della scala.
\prm{ecc}Variabile o costante reale che specifica l\:eccentricit\`e
dell\:ellisse. 
\prm{psi}Variabile o costante reale che specifica ls direzione del
pericentro nell\:unit\`a corrente degli angoli, misurata rispetto alla
direzione positiva dell\:asse orizzontale.
\prm{modo}Variabile o costante intera che specifica la modalit\`a di 
tracciamento. Pu\`o assumere i valori:
\paritm{$\ge$0}tracciamento a linea continua;
\paritm{$<0$}linea tratteggiata.
\prm{motr}Vettore intero di al pi\'u 11 elementi, che specifica la
modalit\`a di tratteggio: si veda la scheda del sottoprogramma {\tt
grtra}.

\limit
Il sottoprogramma pu\`o essere usato solo con coordinate lineari. Per il 
tracciamento di ellissi in coordinate polari o logaritmiche si 
faccia uso del sottoprogramma {\tt grellisse}.
\par\blankq
Il sottoprogramma non tiene conto di deformazioni dovute alle
differenze di scala tra gli assi; in altre parole, viene semplicemente
tracciata la curva di equazione $x=x_0+a(1-e\cos u)$,
$y=y_0+a\sqrt{1-e^2}\sin t$, per $t$ che percorre l'$\,$angolo
giro. Di conseguenza, salvo scelte oculate dei fattori di scala, la
curva risultante sar\`a, nella maggior parte dei casi,
distorta. 

\conderr
\errit{LGE\_SISTCOORD}Le coordinate in uso non sono lineari. La
chiamata viene ignorata.

\errit{LGE\_WRONGECC}L'eccentricit\`a non rispetta i limiti $0\le e\lt
1$. La chiamata viene ignorata.

\note
Alla fine del tracciamento la penna viene riposizionata al punto 
iniziale (al centro della circonferenza).

