\scheda{utmov}
\tipo{S}

\scopo
Muove la penna, senza scrivere, fino al punto di coordinate utente {\tt
(x,y)}. In caso di coordinate polari {\tt x} corrisponde al raggio,
{\tt y} all'$\,$angolo.

\ccall
int utmov(x,y);
float x,y;
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{x,y}Variabili o costanti reali contenenti le
coordinate utente del punto di arrivo della penna.

\limit
Le coordinate utente devono rispettare le limitazioni del sistema
di coordinate in uso: le coordinate su assi logaritmici devono essere
positive, il raggio in coordinate polari deve essere positivo o nullo.

\conderr
\errit{LGE\_ESTRLOG}\`E stato richiesto l'$\,$uso di coordinate 
logaritmiche su un asse, ma \`e stato specificato un estremo non 
positivo per l'$\,$area utente.
\errit{LGE\_ESTRAGGIO}\`E stato richiesto l'$\,$uso di coordinate polari,
ma \`e stato specificato un estremo negativo per il raggio.
\errit{LGE\_COORLOG}Una coordinata corrispondente ad un asse logaritmico 
ha un valore non positivo.
\errit{LGE\_RAGNEG}In coordinate polari, il raggio ha un valore negativo.
\errit{LGE\_UTFUORIARUT}Il punto specificato \`e esterno all'$\,$area utente.

\note
Lo spostamento effettivo della penna avviene solo se il punto di arrivo
\`e interno all'$\,$area utente. In caso contrario, la posizione della penna
viene trattata come posizione virtuale, ed in tracciamenti successivi
vengono tagliate tutte le parti di disegno esterne all'$\,$area utente.
L'$\,$aggiornamento delle coordinate virtuali viene ignorato qualora una
delle coordinate {\tt x,y} specificate abbia valori inconsistenti col 
sistema di coordinate in uso. Il risultato in questo caso \`e 
imprevedibile.

La libreria {\mizar} effettua il controllo di consistenza degli estremi
dell'$\,$area utente al momento della prima richiesta di conversione di
coordinate, e non all'$\,$atto della definizione dell'$\,$area utente.
Per questo motivo gli errori {\tt LGE\_ESTRLOG} e {\tt LGE\_ESTRAGGIO}
possono essere segnalati dal sottoprogramma. Questi errori sono
normalmente considerati gravi, e provocano l'$\,$interruzione
dell'$\,$esecuzione. Se la gestione degli errori \`e disabilitata, e si
verifica uno di questi errori, tutte le operazioni di tracciamento
vengono omesse.

