/* <assisc> 
Sottoprogrammi per la gestione di 
   -	assi in scala lineare
   -	assi in scala logaritmica
*/
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
struct lgbcas {			/* Blocco comune a tutti gli assi */
  double gxinas;                /* Coordinate grafico degli estremi dell'asse */
  double gyinas;
  double gxfias;
  double gyfias;
  double dlunas;	        /* Lunghezza dell'asse in unita' grafiche */
  double coas;			/* Coseni direttori di proiezione in  */
  double seas;			/* coordinate grafico */
  double rotas;	                /* Angolo dell'asse rispetto all'asse x della pagina */
  double scinas;		/* Estremi della scala */
  double scfias;
  double slunas;		/* Lunghezza della scala in unita' della scala stessa */
  double dscas;	                /* Intervallo tra due tratti nelle unita' della scala */
  double rotsc;		        /* Angolo di rotazione per etichette */
  double coefas;		/* Coeff. da unita' grafiche a unita' della scala */
  double dimsc;		        /* Dimensione dei caratteri per etichette */
  int kdec;			/* Numero di cifre decimali da scrivere */
  int nscas[4];
  int latas[2];
} lgbcas={0};
/*  */
struct lgbcsl {			/* Blocco comune per assi logaritmici */
  double alinas;		/* Logaritmi decimali degli estremi della scala */
  double alfias;
  double alunas;
  double xscl[9];		/* Differenza tra i Log degli estremi */
  double xtrl[15];
  int kscfl[5];
  int ktrfl[6];
  int kluntr[15];
  int psc[5][4];
} lgbcsl={0.,0.,0.,
	  {0.0000000,0.3010300,0.4771213,0.6020600,0.6989700,
	   0.7781513,0.8450980,0.9030900,0.9542425},
	  {0.0000000,0.1760913,0.3010300,0.3979400,0.4771213,
	   0.5440680,0.6020600,0.6532125,0.6989700,0.7403627,
	   0.7781513,0.8129134,0.8450980,0.9030900,0.9542425},
	  {01,	013,	0113,	0257,	0777},
	  {01,	072525,	072527,	072537,	072777,	077777},
	  {0,2,1,2,1,2,1,2,1,2,1,2,1,1,1},
	  {{2,1,0,4},
	   {5,1,0,5},
	   {10,5,1,10},
	   {10,5,1,5},
	   {20,2,1,10}}
};
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
#define INT(x) (x)-fmod((x),1.)
#define ASSI_EPS 1.e-4
				/* Il parametro seguente determina quando la scala 
				   logaritmica deve ricorrere alla suddivisione 
				   lineare sugli esponenti */
#define SCALA_EXP 15.
#define SCALA_LOG 1.
/*  */
/* Sottoprogramma lgtrlg */
VOID lgtrlg()
{  
  double dgx[3],dgy[3];
  double b,c,cfas,gx0,gy0;
  int j;
  lgbc2d.kgrut=MIZ_GRAFPAG;
				/* Calcola lunghezza dei trattini */
  b= -lgbcas.latas[0];
  if(b==0.) b=1.;
  b*=lgbcas.dimsc;
  c=9.;
  for(j=0;j<3;j++) {
    dgx[j]= -b*c*lgbcas.seas;
    dgy[j]=b*c*lgbcas.coas;
    c-=3.;
  }
  cfas=ABS(lgbcas.coefas);
  if(lgbcsl.alunas < 0.) cfas= -cfas;
				/* Determina il tipo di asse da tracciare */
  if(lgbcas.nscas[0] > 0) {	/* Parametri calcolati con suddivisione lineare, 
				   eventualmente sull'esponente. */
    double tmplunas;
    tmplunas = ABS(lgbcsl.alunas);
    if(tmplunas >= SCALA_EXP) {	/* Suddivisione lineare sugli esponenti */
      double a,c0,d0,dc,gx,gy;
      int i,k;
      a=lgbcas.dscas*(MAX(lgbcas.nscas[0],lgbcas.nscas[3]));
      c=lgbcsl.alinas/a;
      c0=a*(INT(c));
      if(c0<=0.) c0-=a;
      d0=(c0-lgbcsl.alinas)/cfas;
      if((ABS(d0)) < (ASSI_EPS*lgbcas.dlunas)) d0=0.;
      lgplot(lgbcas.gxinas,lgbcas.gyinas,MIZ_MOV);
      dc=ABS(lgbcas.dscas);
      if(lgbcsl.alunas<0.) dc= -dc;
      k=lgbcsl.alunas/lgbcas.dscas+10.5;
      for(i=0;i<=k;i++) {
	if(d0>=0.) {
	  if(d0>lgbcas.dlunas) break;
	  gx=lgbcas.gxinas+lgbcas.coas*d0;
	  gy=lgbcas.gyinas+lgbcas.seas*d0;
	  lgplot(gx,gy,MIZ_SEG);
	  for(j=0;j<3;j++) {
	    if((i%lgbcas.nscas[j])==0) break;
	  }
	  lgplot(gx+dgx[j],gy+dgy[j],MIZ_SEG);
	  if(lgbcas.latas[0]==0) lgplot(gx-dgx[j],gy-dgy[j],MIZ_SEG);
	  lgplot(gx,gy,MIZ_SEG);
	}
	d0=(c0+(i+1)*dc-lgbcsl.alinas)/cfas;
	if((ABS(d0)) < ASSI_EPS*lgbcas.dlunas) d0=0.;
	if((ABS(d0-lgbcas.dlunas))<ASSI_EPS*lgbcas.dlunas) d0=lgbcas.dlunas;
      }
      lgplot(lgbcas.gxfias,lgbcas.gyfias,MIZ_SEG);
    }
    else {			/* Asse praticamente lineare */
    double a,c0,d0,dc,gx,gy;
    int i,k;
      a=lgbcas.dscas*(MAX(lgbcas.nscas[0],lgbcas.nscas[3]));
      c=lgbcas.scinas/a;
      c0=a*(INT(c));
      if(c0<=0.) c0+=a;
      d0=(log10(c0)-lgbcsl.alinas)/cfas;
      if((ABS(d0))<(ASSI_EPS*lgbcas.dlunas)) d0=0.;
      lgplot(lgbcas.gxinas,lgbcas.gyinas,MIZ_MOV);
      dc=ABS(lgbcas.dscas);
      if(lgbcsl.alunas<0.) dc= -dc;
      k=lgbcas.slunas/lgbcas.dscas+10.5;
      for(i=0;i<k;i++) {
	if(d0>=0.) {
	  if(d0>lgbcas.dlunas) break;
	  gx=lgbcas.gxinas+lgbcas.coas*d0;
	  gy=lgbcas.gyinas+lgbcas.seas*d0;
	  lgplot(gx,gy,MIZ_SEG);
	  for(j=0;j<3;j++) {
	    if((i%lgbcas.nscas[j])==0) break;
	  }
	  lgplot(gx+dgx[j],gy+dgy[j],MIZ_SEG);
	  if(lgbcas.latas[0]==0) lgplot(gx-dgx[j],gy-dgy[j],MIZ_SEG);
	  lgplot(gx,gy,MIZ_SEG);
	}
	d0=(log10(c0+(i+1)*dc)-lgbcsl.alinas)/cfas;
	if((ABS(d0))<ASSI_EPS*lgbcas.dlunas) d0=0.;
	if((ABS(d0-lgbcas.dlunas))<ASSI_EPS*lgbcas.dlunas) d0=lgbcas.dlunas;
      }
      lgplot(lgbcas.gxfias,lgbcas.gyfias,MIZ_SEG);
    }
  }
  else {			/* Asse logaritmico */
    int jkf,l,i,k,ii,kfl,kk;
    double gx,gy,gx1,gy1,x,x0,co,se;
    jkf= -lgbcas.nscas[0];
    if(lgbcsl.alunas>=0.) {
      gx0=lgbcas.gxinas;
      gy0=lgbcas.gyinas;
      l=lgbcas.nscas[1];
      gx1=lgbcas.gxfias;
      gy1=lgbcas.gyfias;
      x0=lgbcsl.alinas;
      co=lgbcas.coas;
      se=lgbcas.seas;
    }
    else {
      gx0=lgbcas.gxfias;
      gy0=lgbcas.gyfias;
      l=lgbcas.nscas[2];
      gx1=lgbcas.gxinas;
      gy1=lgbcas.gyinas;
      x0=lgbcsl.alfias;
      co= -lgbcas.coas;
      se= -lgbcas.seas;
    }
    lgplot(gx0,gy0,MIZ_MOV);
    k=(ABS(lgbcas.nscas[2]-lgbcas.nscas[1]))+2;
    for(i=0;i<=k;i++) {
      kfl=lgbcsl.ktrfl[jkf];
      for(ii=0;ii<15;ii++) {
	kk=kfl%2;
	kfl/=2;
	if(kk!=0) {
	  x=(lgbcsl.xtrl[ii]+l-x0)/lgbcas.coefas;
	  if((ABS(x))<ASSI_EPS*lgbcas.dlunas) x=0.;
	  if((ABS(x-lgbcas.dlunas))<ASSI_EPS*lgbcas.dlunas) 
	    x=lgbcas.dlunas;
	  if((x>=0.)&&(x<=lgbcas.dlunas)) {
	    gx=gx0+co*x;
	    gy=gy0+se*x;
	    lgplot(gx,gy,MIZ_SEG);
	    j=lgbcsl.kluntr[ii];
	    lgplot(gx+dgx[j],gy+dgy[j],MIZ_SEG);
	    if(lgbcas.latas[0]==0) 
	      lgplot(gx-dgx[j],gy-dgy[j],MIZ_SEG);
	    lgplot(gx,gy,MIZ_SEG);
	  }
	}
      }
      l++;
    }
    lgplot(gx1,gy1,MIZ_SEG);
  }
  return;
}
/* Sottoprogramma lgsclg */
VOID lgsclg(testo,ntesto)
     CHAR testo[];
     int ntesto;
{  
  double b, dgx, dgy, cfas, gx=0., gy=0.;
  int ib=24;
  int kp,ncar;
  lgbc2d.kgrut=MIZ_GRAFPAG;
				/* Fissa la posizione della scala rispetto all'asse */
  b=ABS(ib);
  if(lgbcas.latas[1]<0) b= -b;
  b=(b+5.)*lgbcas.dimsc;
  dgx=b*lgbcas.seas;
  dgy= -b*lgbcas.coas;
  lgbcas.rotsc=lgbcas.rotas;
  if(lgbcas.latas[1]!=0) {
    kp=lgbcas.latas[1]/2;
    if(kp!=0) lgbcas.rotsc-=.25*lgbccs.angiro;
    cfas=ABS(lgbcas.coefas);
    if(lgbcsl.alunas<0.) cfas= -cfas;
				/* Stabilisce il tipo di asse da tracciare */
    if(lgbcas.nscas[0]>0) {	/* Parametri calcolati con suddivisione lineare, 
				   eventualmente sull'esponente. */
      double tmplunas;
      tmplunas = ABS(lgbcsl.alunas);
      if(tmplunas >= SCALA_EXP) {	/* Suddivisione lineare sugli esponenti */
	double a,c,c0,d0,s;
	int j=0;
	int k,km,i;
	a=lgbcas.dscas*lgbcas.nscas[3];
	c=(MIN(lgbcsl.alinas,lgbcsl.alfias))/a;
	c0=(INT(c))*a;
 	if(c0<=0.) c0-=a;
	k=lgbcsl.alunas/a+2.5;
	km=k/2;
	for(i=0;i<k;i++) {
	  s=c0+i*a;
	  d0=(s-lgbcsl.alinas)/cfas;
	  if((ABS(d0))<ASSI_EPS*lgbcas.dlunas) d0=0.;
	  if((ABS(d0-lgbcas.dlunas))<ASSI_EPS*lgbcas.dlunas) 
	    d0=lgbcas.dlunas;
	  if((d0>=0.) && (d0<=lgbcas.dlunas)) {
	    gx=lgbcas.gxinas+d0*lgbcas.coas+dgx;
	    gy=lgbcas.gyinas+d0*lgbcas.seas+dgy;
	    numesp(gx,gy,kp,10,(int) s,lgbcas.dimsc,lgbcas.rotsc,&ncar);
	    j=MAX(j,ncar);
	  }
	  if(i==km) lgwlab(gx,gy,dgx,dgy,j,kp,testo,ntesto);
	}
      }
      else {			/* Scala praticamente lineare */
	double a,c,c0,d0,s;
	int j=0;
	int k,km,i;
	a=lgbcas.dscas*lgbcas.nscas[3];
	c=(MIN(lgbcas.scinas,lgbcas.scfias))/a;
	c0=(INT(c))*a;
	if(c0<=0.) c0+=a;
	k=lgbcas.slunas/a+2.5;
	km=k/2;
	for(i=0;i<k;i++) {
	  s=c0+i*a;
	  d0=(log10(s)-lgbcsl.alinas)/cfas;
	  if((ABS(d0))<ASSI_EPS*lgbcas.dlunas) d0=0.;
	  if((ABS(d0-lgbcas.dlunas))<ASSI_EPS*lgbcas.dlunas) 
	    d0=lgbcas.dlunas;
	  if((d0>=0.) && (d0<=lgbcas.dlunas)) {
	    gx=lgbcas.gxinas+d0*lgbcas.coas+dgx;
	    gy=lgbcas.gyinas+d0*lgbcas.seas+dgy;
	    numrea(gx,gy,kp,s,lgbcas.kdec,lgbcas.dimsc,lgbcas.rotsc,&ncar);
	    j=MAX(j,ncar);
	  }
	  if(i==km) lgwlab(gx,gy,dgx,dgy,j,kp,testo,ntesto);
	}
      }
    }
    else if(lgbcas.nscas[0]==0) {
      int k,km,l,i;
      int j=0;
      double x;
      /* Scala solo sulle decadi */
      k=(ABS(lgbcas.nscas[2]-lgbcas.nscas[1]))/lgbcas.nscas[3]+2;
      km=k/2;
      l=MIN(lgbcas.nscas[1],lgbcas.nscas[2]);
      l-=l%lgbcas.nscas[3];	
      if(l<=0) l-=lgbcas.nscas[3];
      for(i=0;i<k;i++) {
	x=(l-lgbcsl.alinas)/cfas;
	if((ABS(x))<ASSI_EPS) x=0.;
	if((ABS(x-lgbcas.dlunas))<ASSI_EPS) x=lgbcas.dlunas;
	if((x>=0.) && (x<=lgbcas.dlunas)) {
	  gx=lgbcas.gxinas+x*lgbcas.coas+dgx;
	  gy=lgbcas.gyinas+x*lgbcas.seas+dgy;
	  numesp(gx,gy,kp,10,l,lgbcas.dimsc,lgbcas.rotsc,&ncar);
	  j=MAX(j,ncar);
	}
	if(i==km) lgwlab(gx,gy,dgx,dgy,j,kp,testo,ntesto);
	l+=lgbcas.nscas[3];
      }
    }
    else if(lgbcas.nscas[0]<0) {
      int j=0;		/* Scala entro le decadi */
      int jkf,l,k,km,kfl,kk,i,ii;
      double x;
      jkf= -lgbcas.nscas[0];
      k=(ABS(lgbcas.nscas[2]-lgbcas.nscas[1]))+2;
      km=k/2;
      l=MIN(lgbcas.nscas[1],lgbcas.nscas[2]);
      for(i=0;i<k;i++) {
	kfl=lgbcsl.kscfl[jkf];
	for(ii=0;ii<9;ii++) {
	  kk=kfl%2;
	  kfl/=2;
	  if(kk!=0) {
	    x=(lgbcsl.xscl[ii]+l-lgbcsl.alinas)/cfas;
	    if((ABS(x))<ASSI_EPS) x=0.;
	    if((ABS(x-lgbcas.dlunas))<ASSI_EPS) x=lgbcas.dlunas;
	    if((x>=0.) && (x<=lgbcas.dlunas)) {
	      gx=lgbcas.gxinas+x*lgbcas.coas+dgx;
	      gy=lgbcas.gyinas+x*lgbcas.seas+dgy;
	      if(ii!=0) 
		numint(gx,gy,kp,(long)(ii+1),
		       lgbcas.dimsc,lgbcas.rotsc,&ncar);
	      else
		numesp(gx,gy,kp,10,l,lgbcas.dimsc,lgbcas.rotsc,&ncar);
	      j=MAX(j,ncar);
	    }
	  }
	}
	if(i==km) lgwlab(gx,gy,dgx,dgy,j,kp,testo,ntesto);
	l+=1;
      }
    }
  }
  else {
    lgwlab(gx,gy,dgx,dgy,0,0,testo,ntesto);
  }
  return;
}
/* Sottoprogramma lgwlab */
VOID lgwlab(gx,gy,dgx,dgy,j,kp,testo,ntesto)
double gx,gy,dgx,dgy;
int j,kp;
CHAR testo[];
int ntesto;
{  int jj;
   double dx,dy;
   if(j!=0)
   {  if(kp!=0) jj=lgbcsa.kspor*j+3;
      else jj=20;
      dx=ABS(jj*lgbcas.dimsc*lgbcas.seas);
      if(dgx<0.) dx= -dx;
      dx+=dgx;
      dy=ABS(jj*lgbcas.dimsc*lgbcas.coas);
      if(dgy<0.) dy= -dy;
      dy+=dgy;
   }
   else
   {  dx=dgx;
      dy=dgy;
   }
   if(ntesto>0)
   {  int jj=0;
      int ll=0;
      double dm;
      while(ll<ntesto && testo[ll]!=NUL) 
      {  if(testo[ll++]>BLANK) jj+=lgbcsa.kspor;
      }
      dm=.5*(lgbcas.dlunas-jj*lgbcas.dimsc);
      gx=lgbcas.gxinas+dx+dm*lgbcas.coas;
      gy=lgbcas.gyinas+dy+dm*lgbcas.seas;
      lgplot(gx,gy,MIZ_MOV);
      stralf(testo,ntesto,lgbcas.dimsc,lgbcas.rotas);
   }
   return;
}
/* Sottoprogramma lgtras */
VOID lgtras()
{  double dgx[3],dgy[3];
   double a,dl,c,d0,b,d1,gx,gy;
   int j,k,i;
   lgbc2d.kgrut=MIZ_GRAFPAG;
   a=(MAX(lgbcas.nscas[0],lgbcas.nscas[3]))*lgbcas.dscas;
   dl=a/lgbcas.coefas;
   c=lgbcas.scinas/a;
   if(lgbcas.scinas>0.)  c+=.5;
   else if(lgbcas.scinas<0.)  c-=.5;
   d0=((INT(c))*a-lgbcas.scinas)*lgbcas.dlunas/(lgbcas.scfias-lgbcas.scinas);
   if((ABS(d0))<ASSI_EPS*lgbcas.dlunas) d0=0.;
   if(d0>0.) d0-=dl;
/* Calcola lunghezza dei trattini */
   b= -lgbcas.latas[0];
   if(b==0.) b=1.;
   c=9.;
   b*=lgbcas.dimsc;
   for(j=0;j<3;j++)
   {  dgx[j]= -b*c*lgbcas.seas;
      dgy[j]=b*c*lgbcas.coas;
      c-=3.;
   }
/* Traccia l'asse */
   lgplot(lgbcas.gxinas,lgbcas.gyinas,MIZ_MOV);
   dl=lgbcas.dscas/lgbcas.coefas;
   k=(lgbcas.dlunas-d0)/dl+1.1;
   d1=d0;
   for(i=0;i<k;i++)
   {  if(d0<=lgbcas.dlunas)
      {  if(d0>=0.)
 	 {  gx=lgbcas.gxinas+lgbcas.coas*d0;
	    gy=lgbcas.gyinas+lgbcas.seas*d0;
	    lgplot(gx,gy,MIZ_SEG);
	    for(j=0;j<3;j++)
	    {  if((i%lgbcas.nscas[j])==0) break;
	    }
	    lgplot(gx+dgx[j],gy+dgy[j],MIZ_SEG);
	    if(lgbcas.latas[0]==0) lgplot(gx-dgx[j],gy-dgy[j],MIZ_SEG);
	    lgplot(gx,gy,MIZ_SEG);
	 }
	 d0=d1+dl*(i+1);
	 if((ABS(d0))<ASSI_EPS*lgbcas.dlunas) d0=0.;
	 if((ABS(d0-lgbcas.dlunas))<ASSI_EPS*lgbcas.dlunas) d0=lgbcas.dlunas;
      }
   }
   lgplot(lgbcas.gxinas+lgbcas.dlunas*lgbcas.coas,
   		lgbcas.gyinas+lgbcas.dlunas*lgbcas.seas,MIZ_SEG);
   return;
}
/* Sottoprogramma lgscal */
VOID lgscal(testo,ntesto)
CHAR testo[];
int ntesto;
{  int ib=16;
   int kp;
   double b, dgx, dgy, gx=0., gy=0.;
   lgbc2d.kgrut=MIZ_GRAFPAG;
/* Fissa la posizione della scala rispetto all'asse */
   b=ib;
   if(lgbcas.latas[1]<0) b= -b;
   b=(b+5.)*lgbcas.dimsc;
   dgx=b*lgbcas.seas;
   dgy= -b*lgbcas.coas;
   lgbcas.rotsc=lgbcas.rotas;
   if(lgbcas.latas[1]!=0)
   {  double a,dl,c,d0,s,cfas;
      int k,km,i,ncar;
      double d1;
      int j=0;
      kp=lgbcas.latas[1]/2;
      if(kp!=0) lgbcas.rotsc-=.25*lgbccs.angiro;
/* Cerca il punto iniziale della scala */
      a=lgbcas.dscas*lgbcas.nscas[3];
      dl=a/lgbcas.coefas;
      c=lgbcas.scinas/a;
      if(lgbcas.scinas>0.) c+=.5;
      else if(lgbcas.scinas>0.) c-=.5;
      d0=((INT(c))*a-lgbcas.scinas)*lgbcas.dlunas/(lgbcas.scfias-lgbcas.scinas);
      if((ABS(d0))/lgbcas.dlunas<ASSI_EPS) d0=0.;
      if(d0<0.) d0+=dl;
      cfas=ABS(lgbcas.coefas);
      if((lgbcas.scfias-lgbcas.scinas)<0.) cfas= -cfas;
/* Scrive la scala */
      k=(lgbcas.dlunas-d0)/dl+1.01;
      km=k/2;
      d1=d0;
      for(i=0;i<k;i++)
      {  gx=lgbcas.gxinas+d0*lgbcas.coas+dgx;
	 gy=lgbcas.gyinas+d0*lgbcas.seas+dgy;
	 s=lgbcas.scinas+d0*cfas;
	 if((ABS(s))<ASSI_EPS*lgbcas.slunas) s=0.;
	 numrea(gx,gy,kp,s,lgbcas.kdec,lgbcas.dimsc,lgbcas.rotsc,&ncar);
	 j=MAX(j,ncar);
	 if(i==km) lgwlab(gx,gy,dgx,dgy,j,kp,testo,ntesto);
	 d0=d1+dl*(i+1);
      }
   }
   else
   {  lgwlab(gx,gy,dgx,dgy,0,0,testo,ntesto);
   }
   return;
}
/* Sottoprogramma lgprsl */
VOID lgprsl()
{  
  double tmplunas;
  lgbcsl.alinas=log10(lgbcas.scinas);
  lgbcsl.alfias=log10(lgbcas.scfias);
  lgbcsl.alunas=lgbcsl.alfias-lgbcsl.alinas;
  lgbcas.coefas=ABS(lgbcsl.alunas/lgbcas.dlunas);
  tmplunas = ABS(lgbcsl.alunas);
  if(tmplunas >= SCALA_EXP) {		/* Scala su molte decadi.
				   Uso una suddivisione lineare sugli esponenti.
				*/
    double s;
    s = lgbcas.slunas;
    lgbcas.slunas = tmplunas;
    lgprsc();
    lgbcas.slunas = s;
  }
  else if(tmplunas >= SCALA_LOG) {	/* Scala su un numero limitato di decadi.
				   Uso una suddivisione logaritmica.
				*/
    int k,j;
    double dg;
    lgbcas.nscas[1]=lgbcsl.alinas+.01;
    if(lgbcsl.alinas<0.) lgbcas.nscas[1]-=1;
    lgbcas.nscas[2]=lgbcsl.alfias+.01;
    if(lgbcsl.alfias<0.) lgbcas.nscas[2]-=1;
    k=ABS(lgbcas.nscas[2]-lgbcas.nscas[1]);
    dg=1./lgbcas.coefas;
    j=.012*dg/lgbcas.dimsc;
    j=MIN(j,5);
    lgbcas.nscas[0]= -j;
    lgbcas.nscas[3]=0;
    if(j==0) lgbcas.nscas[3]=120.*lgbcas.dimsc/dg;
    lgbcas.nscas[3]=MIN(lgbcas.nscas[3],k/2);
  }
  else {			/* Scala su meno di una decade.
				   Uso una suddivisione lineare.
				*/
    double c;
    c=lgbcas.coefas;
    lgbcas.coefas=lgbcas.slunas/lgbcas.dlunas;
    lgprsc();
    lgbcas.coefas=c;
  }
  return;
}
/* Sottoprogramma lgprsc */
VOID lgprsc()
{  int k,j,l;
   double dg,a,b,c;
   k=log10(lgbcas.slunas);
   if(lgbcas.slunas<1.) k-=1;
   a=lgpow10(k);
   dg=a/lgbcas.coefas;
   while(dg<50.) 
   {  a*=10.; dg*=10.;
      k+=1;
   }
   while(dg>500.)
   {  a*=.1; dg*=.1;
      k-=1;
   }
   j=.018*dg/lgbcas.dimsc;
   j=MIN(j,4);
   for(l=0;l<4;l++) lgbcas.nscas[l]=lgbcsl.psc[j][l];
   lgbcas.kdec=MAX(0,-k+(j+1)/3);
   if(lgbcas.kdec>4)
   {  c=ABS(lgbcas.scinas);
      b=ABS(lgbcas.scfias);
      c=MAX(c,b);
      if(c<=1.)
      {  l=log10(c);
	 lgbcas.kdec= -(ABS(l+lgbcas.kdec));
      }
   }
   lgbcas.dscas=a/lgbcas.nscas[0];
   return;
}
/* Sottoprogramma lgaslg */
VOID lgaslg(testo,ntesto)
CHAR testo[];
int ntesto;
{  
   lgcvcp(lgbcas.gxfias-lgbcas.gxinas,lgbcas.gyfias-lgbcas.gyinas,
	            &lgbcas.dlunas,&lgbcas.rotas);
   if(lgbcas.dlunas<=0.)
   {  lgerr(LGE_ESTRASSE);
      return;
   }
   lgbcas.slunas=ABS(lgbcas.scfias-lgbcas.scinas);
   if(lgbcas.slunas<=0.)
   {  lgerr(LGE_ESTRSCALA);
      return;
   }
   if((lgbcas.scinas<=0.) || (lgbcas.scfias<=0.))
   {  lgerr(LGE_ESTRLOGNZE);
      return;
   }
   lgbcas.coas=(lgbcas.gxfias-lgbcas.gxinas)/lgbcas.dlunas;
   lgbcas.seas=(lgbcas.gyfias-lgbcas.gyinas)/lgbcas.dlunas;
   lgprsl();
   lgsclg(testo,ntesto);
   lgtrlg();
   return;
}
/* Sottoprogramma lgasli */
VOID lgasli(testo,ntesto)
CHAR testo[];
int ntesto;
{  lgcvcp(lgbcas.gxfias-lgbcas.gxinas,lgbcas.gyfias-lgbcas.gyinas,
	            &lgbcas.dlunas,&lgbcas.rotas);
   if(lgbcas.dlunas<=0.)
   {  lgerr(LGE_ESTRASSE);
      return;
   }
   lgbcas.slunas=ABS(lgbcas.scfias-lgbcas.scinas);
   if(lgbcas.slunas<=0.)
   {  lgerr(LGE_ESTRSCALA);
      return;
   }
   lgbcas.coas=(lgbcas.gxfias-lgbcas.gxinas)/lgbcas.dlunas;
   lgbcas.seas=(lgbcas.gyfias-lgbcas.gyinas)/lgbcas.dlunas;
   lgbcas.coefas=lgbcas.slunas/lgbcas.dlunas;
   lgprsc();
   lgscal(testo,ntesto);
   lgtras();
   return;
}
/* Sottoprogramma quadro */
VOID quadro(testx,ntestx,testy,ntesty)
CHAR testx[],testy[];
int ntestx,ntesty;
{  double dimx=2.;
   double dimy=2.;
   if(lgbc2d.kcoord==MIZ_CPOL)
   {  lgerr(LGE_COORD);
      return;
   }
/* dimx=aint(.005*(lgbc2d.g2lim(2,2)-lgbc2d.g2lim(1,2)))*.1+1.2 */
/* dimy=aint(.005*(lgbc2d.g2lim(4,2)-lgbc2d.g2lim(3,2)))*.1+1.2 */
   lgbcas.gxinas=lgbc2d.g2lim[MIZ_GRAFAGR][0];
   lgbcas.gyinas=lgbc2d.g2lim[MIZ_GRAFAGR][2];
   lgbcas.gxfias=lgbc2d.g2lim[MIZ_GRAFAGR][1];
   lgbcas.gyfias=lgbc2d.g2lim[MIZ_GRAFAGR][2];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][0];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][1];
   lgbcas.latas[0]= -1;
   lgbcas.latas[1]=1;
   lgbcas.dimsc=dimx;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLINYLOG))
   				lgasli(testx,ntestx);
   if((lgbc2d.kcoord==MIZ_XLOGYLIN) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg(testx,ntestx);
   lgbcas.gxfias=lgbc2d.g2lim[MIZ_GRAFAGR][0];
   lgbcas.gyfias=lgbc2d.g2lim[MIZ_GRAFAGR][3];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][2];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][3];
   lgbcas.latas[0]=1;
   lgbcas.latas[1]= -1;
   lgbcas.dimsc=dimy;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLOGYLIN))
   				lgasli(testy,ntesty);
   if((lgbc2d.kcoord==MIZ_XLINYLOG) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg(testy,ntesty);
   lgbcas.gxinas=lgbcas.gxfias;
   lgbcas.gyinas=lgbcas.gyfias;
   lgbcas.gxfias=lgbc2d.g2lim[MIZ_GRAFAGR][1];
   lgbcas.gyfias=lgbc2d.g2lim[MIZ_GRAFAGR][3];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][0];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][1];
   lgbcas.latas[0]=1;
   lgbcas.latas[1]=0;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLINYLOG))
   				lgasli("\000",(int) 0);
   if((lgbc2d.kcoord==MIZ_XLOGYLIN) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg("\000",(int) 0);
   lgbcas.gxinas=lgbc2d.g2lim[MIZ_GRAFAGR][1];
   lgbcas.gyinas=lgbc2d.g2lim[MIZ_GRAFAGR][2];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][2];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][3];
   lgbcas.latas[0]= -1;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLOGYLIN))
   				lgasli("\000",(int) 0);
   if((lgbc2d.kcoord==MIZ_XLINYLOG) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg("\000",(int) 0);
   return;
}
/* Sottoprogramma quadre */
VOID quadre(testx,ntestx,testy,ntesty)
CHAR testx[],testy[];
int ntestx,ntesty;
{  double dimx=2.;
   double dimy=2.;
   if(lgbc2d.kcoord==MIZ_CPOL)
   {  lgerr(LGE_COORD);
      return;
   }
/* dimx=aint(.005*(lgbc2d.g2lim(2,2)-lgbc2d.g2lim(1,2)))*.1+1.2 */
/* dimy=aint(.005*(lgbc2d.g2lim(4,2)-lgbc2d.g2lim(3,2)))*.1+1.2 */
   lgbcas.gxinas=lgbc2d.g2lim[MIZ_GRAFAGR][0];
   lgbcas.gyinas=lgbc2d.g2lim[MIZ_GRAFAGR][2];
   lgbcas.gxfias=lgbc2d.g2lim[MIZ_GRAFAGR][1];
   lgbcas.gyfias=lgbc2d.g2lim[MIZ_GRAFAGR][2];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][0];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][1];
   lgbcas.latas[0]= -1;
   lgbcas.latas[1]=1;
   lgbcas.dimsc=dimx;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLINYLOG))
   				lgasli(testx,ntestx);
   if((lgbc2d.kcoord==MIZ_XLOGYLIN) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg(testx,ntestx);
   lgbcas.gxfias=lgbc2d.g2lim[MIZ_GRAFAGR][0];
   lgbcas.gyfias=lgbc2d.g2lim[MIZ_GRAFAGR][3];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][2];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][3];
   lgbcas.latas[0]=1;
   lgbcas.latas[1]= -2;
   lgbcas.dimsc=dimy;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLOGYLIN))
   				lgasli(testy,ntesty);
   if((lgbc2d.kcoord==MIZ_XLINYLOG) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg(testy,ntesty);
   lgbcas.gxinas=lgbcas.gxfias;
   lgbcas.gyinas=lgbcas.gyfias;
   lgbcas.gxfias=lgbc2d.g2lim[MIZ_GRAFAGR][1];
   lgbcas.gyfias=lgbc2d.g2lim[MIZ_GRAFAGR][3];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][0];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][1];
   lgbcas.latas[0]=1;
   lgbcas.latas[1]=0;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLINYLOG))
   				lgasli("\000",(int) 0);
   if((lgbc2d.kcoord==MIZ_XLOGYLIN) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg("\000",(int) 0);
   lgbcas.gxinas=lgbc2d.g2lim[MIZ_GRAFAGR][1];
   lgbcas.gyinas=lgbc2d.g2lim[MIZ_GRAFAGR][2];
   lgbcas.scinas=lgbc2d.g2lim[MIZ_UTENTE][2];
   lgbcas.scfias=lgbc2d.g2lim[MIZ_UTENTE][3];
   lgbcas.latas[0]= -1;
   if((lgbc2d.kcoord==MIZ_CLINEARI) || (lgbc2d.kcoord==MIZ_XLOGYLIN))
   				lgasli("\000",(int) 0);
   if((lgbc2d.kcoord==MIZ_XLINYLOG) || (lgbc2d.kcoord==MIZ_CLOG)) 
   				lgaslg("\000",(int) 0);
   return;
}
/* Sottoprogramma asslog */
VOID asslog(xin,yin,xfi,yfi,scin,scfi,lato,dim,testo,ntesto)
double xin,xfi,yin,yfi,scin,scfi;
INT lato[2];
double dim;
CHAR testo[];
int ntesto;
{  lgcvug(xin,yin,&lgbcas.gxinas,&lgbcas.gyinas);
   lgcvug(xfi,yfi,&lgbcas.gxfias,&lgbcas.gyfias);
   lgbcas.scinas=scin;
   lgbcas.scfias=scfi;
/* Controllo della condizione di errore */
   if((ABS(lato[0]))>1 && (ABS(lato[1]))>2)
   {  lgerr(LGE_SCALA);
      lgbcas.latas[0]=0;
      lgbcas.latas[1]=0;
   }
   else
   {  lgbcas.latas[0]=lato[0];
      lgbcas.latas[1]=lato[1];
   }
   lgbcas.dimsc=ABS(dim);
   if(lgbcas.dimsc>0. && lgbcas.dimsc<=MIZ_DSIMX)
   {  lgaslg(testo,ntesto);
   }
   else
   {  lgbcas.dimsc=MIN(lgbcas.dimsc,MIZ_DSIMX);
      if(lgbcas.dimsc==0.) lgbcas.dimsc=1.;
      lgerr(LGE_DIMCARATT);
   }
   return;
}
/* Sottoprogramma asse */
VOID asse(xin,yin,xfi,yfi,scin,scfi,lato,dim,testo,ntesto)
double xin,xfi,yin,yfi,scin,scfi;
INT lato[2];
double dim;
CHAR testo[];
int ntesto;
{  lgcvug(xin,yin,&lgbcas.gxinas,&lgbcas.gyinas);
   lgcvug(xfi,yfi,&lgbcas.gxfias,&lgbcas.gyfias);
   lgbcas.scinas=scin;
   lgbcas.scfias=scfi;
/* Controllo della condizione di errore */
   if((ABS(lato[0]))>1 && (ABS(lato[1]))>2)
   {  lgerr(LGE_SCALA);
      lgbcas.latas[0]=0;
      lgbcas.latas[1]=0;
   }
   else
   {  lgbcas.latas[0]=lato[0];
      lgbcas.latas[1]=lato[1];
   }
   lgbcas.dimsc=ABS(dim);
   if(lgbcas.dimsc>0. && lgbcas.dimsc<=MIZ_DSIMX)
   {  lgasli(testo,ntesto);
   }
   else
   {  lgbcas.dimsc=MIN(lgbcas.dimsc,MIZ_DSIMX);
      if(lgbcas.dimsc==0.) lgbcas.dimsc=1.;
      lgerr(LGE_DIMCARATT);
   }
   return;
}
