/* <crinfo> :
Sottoprogrammi per la restituzione di informazioni relative a:
   -	posizione corrente della penna
   -	coordinate grafico o utente del cursore grafico
   -	errori
 */
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
/* Sottoprogramma grcoor */
VOID grcoor(gx,gy,ipos)
DOUBLE *gx,*gy;
INT *ipos;
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   *gx=lgbc2d.g2ult[MIZ_GRAFPAG][0];
   *gy=lgbc2d.g2ult[MIZ_GRAFPAG][1];
   *ipos=lgbc2d.kp2ult[MIZ_GRAFPAG];
   return;
}
/* Sottoprogramma utcoor */
VOID utcoor(x,y,ipos)
DOUBLE *x,*y;
INT *ipos;
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   *x=lgbc2d.g2ult[MIZ_UTENTE][0];
   *y=lgbc2d.g2ult[MIZ_UTENTE][1];
   *ipos=lgbc2d.kp2ult[MIZ_UTENTE];
   return;
}
/* Sottoprogramma grcur */
VOID grcur(gx,gy,car)
DOUBLE *gx,*gy;
CHAR *car;
{  double fx,fy;
#if MIZ_FILE
   *gx=lgbc2d.g2ult[MIZ_GRAFPAG][0];
   *gy=lgbc2d.g2ult[MIZ_GRAFPAG][1];
   *car=CR;
#endif
#if MIZ_INTERATTIVA
   *car=lgcur(&fx,&fy);
   lgcvfg(fx,fy,gx,gy);
#endif
   return;
}
/* Sottoprogramma grzoom */
VOID grzoom(gx0,gx1,gy0,gy1,car)
DOUBLE *gx0,*gy0,*gx1,*gy1;
CHAR *car;
{  double fx0,fy0,fx1,fy1;
#if MIZ_FILE
   *gx0=lgbc2d.g2lim[MIZ_GRAFPAG][0];
   *gy0=lgbc2d.g2lim[MIZ_GRAFPAG][1];
   *gx1=lgbc2d.g2lim[MIZ_GRAFPAG][2];
   *gy1=lgbc2d.g2lim[MIZ_GRAFPAG][3];
   *car=CR;
#endif
#if MIZ_INTERATTIVA
   *car=lgzoom(&fx0,&fy0,&fx1,&fy1);
   lgcvfg(fx0,fy0,gx0,gy0);
   lgcvfg(fx1,fy1,gx1,gy1);
#endif
   return;
}
/* Sottoprogramma utcur */
VOID utcur(x,y,car)
DOUBLE *x,*y;
CHAR *car;
{  double gx,gy;
#if MIZ_FILE
   gx=lgbc2d.g2ult[MIZ_GRAFPAG][0];
   gy=lgbc2d.g2ult[MIZ_GRAFPAG][2];
   *car=CR;
#endif
#if MIZ_INTERATTIVA
   grcur(&gx,&gy,car);
#endif
   lgcvgu(gx,gy,x,y);
   return;
}
/* Sottoprogramma utzoom */
VOID utzoom(x0,x1,y0,y1,car)
DOUBLE *x0,*y0,*x1,*y1;
CHAR *car;
{  double gx0,gy0,gx1,gy1;
#if MIZ_FILE
   gx0=lgbc2d.g2lim[MIZ_GRAFPAG][0];
   gy0=lgbc2d.g2lim[MIZ_GRAFPAG][1];
   gx1=lgbc2d.g2lim[MIZ_GRAFPAG][2];
   gy1=lgbc2d.g2lim[MIZ_GRAFPAG][3];
   *car=CR;
#endif
#if MIZ_INTERATTIVA
   grzoom(&gx0,&gx1,&gy0,&gy1,car);
#endif
   lgcvgu(gx0,gy0,x0,y0);
   lgcvgu(gx1,gy1,x1,y1);
   return;
}
/* Sottoprogramma schlim */
VOID schlim(fxmin,fxmax,fymin,fymax)
DOUBLE *fxmin,*fxmax,*fymin,*fymax;
{  
#if MIZ_FILE
   *fxmin=0.;
   *fymin=0.;
   paglim(fxmax,fymax);
#endif
#if MIZ_INTERATTIVA
   *fxmin=lgbccf.flim[0];
   *fxmax=lgbccf.flim[1];
   *fymin=lgbccf.flim[2];
   *fymax=lgbccf.flim[3];
#endif
   return;
}
/* Sottoprogramma numerr */
INT numerr(k)
int k;
{  if(k>0 && k<=MIZ_NUMMSGERR) 
   {  return(lgbcer.errve[k-1].cont);
   }
   else
   {  return(-1);
   }
}
/* Sottoprogramma ulterr */
INT ulterr()
{  return(lgbcer.kerult);
}
