/* <curliv> :
Sottoprogramma di tracciamento delle curve di livello 
di una funzione di due variabili.
Il traccimento e' fatto nel modo piu' elementare, senza
possibilita' di tratteggio e/o aggiunta di labels di 
nessun genere.
Viene tracciata una curva per volta, al valore specificato
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
struct {
  double fcri;
  double fliv;
  double fmin;
  double fmax;
  double dretx;
  double drety;
} lgcrlv;
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
#define SGN(x) ({int jj; \
                 if(x<0) jj=-1;\
                 else if(x==0) jj=0;\
                 else jj=1; jj;})
				/*  */
/* Sottoprogramma curliv 
   Parametri:
   fmat  :  matrice dei valori della funzione
   nx,nx :  dimensioni della matrice
   fliv  :  valore del livello da tracciare
   fcr   :  valore critico al di sotto del quale non si deve tracciare
*/
VOID curliv(fmat_adr,nx,ny,fliv,fcr)
     int nx;
     int ny;
     DOUBLE fmat_adr[];
     DOUBLE fliv;
     DOUBLE fcr;
{
  INT i,ip,ix,iy,jp;
  INT sg[4],sgcen;
  DOUBLE fl[4],flcen;
  DOUBLE dretx,drety,xnod[4],ynod[4],xcen,ycen,x,y,t;
  if(nx<=0 || ny<=0) {
    lgerr(LGE_DIMMATLIV);
    return;
  }
  else { 
    DOUBLE *fmat[nx];
    for(fmat[0]=fmat_adr, i=1; i<nx; i++) fmat[i] = fmat[i-1]+ny;
    /*   for(ix=0;ix<nx;ix++) { */
    /*     for(iy=0;iy<ny;iy++) { */
    /*       printf("%10.2lf",fmat[ix][iy]); */
    /*     } */
    /*     printf("\n"); */
    /*   } */
    dretx=(lgbc2d.g2lim[2][1]-lgbc2d.g2lim[2][0])/(nx-1);
    drety=(lgbc2d.g2lim[2][3]-lgbc2d.g2lim[2][2])/(ny-1);
    for(ix=0;ix<nx-1;ix++) {
      xnod[0]=xnod[3]=lgbc2d.g2lim[2][0]+ix*dretx;
      xnod[1]=xnod[2]=lgbc2d.g2lim[2][0]+(ix+1)*dretx;
      xcen=.5*(xnod[0]+xnod[1]);
      for(iy=0;iy<ny-1;iy++) {
	if(fmat[ix][iy] < fcr) continue;         /* se trovi un valore */
	if(fmat[ix+1][iy] < fcr) continue;       /* critico sulla maglia, */
	if(fmat[ix+1][iy+1] < fcr) continue;     /* lascia perdere tutto */
	if(fmat[ix][iy+1] < fcr) continue;
	fl[0]=fmat[ix][iy]-fliv;
	sg[0]=SGN(fl[0]);
	fl[1]=fmat[ix+1][iy]-fliv;
	sg[1]=SGN(fl[1]);
	fl[2]=fmat[ix+1][iy+1]-fliv;
	sg[2]=SGN(fl[2]);
	fl[3]=fmat[ix][iy+1]-fliv;
	sg[3]=SGN(fl[3]);
	if(sg[0]==sg[1] && sg[1]==sg[2] && sg[2]==sg[3]) continue;
	ynod[0]=ynod[1]=lgbc2d.g2lim[2][2]+iy*drety;
	ynod[2]=ynod[3]=lgbc2d.g2lim[2][2]+(iy+1)*drety;
	ycen=.5*(ynod[1]+ynod[2]);
	flcen=.25*(fl[0]+fl[1]+fl[2]+fl[3]);
	sgcen=SGN(flcen);
	for(i=0;i<4;i++){
	  ip=(i+1)%4;
	  if(sg[i]==sg[ip] && sg[i]==sgcen) continue;
	  jp=0;
	  if(sg[i]!=sg[ip]) {
	    t=fl[i]/(fl[i]-fl[ip]);
	    x=(1.-t)*xnod[i]+t*xnod[ip];
	    y=(1.-t)*ynod[i]+t*ynod[ip];
	    utmov(x,y);
	    ++jp;
	  }
	  if(sg[i]!=sgcen) {
	    t=fl[i]/(fl[i]-flcen);
	    x=(1.-t)*xnod[i]+t*xcen;
	    y=(1.-t)*ynod[i]+t*ycen;
	    if(jp==0) {
	      utmov(x,y);
	      ++jp;
	    }
	    else
	      utseg(x,y);
	  }
	  if(sg[ip]!=sgcen) {
	    t=fl[ip]/(fl[ip]-flcen);
	    x=(1.-t)*xnod[ip]+t*xcen;
	    y=(1.-t)*ynod[ip]+t*ycen;
	    if(jp==0) 
	      lgerr(LGE_CRLVINTERR);
	    else
	      utseg(x,y);
	  }
	}	
      }
    }
  }
  return;
}
/*  */
VOID clvmin(fmat_adr,nx,ny)
     int nx;
     int ny;
     DOUBLE fmat_adr[];
{
  int ix,iy,nx1,ny1,i;
  DOUBLE dretx,drety,x,y,tmp;
  if(nx<=0 || ny<=0) {
    lgerr(LGE_DIMMATLIV);
    return;
  }
  else { 
    DOUBLE *fmat[nx];
    for(fmat[0]=fmat_adr, i=1; i<nx; i++) fmat[i] = fmat[i-1]+ny;
    nx1=nx-1;
    ny1=ny-1;
    dretx=(lgbc2d.g2lim[2][1]-lgbc2d.g2lim[2][0])/(nx1);
    drety=(lgbc2d.g2lim[2][3]-lgbc2d.g2lim[2][2])/(ny1);
    for(ix=1;ix<nx1;ix++) {
      x=lgbc2d.g2lim[2][0]+ix*dretx;
      for(iy=1;iy<ny1;iy++) {
	tmp=fmat[ix][iy];
	tmp=MIN(tmp,fmat[ix-1][iy-1]);
	tmp=MIN(tmp,fmat[ix-1][iy]);
	tmp=MIN(tmp,fmat[ix-1][iy+1]);
	tmp=MIN(tmp,fmat[ix][iy-1]);
	tmp=MIN(tmp,fmat[ix][iy+1]);
	tmp=MIN(tmp,fmat[ix+1][iy-1]);
	tmp=MIN(tmp,fmat[ix+1][iy]);
	tmp=MIN(tmp,fmat[ix+1][iy+1]);
	if(tmp==fmat[ix][iy]) {
	  y=lgbc2d.g2lim[2][2]+iy*drety;
	  utpun(x,y);
	}
      }
    }
  }
  return;
} 
				/*  */
VOID colora_mappa(fmat_adr,nx,ny,zmin,zmax,jpenmin,jpenmax)
     int nx;
     int ny;
     DOUBLE fmat_adr[];
     DOUBLE zmin,zmax;
     int jpenmin,jpenmax;
{
  int jx,jy,kx,ky,npx,npy,jpen,npen,jpenpr,i;
  DOUBLE x,y,z,dx,dy,dz,xu,yu,dretx,drety,drix,driy,dzi,tmp;
  if(nx<=0 || ny<=0) {
    lgerr(LGE_DIMMATLIV);
    return;
  }
  if(jpenmin <= 0 || jpenmin > MIZ_NUMPEN || jpenmax <= 0 || jpenmax > MIZ_NUMPEN){
    lgerr(LGE_PENNA);
    return;
  }
  if((npen = jpenmax - jpenmin) == 0) {
    lgerr(CLM_INVNPEN);
    return;
  }
  if(zmin == zmax) {
    lgerr(CLM_INVLIMITS);
    return;
  }
  { 
    DOUBLE *fmat[nx];
    for(fmat[0]=fmat_adr, i=1; i<nx; i++) fmat[i] = fmat[i-1]+ny;
    dretx = lgbc2d.g2lim[MIZ_UTENTE][1]-lgbc2d.g2lim[MIZ_UTENTE][0];
    drety = lgbc2d.g2lim[MIZ_UTENTE][3]-lgbc2d.g2lim[MIZ_UTENTE][2];
    if((npx = (1.5+lgbc2d.g2lim[MIZ_GRAFAGR][1]-lgbc2d.g2lim[MIZ_GRAFAGR][0])) < 2) npx = 2;
    if((npy = (1.5+lgbc2d.g2lim[MIZ_GRAFAGR][3]-lgbc2d.g2lim[MIZ_GRAFAGR][2])) < 2) npy = 2;
    dx = dretx/((double) (npx-1));
    dy = drety/((double) (npy-1));
    dretx /= ((double) (nx-1));
    drety /= ((double) (ny-1));
    drix = 1./dretx;
    driy = 1./drety;
    dz = (zmax-zmin)/((double) npen);
    dzi = 1./dz;
    jpenpr = 0;
    for(jy=0; jy<npy; jy++) {
      yu = (y = jy*dy) + lgbc2d.g2lim[MIZ_UTENTE][2];
      if((ky = y*driy) > (ny-2)) ky = ny-2;
      y -= ky*drety;
      y *= driy;
      tmp = 1.-y;
      for(jx=0; jx<npy; jx++) {
	xu = (x = jx*dx) + lgbc2d.g2lim[MIZ_UTENTE][0];
	if((kx = x*drix) > (nx-2)) kx = nx-2;
	x -= kx*dretx;
	x *= drix;
	z = (1.-x)*(tmp*fmat[kx][ky]+y*fmat[kx][ky+1])
	  + x*(tmp*fmat[kx+1][ky]+y*fmat[kx+1][ky+1]);
	jpen = (z-zmin)*dzi;
	if((jpen >= 0) && (jpen <= npen)) {
	  if(jpenpr != jpen) {
	    jpenpr = jpen;
	    penna(jpen+jpenmin);
	  }
	  utpun(xu,yu);
	}
      }
    }
  }
  return;
}
