/* Interprete di interfacciamento con la libreria libgd.

   In linea di principio si possono creare tutti i formati previsti da
   libgd, semplicemente cambiando la chiamata alla funzione di codifica
   e scrittura del file.  

   La versione attuale prevede i formati png, jpeg e gif (non animato).

   Crea files separati per ciascuna pagina del file grafico.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#include "icpcmn.h"
#include "gd.h"
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
#if ICP_PNG
#define FGF_OUTSFX ".png"
#elif ICP_GIF
#define FGF_OUTSFX ".gif"
#elif ICP_JPEG
#define FGF_OUTSFX ".jpg"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbcio lgbcio;
extern struct lggraf lggraf;
/*  */
struct {  
  long kxult;			/* Ultime coordinate fisiche. */
  long kyult;
  long kxmin;			/* Minimo e massimo effettivamente */
  long kxmax;		        /* raggiunti durante il tracciamento */
  long kymin;			/* Serve per definire la dimensione*/
  long kymax;			/* effettiva dell'immagine */
  int npages;			/* Numero di pagine */
  FILE *tmpfil;			/* Puntatore al file temporaneo */
   }  lgcfgf={-1,-1,2000000000L,0,2000000000L,0,0,NULL};
gdImagePtr Image;		/* Puntatore all'immagine */
char lgfgf_outprefix[60];
char lgfgf_outname[84];
char *lgfgf_outsfx;
#define NUM_COLOR 256
unsigned short int Palette[NUM_COLOR][3] = {
  0377, 0377, 0377,      /* (0) */     /* bianco */
  0000, 0000, 0000,      /* (1) */     /* nero */
  0045, 0377, 0000,      /* (2) */
  0377, 0000, 0112,      /* (3) */
  0000, 0157, 0377,      /* (4) */
  0224, 0377, 0000,      /* (5) */
  0377, 0000, 0271,      /* (6) */
  0000, 0336, 0377,      /* (7) */
  0000, 0377, 0053,      /* (8) */
  0377, 0053, 0045,      /* (9) */
  0053, 0112, 0377,      /* (10) */
  0157, 0377, 0053,      /* (11) */
  0377, 0053, 0224,      /* (12) */
  0053, 0271, 0377,      /* (13) */
  0336, 0377, 0053,      /* (14) */
  0377, 0126, 0000,      /* (15) */
  0126, 0045, 0377,      /* (16) */
  0112, 0377, 0126,      /* (17) */
  0377, 0126, 0157,      /* (18) */
  0126, 0224, 0377,      /* (19) */
  0271, 0377, 0126,      /* (20) */
  0377, 0126, 0336,      /* (21) */
  0201, 0000, 0377,      /* (22) */
  0045, 0377, 0201,      /* (23) */
  0377, 0201, 0112,      /* (24) */
  0201, 0157, 0377,      /* (25) */
  0224, 0377, 0201,      /* (26) */
  0377, 0201, 0271,      /* (27) */
  0201, 0336, 0377,      /* (28) */
  0000, 0377, 0254,      /* (29) */
  0377, 0254, 0045,      /* (30) */
  0254, 0112, 0377,      /* (31) */
  0157, 0377, 0254,      /* (32) */
  0377, 0254, 0224,      /* (33) */
  0254, 0271, 0377,      /* (34) */
  0336, 0377, 0254,      /* (35) */
  0377, 0327, 0000,      /* (36) */
  0327, 0045, 0377,      /* (37) */
  0112, 0377, 0327,      /* (38) */
  0377, 0327, 0157,      /* (39) */
  0327, 0224, 0377,      /* (40) */
  0271, 0377, 0327,      /* (41) */
  0377, 0327, 0336,      /* (42) */
  0000, 0000, 0324,      /* (43) */
  0045, 0324, 0000,      /* (44) */
  0324, 0000, 0112,      /* (45) */
  0000, 0157, 0324,      /* (46) */
  0224, 0324, 0000,      /* (47) */
  0324, 0000, 0271,      /* (48) */
  0000, 0336, 0324,      /* (49) */
  0000, 0324, 0053,      /* (50) */
  0324, 0053, 0045,      /* (51) */
  0053, 0112, 0324,      /* (52) */
  0157, 0324, 0053,      /* (53) */
  0324, 0053, 0224,      /* (54) */
  0053, 0271, 0324,      /* (55) */
  0336, 0324, 0053,      /* (56) */
  0324, 0126, 0000,      /* (57) */
  0126, 0045, 0324,      /* (58) */
  0112, 0324, 0126,      /* (59) */
  0324, 0126, 0157,      /* (60) */
  0126, 0224, 0324,      /* (61) */
  0271, 0324, 0126,      /* (62) */
  0324, 0126, 0336,      /* (63) */
  0201, 0000, 0324,      /* (64) */
  0045, 0324, 0201,      /* (65) */
  0324, 0201, 0112,      /* (66) */
  0201, 0157, 0324,      /* (67) */
  0224, 0324, 0201,      /* (68) */
  0324, 0201, 0271,      /* (69) */
  0201, 0336, 0324,      /* (70) */
  0000, 0324, 0254,      /* (71) */
  0324, 0254, 0045,      /* (72) */
  0254, 0112, 0324,      /* (73) */
  0157, 0324, 0254,      /* (74) */
  0324, 0254, 0224,      /* (75) */
  0254, 0271, 0324,      /* (76) */
  0336, 0324, 0254,      /* (77) */
  0324, 0327, 0000,      /* (78) */
  0327, 0045, 0324,      /* (79) */
  0112, 0324, 0327,      /* (80) */
  0324, 0327, 0157,      /* (81) */
  0327, 0224, 0324,      /* (82) */
  0271, 0324, 0327,      /* (83) */
  0324, 0327, 0336,      /* (84) */
  0000, 0000, 0251,      /* (85) */
  0045, 0251, 0000,      /* (86) */
  0251, 0000, 0112,      /* (87) */
  0000, 0157, 0251,      /* (88) */
  0224, 0251, 0000,      /* (89) */
  0251, 0000, 0271,      /* (90) */
  0000, 0336, 0251,      /* (91) */
  0000, 0251, 0053,      /* (92) */
  0251, 0053, 0045,      /* (93) */
  0053, 0112, 0251,      /* (94) */
  0157, 0251, 0053,      /* (95) */
  0251, 0053, 0224,      /* (96) */
  0053, 0271, 0251,      /* (97) */
  0336, 0251, 0053,      /* (98) */
  0251, 0126, 0000,      /* (99) */
  0126, 0045, 0251,      /* (100) */
  0112, 0251, 0126,      /* (101) */
  0251, 0126, 0157,      /* (102) */
  0126, 0224, 0251,      /* (103) */
  0271, 0251, 0126,      /* (104) */
  0251, 0126, 0336,      /* (105) */
  0201, 0000, 0251,      /* (106) */
  0045, 0251, 0201,      /* (107) */
  0251, 0201, 0112,      /* (108) */
  0201, 0157, 0251,      /* (109) */
  0224, 0251, 0201,      /* (110) */
  0251, 0201, 0271,      /* (111) */
  0201, 0336, 0251,      /* (112) */
  0000, 0251, 0254,      /* (113) */
  0251, 0254, 0045,      /* (114) */
  0254, 0112, 0251,      /* (115) */
  0157, 0251, 0254,      /* (116) */
  0251, 0254, 0224,      /* (117) */
  0254, 0271, 0251,      /* (118) */
  0336, 0251, 0254,      /* (119) */
  0251, 0327, 0000,      /* (120) */
  0327, 0045, 0251,      /* (121) */
  0112, 0251, 0327,      /* (122) */
  0251, 0327, 0157,      /* (123) */
  0327, 0224, 0251,      /* (124) */
  0271, 0251, 0327,      /* (125) */
  0251, 0327, 0336,      /* (126) */
  0000, 0000, 0176,      /* (127) */
  0045, 0176, 0000,      /* (128) */
  0176, 0000, 0112,      /* (129) */
  0000, 0157, 0176,      /* (130) */
  0224, 0176, 0000,      /* (131) */
  0176, 0000, 0271,      /* (132) */
  0000, 0336, 0176,      /* (133) */
  0000, 0176, 0053,      /* (134) */
  0176, 0053, 0045,      /* (135) */
  0053, 0112, 0176,      /* (136) */
  0157, 0176, 0053,      /* (137) */
  0176, 0053, 0224,      /* (138) */
  0053, 0271, 0176,      /* (139) */
  0336, 0176, 0053,      /* (140) */
  0176, 0126, 0000,      /* (141) */
  0126, 0045, 0176,      /* (142) */
  0112, 0176, 0126,      /* (143) */
  0176, 0126, 0157,      /* (144) */
  0126, 0224, 0176,      /* (145) */
  0271, 0176, 0126,      /* (146) */
  0176, 0126, 0336,      /* (147) */
  0201, 0000, 0176,      /* (148) */
  0045, 0176, 0201,      /* (149) */
  0176, 0201, 0112,      /* (150) */
  0201, 0157, 0176,      /* (151) */
  0224, 0176, 0201,      /* (152) */
  0176, 0201, 0271,      /* (153) */
  0201, 0336, 0176,      /* (154) */
  0000, 0176, 0254,      /* (155) */
  0176, 0254, 0045,      /* (156) */
  0254, 0112, 0176,      /* (157) */
  0157, 0176, 0254,      /* (158) */
  0176, 0254, 0224,      /* (159) */
  0254, 0271, 0176,      /* (160) */
  0336, 0176, 0254,      /* (161) */
  0176, 0327, 0000,      /* (162) */
  0327, 0045, 0176,      /* (163) */
  0112, 0176, 0327,      /* (164) */
  0176, 0327, 0157,      /* (165) */
  0327, 0224, 0176,      /* (166) */
  0271, 0176, 0327,      /* (167) */
  0176, 0327, 0336,      /* (168) */
  0000, 0000, 0123,      /* (169) */
  0045, 0123, 0000,      /* (170) */
  0123, 0000, 0112,      /* (171) */
  0000, 0157, 0123,      /* (172) */
  0224, 0123, 0000,      /* (173) */
  0123, 0000, 0271,      /* (174) */
  0000, 0336, 0123,      /* (175) */
  0000, 0123, 0053,      /* (176) */
  0123, 0053, 0045,      /* (177) */
  0053, 0112, 0123,      /* (178) */
  0157, 0123, 0053,      /* (179) */
  0123, 0053, 0224,      /* (180) */
  0053, 0271, 0123,      /* (181) */
  0336, 0123, 0053,      /* (182) */
  0123, 0126, 0000,      /* (183) */
  0126, 0045, 0123,      /* (184) */
  0112, 0123, 0126,      /* (185) */
  0123, 0126, 0157,      /* (186) */
  0126, 0224, 0123,      /* (187) */
  0271, 0123, 0126,      /* (188) */
  0123, 0126, 0336,      /* (189) */
  0201, 0000, 0123,      /* (190) */
  0045, 0123, 0201,      /* (191) */
  0123, 0201, 0112,      /* (192) */
  0201, 0157, 0123,      /* (193) */
  0224, 0123, 0201,      /* (194) */
  0123, 0201, 0271,      /* (195) */
  0201, 0336, 0123,      /* (196) */
  0000, 0123, 0254,      /* (197) */
  0123, 0254, 0045,      /* (198) */
  0254, 0112, 0123,      /* (199) */
  0157, 0123, 0254,      /* (200) */
  0123, 0254, 0224,      /* (201) */
  0254, 0271, 0123,      /* (202) */
  0336, 0123, 0254,      /* (203) */
  0123, 0327, 0000,      /* (204) */
  0327, 0045, 0123,      /* (205) */
  0112, 0123, 0327,      /* (206) */
  0123, 0327, 0157,      /* (207) */
  0327, 0224, 0123,      /* (208) */
  0271, 0123, 0327,      /* (209) */
  0123, 0327, 0336,      /* (210) */
  0000, 0000, 0050,      /* (211) */
  0045, 0050, 0000,      /* (212) */
  0050, 0000, 0112,      /* (213) */
  0000, 0157, 0050,      /* (214) */
  0224, 0050, 0000,      /* (215) */
  0050, 0000, 0271,      /* (216) */
  0000, 0336, 0050,      /* (217) */
  0000, 0050, 0053,      /* (218) */
  0050, 0053, 0045,      /* (219) */
  0053, 0112, 0050,      /* (220) */
  0157, 0050, 0053,      /* (221) */
  0050, 0053, 0224,      /* (222) */
  0053, 0271, 0050,      /* (223) */
  0336, 0050, 0053,      /* (224) */
  0050, 0126, 0000,      /* (225) */
  0126, 0045, 0050,      /* (226) */
  0112, 0050, 0126,      /* (227) */
  0050, 0126, 0157,      /* (228) */
  0126, 0224, 0050,      /* (229) */
  0271, 0050, 0126,      /* (230) */
  0050, 0126, 0336,      /* (231) */
  0201, 0000, 0050,      /* (232) */
  0045, 0050, 0201,      /* (233) */
  0050, 0201, 0112,      /* (234) */
  0201, 0157, 0050,      /* (235) */
  0224, 0050, 0201,      /* (236) */
  0050, 0201, 0271,      /* (237) */
  0201, 0336, 0050,      /* (238) */
  0000, 0050, 0254,      /* (239) */
  0050, 0254, 0045,      /* (240) */
  0254, 0112, 0050,      /* (241) */
  0157, 0050, 0254,      /* (242) */
  0050, 0254, 0224,      /* (243) */
  0254, 0271, 0050,      /* (244) */
  0336, 0050, 0254,      /* (245) */
  0050, 0327, 0000,      /* (246) */
  0327, 0045, 0050,      /* (247) */
  0112, 0050, 0327,      /* (248) */
  0050, 0327, 0157,      /* (249) */
  0000, 0000, 0377,      /* (250) */
  0000, 0377, 0000,      /* (251) */
  0377, 0000, 0000,      /* (252) */
  0377, 0000, 0377,      /* (253) */
  0377, 0377, 0000,      /* (254) */
  0377, 0377, 0377       /* (255) */
}; 
/*  */
/* Sottoprogramma LGCUR */
/* Questo sottoprogramma e' previsto solo per le versioni interattive.
   Qui serve solo per evitare errori di "undefined external" in fase di 
   link. */
CHAR lgcur(fx,fy)
DOUBLE *fx,*fy;
{  *fx=lgcfgf.kxult;
   *fy=lgcfgf.kyult;
   return(CR);
}
/* Sottoprogramma LGZOOM */
/* Questo sottoprogramma e' previsto solo per le versioni interattive.
   Qui serve solo per evitare errori di "undefined external" in fase di 
   link. */
CHAR lgzoom(fx0,fy0,fx1,fy1)
DOUBLE *fx0,*fy0,*fx1,*fy1;
{  *fx0=0.;
   *fy0=lggraf.dflim[0];
   *fx1=0.;
   *fy1=lggraf.dflim[1];
   return(CR);
}
/* Sottoprogramma LGSVUO */
/* Esiste solo per compatibilita' con gli interpreti che tracciano
   direttamente su schermo, ma non fa nulla.
 */
VOID lgsvuo()
{  
   return;
}
/* Sottoprogramma LGPAG */
VOID lgpag(kpg)
     int kpg;
{  int kpg1,k;
 kpg1=kpg; if(kpg1>0) kpg1=ICP_PAGINA;
 switch (kpg1) {
 case ICP_INIT:
   {
     int ldot,lnam;
     char *palette_name;
     FILE *inpal;
     deferr(IGD_NOPALETTE,0,1,0);            /* Abilita la stampa del warning */
     deferr(IGD_INVPALETTE,0,1,0);           /* per i files palette */
     palette_name = getenv("MIZAR_PALETTE");
     if(palette_name == NULL || palette_name[0]==NUL) {
       lgerr(IGD_NOPALETTE);
     }
     else {
       if((inpal=fopen(palette_name,"r")) == NULL) {
	 perror(palette_name);
	 lgerr(IGD_INVPALETTE);
       }
       else {
	 fread(Palette,sizeof(unsigned short int),3*NUM_COLOR,inpal);
	 lgwmsg(IGD_PALETTE,palette_name);
	 fclose(inpal);
       }
     }
     lnam=strlen(lggraf.nomoug);
     for(ldot=lnam-1;ldot>=0;ldot--) if(lggraf.nomoug[ldot]=='.') break;
     if(ldot==0) ldot=lnam;
     strncpy(lgfgf_outprefix,lggraf.nomoug,60);
     lgfgf_outsfx=lggraf.nomoug+ldot;
     lgfgf_outprefix[ldot]=NUL;
   }
   strncpy(lgfgf_outname,lggraf.nomoug,60);
   lgcfgf.npages=0;
/*    printf("lggraf.nomoug: %s\n",lggraf.nomoug); */
/*    printf("lgfgf_outprefix: %s\n",lgfgf_outprefix); */
/*    printf("lgfgf_outsfx: %s\n",lgfgf_outsfx); */
/*    printf("lgfgf_outname: %s\n",lgfgf_outname); */
   break;
 case ICP_PAGINA:
   if(lgcfgf.npages>0) {
     if((lgbcio.kunoug=fopen(lgfgf_outname,"w")) == NULL) {
       printf("Failed to open output file:\n");
       perror(lgfgf_outname);
     }
#if ICP_PNG
     gdImagePng(Image,lgbcio.kunoug);
#elif ICP_GIF
     gdImageGif(Image,lgbcio.kunoug);
#elif ICP_JPEG
     gdImageJpeg(Image,lgbcio.kunoug,lggraf.quality);
#endif
     fclose(lgbcio.kunoug);
     gdImageDestroy(Image);
     sprintf(lgfgf_outname,"%s_%05d%s",lgfgf_outprefix,lgcfgf.npages,lgfgf_outsfx);
   }
   lgcfgf.npages++;
   Image=gdImageCreate(lggraf.dlim[0],lggraf.dlim[1]);
   /* lgcfgf.kxmin=lggraf.dflim[0]+1;
      lgcfgf.kxmax= -1;
      lgcfgf.kymin=lggraf.dflim[1]+1;
      lgcfgf.kymax= -1;
   */
/*    lgcfgf.npages=kpg; */
   for(k=0; k<NUM_COLOR;k++)
     gdImageColorAllocate(Image,Palette[k][0],Palette[k][1],Palette[k][2]);
   break;
 case ICP_FINE:
   if((lgbcio.kunoug=fopen(lgfgf_outname,"w")) == NULL) {
     printf("Failed to open output file:\n");
     perror(lgfgf_outname);
   }
#if ICP_PNG
   gdImagePng(Image,lgbcio.kunoug);
#elif ICP_GIF
   gdImageGif(Image,lgbcio.kunoug);
#elif ICP_JPEG
   gdImageJpeg(Image,lgbcio.kunoug,lggraf.quality);
#endif
   fclose(lgbcio.kunoug);
   gdImageDestroy(Image);
   break;
 case ICP_SVUOTA:
   break;
 case ICP_INIDATA:
#if ICP_PNG
   fseek(lgbcio.kunmiz,mizhdr.hdr.bldpng,SEEK_SET);
#elif ICP_GIF
   fseek(lgbcio.kunmiz,mizhdr.hdr.bldgif,SEEK_SET);
#elif ICP_JPEG
   fseek(lgbcio.kunmiz,mizhdr.hdr.bldjpg,SEEK_SET);
#endif
   fread(&lggraf,sizeof(struct lggraf),1,lgbcio.kunmiz);
   break;
 }
 return;
}
/* Sottoprogramma LGMOV */
VOID lgmov(fx,fy)
double fx,fy;
{ 
  long kx,ky;
  kx=fx;  ky=lggraf.dlim[1]-fy;
  if(lggraf.kstpn>0)		/* Spostamento a penna abbassata */   
    gdImageLine(Image,lgcfgf.kxult,lgcfgf.kyult,kx,ky,lggraf.kstpn);
				/* Aggiornamento coordinate, in ogni caso. */
  lgcfgf.kxult = kx; lgcfgf.kyult = ky; 
   return;
}
/* Sottoprogramma LGPEN */
VOID lgpen(k)
int k;
{  
  lggraf.kstpn=k;
  return;
}
