/* <genplt> :
Sottoprogrammi di gestione per:
   -	operazioni di conversione di coordinate
   	utente -> grafico -> fisiche
   -	tracciamento con taglio sulle finestre
   -	codifica del tracciamento sul file grafico.
*/
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;

#if MIZ_FILE
extern struct lgfile lgfile;
#endif

#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif

#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
#if MIZ_INTERATTIVA
/* Sottoprogramma lgpfcv */
VOID lgpfcv()
{  int kmp;
   double dgx,dgy,adt;
   double a,b,c,a2;
/* Definizione e controllo dei limiti fisici */
   lgbccf.kcgfdf=TRUE;
   kmp=ABS(lgbccf.kmprz);
   if(lgbccf.kmprz<=0)
   {  lgbccf.flim[0]=0.;
      lgbccf.flim[1]=lggraf.dlim[0];
      lgbccf.flim[2]=0.;
      lgbccf.flim[3]=lggraf.dlim[1];
   }
/* Calcolo coefficienti di conversione */
   dgx=(lgbccf.gflim[1]-lgbccf.gflim[0])*lgbccf.fatscg[0];
   dgy=(lgbccf.gflim[3]-lgbccf.gflim[2])*lgbccf.fatscg[1];
   a=dgx*lgbccf.crotgf;
   b= -dgy*lgbccf.srotgf;
   c=ABS(a+b);
   b=ABS(a-b);
   lgbccf.delgf[0]=MAX(b,c);
   a=dgx*lgbccf.srotgf;
   b=dgy*lgbccf.crotgf;
   c=ABS(a+b);
   b=ABS(a-b);
   lgbccf.delgf[1]=MAX(b,c);
   lgbccf.cfsc[0]=lgbccf.fatscf[0]*lggraf.dimug[0];
   lgbccf.cfsc[1]=lgbccf.fatscf[1]*lggraf.dimug[1];
   lgbccf.delf[0]=lgbccf.delgf[0]*lgbccf.cfsc[0];
   lgbccf.delf[1]=lgbccf.delgf[1]*lgbccf.cfsc[1];
   if(lgbccf.kmprz!=0)
   {  
/* Controllo che l'area interessata sia contenuta nei limiti fisici. */
      a=(lgbccf.flim[1]-lgbccf.flim[0])/lgbccf.delf[0];
      b=(lgbccf.flim[3]-lgbccf.flim[2])/lgbccf.delf[1];
      c=MIN(a,b);
      if((kmp>3) || ((c<1.) && (kmp>1)))
      {  
/* Adattamento ai limiti fisici con riscalamento del disegno. */
	 if((kmp%2)==0)
	 {  a=c;
	    b=c;
	 }
	 lgbccf.cfsc[0]=lgbccf.cfsc[0]*a;
	 lgbccf.cfsc[1]=lgbccf.cfsc[1]*b;
	 lgbccf.delf[0]=lgbccf.cfsc[0]*lgbccf.delgf[0];
	 lgbccf.delf[1]=lgbccf.cfsc[1]*lgbccf.delgf[1];
      }      
   }
/* Matrice di conversione */
   lgbccf.cogf[0][0]=
   	 lgbccf.fatscg[0]*lgbccf.cfsc[0]*lgbccf.crotgf*lgbccf.simxy[0];
   lgbccf.cogf[0][1]=
   	-lgbccf.fatscg[1]*lgbccf.cfsc[0]*lgbccf.srotgf*lgbccf.simxy[1];
   lgbccf.cogf[1][0]=
   	 lgbccf.fatscg[0]*lgbccf.cfsc[1]*lgbccf.srotgf*lgbccf.simxy[0];
   lgbccf.cogf[1][1]=
   	 lgbccf.fatscg[1]*lgbccf.cfsc[1]*lgbccf.crotgf*lgbccf.simxy[1];
   adt=1./(lgbccf.fatscg[0]*lgbccf.fatscg[1]*lgbccf.cfsc[0]*lgbccf.cfsc[1]);
   lgbccf.cofg[0][0]= lgbccf.cogf[1][1]*adt;
   lgbccf.cofg[0][1]= -lgbccf.cogf[0][1]*adt;
   lgbccf.cofg[1][0]= -lgbccf.cogf[1][0]*adt;
   lgbccf.cofg[1][1]= lgbccf.cogf[0][0]*adt;
/*  */
   if((c<1.) && (kmp==1))
   {  int npx,npy;
      double dgx,dgy;
      double x,x1,x2,ax1,ax2,y1,y2,dx,dy;
/* Calcolo dei parametri per il disegno a strisce */
      lgbccf.delgf[0]=lgbccf.delgf[0]*MIN(a,1.);
      lgbccf.delgf[1]=lgbccf.delgf[1]*MIN(b,1.);
      if(lgbccf.srotgf==0.)
      {  dx=lgbccf.delgf[0];
	 dy=lgbccf.delgf[1];
      }
      else if(lgbccf.crotgf==0.)
      {  dx=lgbccf.delgf[1];
	 dy=lgbccf.delgf[0];
      }
      else
      {  a=ABS(lgbccf.srotgf/lgbccf.crotgf);
	 a=MAX(a,1./a);
	 a2=a*a;
	 c=sqrt(1.+a2);
	 x1=lgbccf.delgf[0]/(a*c);
	 x2=lgbccf.delgf[1]*a2/c;
	 if(x1>=x2) 
	 {  dx=.5*x2;
	    dy=dx/a;
	 }
	 else if((x1*a) <= (x2/a))
	 {  dx=.5*x1;
	    dy=dx*a;
	 }
	 else
	 {  x=a2*(a*x2-x1)/(a2-1.);
	    ax1=MIN(.5*x1,x);
	    ax2=MIN(.5*x2,x);
	    y1=MIN(a*(x1-ax1),(x2-ax1)/a);
	    y2=MIN(a*(x1-ax2),(x2-ax2)/a);
	    if((ax1*y1) < (ax2*y2))
	    {  dx=ax2;
	       dy=y2;
	    }
	    else
	    {  dx=ax1;
	       dy=y1;
	    }
	 }
      }
      a=.5*dx/dgx;
      b=.5*dy/dgy;
      lgbccf.gfcen[0]=lgbccf.gflim[0]
   		+a*(lgbccf.gflim[1]-lgbccf.gflim[0]);
      lgbccf.gfcen[1]=lgbccf.gflim[2]
   		+b*(lgbccf.gflim[3]-lgbccf.gflim[2]);
      lgbccf.fcen[0]=.5*(lgbccf.flim[0]+lgbccf.flim[1]);
      lgbccf.fcen[1]=.5*(lgbccf.flim[2]+lgbccf.flim[3]);
      lgbccf.dgfcen[0]=lgbccf.persvr
   		*(lgbccf.gfcen[0]-lgbccf.gflim[0]);
      dgx=lgbccf.gflim[0]+lgbccf.gflim[1]-2.*lgbccf.gfcen[0];
      npx=dgx/lgbccf.dgfcen[0]+2.;
      if(dgx==0.) npx=1;
      lgbccf.dgfcen[1]=lgbccf.persvr
   		*(lgbccf.gfcen[1]-lgbccf.gflim[2]);
      dgy=lgbccf.gflim[2]+lgbccf.gflim[3]-2*lgbccf.gfcen[1];
      if(dgy==0.) npy=1;
      npy=dgy/lgbccf.dgfcen[1]+2.;
   }
   else
   {  if(lgbccf.kmprz<0)
      {  lgbccf.flim[1]=lgbccf.delf[0];
         lgbccf.flim[3]=lgbccf.delf[1];
      }
      if(lgbccf.kmprz!=0)
      {  lgbccf.fcen[0]=.5*(lgbccf.flim[0]+lgbccf.flim[1]);
	 lgbccf.fcen[1]=.5*(lgbccf.flim[2]+lgbccf.flim[3]);
	 lgbccf.gfcen[0]=.5*(lgbccf.gflim[0]+lgbccf.gflim[1]);
	 lgbccf.gfcen[1]=.5*(lgbccf.gflim[2]+lgbccf.gflim[3]);
	 lgbccf.dgfcen[0]=0.;
	 lgbccf.dgfcen[1]=0.;
      }
   }
   return;
}
/* Sottoprogramma lgcvgf */
VOID lgcvgf(gx,gy,fx,fy)
double gx,gy;
DOUBLE *fx,*fy;
{  double ax,ay,d;
   if(!lgbccf.kcgfdf) lgpfcv();
   ax=gx-lgbccf.gfcen[0];
   ay=gy-lgbccf.gfcen[1];
   *fx=lgbccf.fcen[0]+lgbccf.cogf[0][0]*ax+lgbccf.cogf[0][1]*ay;
   *fy=lgbccf.fcen[1]+lgbccf.cogf[1][0]*ax+lgbccf.cogf[1][1]*ay;
/* Tolleranza sui bordi superiore e destro della pagina */
   d=(*fx-lgbccf.flim[1])/lgbccf.flim[1];
   if((d>0.) && (d<1.e-4)) *fx=lgbccf.flim[1];
   d=(*fy-lgbccf.flim[3])/lgbccf.flim[3];
   if((d>0.) && (d<1.e-4)) *fy=lgbccf.flim[3];
   return;
}
/* Sottoprogramma lgcvfg */
VOID lgcvfg(fx,fy,gx,gy)
double fx,fy;
DOUBLE *gx,*gy;
{  double dx,dy;
   if(!lgbccf.kcgfdf) lgpfcv();
   dx=fx-lgbccf.fcen[0];
   dy=fy-lgbccf.fcen[1];
   *gx=lgbccf.gfcen[0]+lgbccf.cofg[0][0]*dx+lgbccf.cofg[0][1]*dy;
   *gy=lgbccf.gfcen[1]+lgbccf.cofg[1][0]*dx+lgbccf.cofg[1][1]*dy;
   return;
}
/* Sottoprogramma lgplof */
VOID lgplof(gx,gy)
double gx,gy;
{  unsigned char kout;
   int kf;
   double fx[2],fy[2],fx1[2];
   if(lgbcpn.pendis) return;
   lgcvgf(gx,gy,&fx[0],&fx[1]);
   fx[0]=floor(fx[0]+0.5);
   fx[1]=floor(fx[1]+0.5);
   kf=lgpos(fx,2,lgbccf.flim);
   if((lgbcpn.kvstpn<0) && kf==0)
   {  
/* Movimento a penna alzata */
      if(lggraf.kstpn!=lgbcpn.kvstpn) lgpen(lgbcpn.kvstpn);
      lgmov(fx[0],fx[1]);
      lgbccf.fult[0]=fx[0];
      lgbccf.fult[1]=fx[1];
   }
   if(lgbcpn.kvstpn>0)
   {  int kf0,kf1;
/* Movimento a penna abbassata con eventuale taglio */
      kf0=lgbccf.kfvult;
      kf1=kf;
      fx1[0]=fx[0];
      fx1[1]=fx[1];
      if((kf0!=0) || (kf!=0))
      {  lgzac(lgbccf.fvult,fx1,lgbccf.flim,&kf0,&kf1,&kout,2);
	 if(kout) goto aggiorna;
	 if(lgbccf.kfvult!=0)
	 {  if(-lgbcpn.kvstpn!=lggraf.kstpn) lgpen(-lgbcpn.kvstpn);
	    lgmov(lgbccf.fvult[0],lgbccf.fvult[1]);
	 }
      }
      if(lgbcpn.kvstpn!=lggraf.kstpn) lgpen(lgbcpn.kvstpn);
      lgmov(fx1[0],fx1[1]);
      lgbccf.fult[0]=fx1[0];
      lgbccf.fult[1]=fx1[1];
   }
/* Aggiornamento coordinate virtuali della penna */
aggiorna:
   lgbccf.fvult[0]=fx[0];
   lgbccf.fvult[1]=fx[1];
   lgbccf.kfvult=kf;
   return;
}
/* Sottoprogramma lgsim */
VOID lgsim(k)
char k;
{  double co,se,gx,gy,ax,ay,gx1,gy1;
   int ind,lun,kx,ky,kx0,ky0,i;
   unsigned char l;
   if(k<0)
   {  lgbcsa.ksim=lgbccf.kspun;
      co=lgbccf.dimpun*lgbccf.copun;
      se=lgbccf.dimpun*lgbccf.sepun;
   }
   if(k==0)
   {  lgbcsa.ksim=lgbc2d.knsp;
      co=lgbc2d.cosp*lgbc2d.dimsp;
      se=lgbc2d.sesp*lgbc2d.dimsp;
   }
   if(k>0)
   {  co=lgbcsg.corot*lgbcsg.dimcar[lgbcsg.kliv];
      se=lgbcsg.serot*lgbcsg.dimcar[lgbcsg.kliv];
   }
   gx=lgbc2d.g2ult[MIZ_GRAFPAG][0];
   gy=lgbc2d.g2ult[MIZ_GRAFPAG][1];
   ind=lgbccr.kindcr[lgbcsa.ksim-1];
   lun=lgbccr.kindcr[lgbcsa.ksim]-lgbccr.kindcr[lgbcsa.ksim-1];
   l=lgbccr.kposcr[lgbcsa.ksim-1];
   kx0=l%8;
   ky0=l/8;
   if((lgbcsa.ksim>=32) && (k<=0))
   {  kx0=kx0+3;
      ky0=ky0+3;
   }
   for(i=0;i<lun;i++)
   {  l=lgbccr.kinfcr[ind+i];
      lgbcpn.kvstpn= -(ABS(lggraf.kstpn));
      if((l&'\200')!=0) lgbcpn.kvstpn= -lgbcpn.kvstpn;
      l&='\177';
      kx=l%8;
      ky=l/8;
      ax=kx-kx0;
      ay=ky-ky0;
      if(k!=0)
      {  ay=ay*lgbcsg.dftsc[1];
	 ax=ax*lgbcsg.dftsc[0]+ay*lgbcsg.dstsim;
      }
      gx1=gx+ax*co-ay*se;
      gy1=gy+ax*se+ay*co;
      lgplof(gx1,gy1);
   }
/* Posiziona la penna secondo il seguente criterio:
   se il simbolo e' centrato riporta la penna alla
   posizione iniziale;
   se il simbolo e' non centrato, prepara la penna per un
   nuovo simbolo. */
   lgbcpn.kvstpn= -(ABS(lggraf.kstpn));
   if((k>0) && (lgbcsa.ksim>=32))
   {  lgbc2d.g2ult[MIZ_GRAFPAG][0]=gx+lgbcsa.kspor*co*lgbcsg.dftsc[0];
      lgbc2d.g2ult[MIZ_GRAFPAG][1]=gy+lgbcsa.kspor*se*lgbcsg.dftsc[0];
   }
   else
   {  lgbc2d.g2ult[MIZ_GRAFPAG][0]=gx;
      lgbc2d.g2ult[MIZ_GRAFPAG][1]=gy;
      lgbcsa.ksim=0;
   }
   lgplof(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
   return;
}
/* Sottoprogramma lgploi */
VOID lgploi(k)
int k;
{  double ax,ay,c,d,s;
   if(lgbcpn.pendis) return;
   switch(k)
   {  case MIZ_MOV:
	 lgbcpn.kvstpn= -(ABS(lggraf.kstpn));
	 lgplof(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	 break;
      case MIZ_SEG:
	 lgbcpn.kvstpn=ABS(lggraf.kstpn);
	 lgplof(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	 break;
      case MIZ_PUN:
	 lgbcpn.kvstpn= -(ABS(lggraf.kstpn));
	 lgplof(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	 if(lggraf.punsim)
	 {  lgsim(-1);
	 }
	 else
	 {  lgbcpn.kvstpn=ABS(lggraf.kstpn);
	    lgplof(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	    lgbcpn.kvstpn= -lgbcpn.kvstpn;
	 }
	 break;
      case MIZ_SIM:
	 lgsim(0);
	 break;
      case MIZ_TRA:
	 ax=lgbc2d.g2ult[MIZ_GRAFPAG][0]-lgbccf.gfult[0];
	 ay=lgbc2d.g2ult[MIZ_GRAFPAG][1]-lgbccf.gfult[1];
	 d=sqrt(ax*ax+ay*ay);
	 if(d==0.) break;
	 c=ax/d;
	 s=ay/d;
	 lgbccf.gfult[0]=lgbc2d.g2ult[MIZ_GRAFPAG][0];
	 lgbccf.gfult[1]=lgbc2d.g2ult[MIZ_GRAFPAG][1];
	 if(lgbccf.kopult!=MIZ_TRA)
	 {  lgbccf.dtrt=0.;
	    lgbccf.itrt= -1;
	 }
	 while(d>0.)
	 {  if(lgbccf.dtrt<=0.)
	    {  int lp;
	       lgbccf.itrt+=1;
	       if(lgbcge.ktratt[lgbccf.itrt]==0) lgbccf.itrt=0;
	       lgbccf.dtrt=ABS(lgbcge.ktratt[lgbccf.itrt]);
	       lp=ABS(lggraf.kstpn);
	       lgbcpn.kvstpn=(lgbcge.ktratt[lgbccf.itrt]>=0)? lp:-lp;
	    }
	    d-=lgbccf.dtrt;
	    lgbccf.dtrt= -d;
	    d=MAX(d,0.);
	    lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbccf.gfult[0]-d*c;
	    lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbccf.gfult[1]-d*s;
	    lgplof(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	 }
	 break;
   }
/* Aggiornamento coordinate */
   lgbccf.gfult[0]=lgbc2d.g2ult[MIZ_GRAFPAG][0];
   lgbccf.gfult[1]=lgbc2d.g2ult[MIZ_GRAFPAG][1];
   lgbccf.kopult=k;
   return;
}
#endif
/* Sottoprogramma lgpos */
INT lgpos(x,n,xlim)
DOUBLE x[];
DOUBLE xlim[];
int n;
{  int k=1;
   int j=0;
   int m=0;
   int l;
   for(l=0;l<n;++l)
   {  if(x[l]<xlim[m]) j+=k;
      k<<=1;
      if(x[l]>xlim[m+1]) j+=k;
      k<<=1;
      m+=2;
   }
   return(j);
}
#if MIZ_FILE
/* Sottoprogramma lgimpc */
VOID lgimpc(gx,gy)
double gx,gy;
{  lgbcge.pult[0]=gx*lgbcge.pcoef[0];
   lgbcge.pult[1]=gy*lgbcge.pcoef[1];
   lgcmpt(lgbcge.pult,2);
   return;
}
#endif
/* Sottoprogramma lgzac */
VOID lgzac(x1,x2,xlim,k1,k2,kout,n)
DOUBLE x1[],x2[],xlim[];
INT *k1,*k2;
UNSCHAR *kout;
int n;
{  int kbit,nn,m,i,j;
   double c;
/* Controllo se il segmento ha intersezioni col contorno
   dell'area di lavoro */
   *kout=((*k1)&(*k2))!=0;
   if(((*k1==0) && (*k2==0)) || *kout) return;
/* Ricerca delle intersezioni */
   kbit=1;
   nn=n+n;
   for (m=0;m<nn;m++)
   {  if(*kout) return;
      i=m/2;
      if(((*k1)&kbit)!=0)
      {  c=(xlim[m]-x1[i])/(x2[i]-x1[i]);
	 for(j=0;j<n;j++)
	 {  if(j!=i) x1[j]=x1[j]+c*(x2[j]-x1[j]);
	 }
	x1[i]=xlim[m];
	*k1=lgpos(x1,n,xlim);
      }
      else if((*k2&kbit)!=0)
      {  c=(xlim[m]-x2[i])/(x1[i]-x2[i]);
	 for(j=0;j<n;j++)
	 {  if(j!=i) x2[j]=x2[j]+c*(x1[j]-x2[j]);
	 }
	x2[i]=xlim[m];
	*k2=lgpos(x2,n,xlim);
      }
   kbit<<=1;
   *kout=((*k1)&(*k2))!=0;
   }
   return;
}
/* Sottoprogramma lgagrn */
VOID lgagrn(k)
char k;
{  char l;
   l=lgbc2d.kgrut;
   lgbc2d.kgrut=k;
/* Controllo errore nelle coordinate di aggiornamento */
   if((k<MIZ_GRAFPAG) || (k>MIZ_UTENTE))
   {  lgerr(LGE_AGGCOORD);
      return;
   }
   switch(k)
   {  case MIZ_UTENTE:
	 lgcvgu(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1],
	 	&lgbc2d.g2ult[MIZ_UTENTE][0],&lgbc2d.g2ult[MIZ_UTENTE][1]);
	 goto posizione;
      case MIZ_GRAFAGR:
	 lgbc2d.g2ult[MIZ_GRAFAGR][0]=lgbc2d.g2ult[MIZ_GRAFPAG][0];
	 lgbc2d.g2ult[MIZ_UTENTE][1]=lgbc2d.g2ult[MIZ_GRAFPAG][1];
      case MIZ_GRAFPAG:
posizione:
	 lgbc2d.kp2ult[k]=lgpos(&lgbc2d.g2ult[k][0],2,&lgbc2d.g2lim[k][0]);
	 lgbc2d.kgrut=l;
	 break;
   }
   return;
}
/* Sottoprogramma lgcvcp */
VOID lgcvcp(cx,cy,rag,ang)
double cx,cy;
DOUBLE *rag,*ang;
{  double a;
   *ang=0.;
   *rag=cx*cx+cy*cy;
   if(*rag!=0.)
   {  *rag=sqrt(*rag);
      a=cy/(*rag);
      *ang=asin(a);
      if(cx<0.) *ang=lgbccs.pigrec-*ang;
      if(!lgbcge.kanrad) *ang=(*ang)*lgbccs.radgra;
      if((*ang)<0.) *ang+=lgbccs.angiro;
   }
   return;
}
/* Sottoprogramma lgprcv */
INT lgprcv()
{  switch(lgbc2d.kcoord)
   {  case MIZ_CLINEARI:
	 lgbc2d.g2lim[3][0]=lgbc2d.g2lim[2][0];
	 lgbc2d.g2lim[3][1]=lgbc2d.g2lim[2][1];
	 lgbc2d.g2lim[3][2]=lgbc2d.g2lim[2][2];
	 lgbc2d.g2lim[3][3]=lgbc2d.g2lim[2][3];
	 break;
      case MIZ_XLOGYLIN:
	 if(lgbc2d.g2lim[2][0]<=0.)
	 {  lgerr(LGE_ESTRLOG);
	    return(LGE_ESTRLOG);
	 }
	 lgbc2d.g2lim[3][0]=log10(lgbc2d.g2lim[2][0]);
	 lgbc2d.g2lim[3][1]=log10(lgbc2d.g2lim[2][1]);
	 lgbc2d.g2lim[3][2]=lgbc2d.g2lim[2][2];
	 lgbc2d.g2lim[3][3]=lgbc2d.g2lim[2][3];
	 break;
      case MIZ_XLINYLOG:
	 lgbc2d.g2lim[3][0]=lgbc2d.g2lim[2][0];
	 lgbc2d.g2lim[3][1]=lgbc2d.g2lim[2][1];
	 if(lgbc2d.g2lim[2][2]<=0.)
	 {  lgerr(LGE_ESTRLOG);
	    return(LGE_ESTRLOG);
	 }
	 lgbc2d.g2lim[3][2]=log10(lgbc2d.g2lim[2][2]);
	 lgbc2d.g2lim[3][3]=log10(lgbc2d.g2lim[2][3]);
	 break;
      case MIZ_CLOG:
	 if((lgbc2d.g2lim[2][0]<=0.) || (lgbc2d.g2lim[2][2]<=0.))
	 {  lgerr(LGE_ESTRLOG);
	    return(LGE_ESTRLOG);
	 }
	 lgbc2d.g2lim[3][0]=log10(lgbc2d.g2lim[2][0]);
	 lgbc2d.g2lim[3][1]=log10(lgbc2d.g2lim[2][1]);
	 lgbc2d.g2lim[3][2]=log10(lgbc2d.g2lim[2][2]);
	 lgbc2d.g2lim[3][3]=log10(lgbc2d.g2lim[2][3]);
	 break;
      case MIZ_CPOL:
	 if(lgbc2d.g2lim[2][0]<0.)
	 {  lgerr(LGE_ESTRAGGIO);
	    return(LGE_ESTRAGGIO);
	 }
	 lgbc2d.g2lim[3][0]= -lgbc2d.g2lim[2][1];
	 lgbc2d.g2lim[3][1]=lgbc2d.g2lim[2][1];
	 lgbc2d.g2lim[3][2]=lgbc2d.g2lim[3][0];
	 lgbc2d.g2lim[3][3]=lgbc2d.g2lim[3][1];
	 break;
   }
   lgbc2d.kcodef=TRUE;
   lgbc2d.co2ug[0]=(lgbc2d.g2lim[1][1]-lgbc2d.g2lim[1][0])/
   			(lgbc2d.g2lim[3][1]-lgbc2d.g2lim[3][0]);
   lgbc2d.co2ug[1]=(lgbc2d.g2lim[1][3]-lgbc2d.g2lim[1][2])/
   			(lgbc2d.g2lim[3][3]-lgbc2d.g2lim[3][2]);
   lgbc2d.co2gu[0]=1./lgbc2d.co2ug[0];
   lgbc2d.co2gu[1]=1./lgbc2d.co2ug[1];
   return(0);
}
/* Sottoprogramma lgcvug */
INT lgcvug(x,y,gx,gy)
double x,y;
DOUBLE *gx,*gy;
{  int kret;
   double ux,uy;
/* Controlla se sono definiti i coefficienti di conversione */
   if(!lgbc2d.kcodef)
   {  kret=lgprcv();
      if(kret!=0) return(kret);
   }
/* Esegue la conversione */
   ux=x;
   uy=y;
   switch(lgbc2d.kcoord)
   {  case MIZ_XLOGYLIN:
	 if(ux<=0.) goto logneg;
	 ux=log10(ux);
	 break;
      case MIZ_XLINYLOG:
	 if(uy<=0.) goto logneg;
	 uy=log10(uy);
	 break;
      case MIZ_CLOG:
	 if(ux<=0. || uy<=0.) goto logneg;
	 ux=log10(ux);
	 uy=log10(uy);
	 break;
      case MIZ_CPOL:
	 if(ux<0.) goto ragneg;
	 if(!lgbcge.kanrad) uy*=lgbccs.grarad;
	 ux=x*cos(uy);
	 uy=x*sin(uy);
	 break;
      case MIZ_CLINEARI:
	 break;
   }
   *gx=lgbc2d.g2lim[1][0]+lgbc2d.co2ug[0]*(ux-lgbc2d.g2lim[3][0]);
   *gy=lgbc2d.g2lim[1][2]+lgbc2d.co2ug[1]*(uy-lgbc2d.g2lim[3][2]);
   return(0);
logneg:
   lgerr(LGE_COORLOG);
   return(LGE_COORLOG);
ragneg:
   lgerr(LGE_RAGNEG);
   return(LGE_RAGNEG);
}
/* Sottoprogramma lgcvgu */
VOID lgcvgu(gx,gy,x,y)
double gx,gy;
DOUBLE *x,*y;
{  double ux,uy;
/* Controlla se sono definiti i coefficienti di conversione */
   if(!lgbc2d.kcodef) lgprcv();
/* Esegue la conversione */
   ux=lgbc2d.g2lim[3][0]+(gx-lgbc2d.g2lim[1][0])*lgbc2d.co2gu[0];
   uy=lgbc2d.g2lim[3][2]+(gy-lgbc2d.g2lim[1][2])*lgbc2d.co2gu[1];
   switch(lgbc2d.kcoord)
   {  case MIZ_XLOGYLIN:
	 ux=pow(10.,ux);
	 break;
      case MIZ_XLINYLOG:
	 uy=pow(10.,uy);
	 break;
      case MIZ_CLOG:	 	 
	 ux=pow(10.,ux);
	 uy=pow(10.,uy);
	 break;
      case MIZ_CPOL:
	 lgcvcp(ux,uy,&ux,&uy);
	 break;
      case MIZ_CLINEARI:
	 break;
   }
   *x=ux;
   *y=uy;
   return;
}
/* Sottoprogramma lgplot */
INT lgplot(x,y,modo)
double x,y;
int modo;
{  int k,k1,k2,ke;
   int kret=0;
   double cx[2];
   cx[0]=x;
   cx[1]=y;
   k=lgpos(cx,2,&lgbc2d.g2lim[lgbc2d.kgrut][0]);
   if(k!=0)
   {  lgerr(lgbc2d.kerpnf[lgbc2d.kgrut]);
      kret=lgbc2d.kerpnf[lgbc2d.kgrut];
   }
   k2=k;
   if((modo==MIZ_SEG) || (modo==MIZ_TRA))
/* Segmento o tratteggio: esegue i tagli necessari */
   {  unsigned char kout;
      k1=lgbc2d.kp2ult[lgbc2d.kgrut];
      if((k1!=0) || (k2!=0))
      {  lgzac(&lgbc2d.g2ult[lgbc2d.kgrut][0],cx,
   		&lgbc2d.g2lim[lgbc2d.kgrut][0],&k1,&k2,&kout,2);
	 if(!kout)
	 {  if(lgbc2d.kp2ult[lgbc2d.kgrut]!=0)
	    {  ke=lgplo1(MIZ_MOV);
	       if(ke!=0) return(ke);
	    }
	    if(k!=0) 
	    {  lgbc2d.g2ult[lgbc2d.kgrut][0]=cx[0];
	       lgbc2d.g2ult[lgbc2d.kgrut][1]=cx[1];
	       ke=lgplo1(modo);
	       if(ke!=0) return(ke);
	    }
	 }
      }
   }
/* Posizionamento finale della penna, se non fuori area, e aggiornamento delle
   coordinate
   Nota: Le coordinate MIZ_GRAFPAG devono sempre essere aggiornate con la 
   posizione virtuale corrente delle penna; le coordinate MIZ_GRAFAGR e 
   MIZ_UTENTE devono essere aggiornate solo in caso di uso.
 */
   lgbc2d.g2ult[lgbc2d.kgrut][0]=x;
   lgbc2d.g2ult[lgbc2d.kgrut][1]=y;
   lgbc2d.kp2ult[lgbc2d.kgrut]=k;
   if(k==0)
   {  ke=lgplo1(modo);
   }
   else
   {  switch(lgbc2d.kgrut)
      {  case MIZ_GRAFAGR:
	    lgbc2d.g2ult[MIZ_GRAFPAG][0]=x;
	    lgbc2d.g2ult[MIZ_GRAFPAG][1]=y;
	    break;
	 case MIZ_UTENTE:
	    ke=lgcvug(x,y,&lgbc2d.g2ult[MIZ_GRAFPAG][0],
	    		&lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	    break;
	 case MIZ_GRAFPAG:
	    break;
      }
   }
   kret=(ke!=0)? ke:kret;
   return(kret);
}
/* Sottoprogramma lgplo1 */
INT lgplo1(modo)
int modo;
{  int kret=0;
   switch(lgbc2d.kgrut)
   {  case MIZ_UTENTE:
	 kret=lgcvug(lgbc2d.g2ult[MIZ_UTENTE][0],lgbc2d.g2ult[MIZ_UTENTE][1],
   		&lgbc2d.g2ult[MIZ_GRAFPAG][0],&lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	 break;
      case MIZ_GRAFAGR:
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbc2d.g2ult[MIZ_GRAFAGR][0];
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbc2d.g2ult[MIZ_GRAFAGR][1];
      case MIZ_GRAFPAG:
	 break;
   }
#if MIZ_FILE
   if(lgbcge.kcmult!=lgbc2d.kcmplo[modo])
   		lgcmdo(lgbc2d.kcmplo[modo],0,0);
   lgimpc(lgbc2d.g2ult[MIZ_GRAFPAG][0],lgbc2d.g2ult[MIZ_GRAFPAG][1]);
#endif
#if MIZ_INTERATTIVA
   lgploi(modo);
#endif
   return(kret);
}
