/* <genrle> :
Sottoprogrammi di;
   -	inizializzazione delle operazioni 
   -	apertura e scrittura dell'header de file grafico
   -	controllo delle pagine 
   -	gestione delle scritture di comandi su file grafico
   -	gestione degli errori e dei relativi messaggi
*/                  
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
#if MIZAR_LinuxVERSION
#include <termios.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
/*  */
#if MIZ_FILE
extern unsigned char lgcmop[MIZ_CMMAX];
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lgbccr lgbccr;
extern struct lggraf lggraf;
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
#if MIZ_FILE
/* Sottoprogramma lgwbuf */
VOID lgwbuf()
{  int i;
   fwrite(lgfile.kgrbf,sizeof(char),MIZ_FGRBUF,lgbcio.kungr);
   ++lgfile.krec;
   lgfile.kgrbf[0]=NUL;
   lgfile.kbf=1;
   for(i=1;i<MIZ_FGRBUF;lgfile.kgrbf[i++]=MIZ_CMNOP);
   if(lgfile.krec > MAX_FILE_RECORDS)
     lgerr(MIZ_FILGROSSO);
   return;
}
/* Sottoprogramma lgbuff */
VOID lgbuff(ibuf,n,modo)
UNSCHAR ibuf[];
int n;
int modo;
{  if(n>0)
   {  int i;
      for(i=0;i<n;i++)
      {  lgfile.kgrbf[lgfile.kbf++]=ibuf[i];
	 if(lgfile.kbf==MIZ_FGRBUF) lgwbuf();
      }
   }
   if((modo!=0) && (lgfile.kbf!=0)) lgwbuf();
   return;   
}
/* Sottoprogramma lgcmdo */
VOID lgcmdo(j,l,nl)
int j;
UNSCHAR l[];
int nl;
{  unsigned char lb[3];
   int n=0;
   int m;
/* Controllo di esistenza del comando */
   if((j<0) || (j>MIZ_CMMAX))
   {  lgerr(LGE_COMANDO);
      return;
   }
/*    if(lgcmop[j-1]<0)      */  /* Commentato perche' lgcmop */ 
/*    {  lgerr(LGE_COMANDO); */  /* e` dichiarato unsigned    */
/*       return;             */
/*    }                      */
   switch(lgbcge.kcmap)
   {
/* Stringa precedente da chiudere con il carattere MIZ_TERMLIST */
      case 1:
	 lb[n++]=MIZ_TERMLIST;
	 break;
/* Stringa precedente da chiudere con il carattere NUL */
      case 2:
	 lb[n++]=NUL;
	 break;
      case 0:
      case 3:
	 break;
   }
/* Registrazione del comando */
   lgbcge.kcmap=lgcmop[j-1];
   lgbcge.kcmult=j;
   lb[n++]=j;
   m=lgcmop[j-1]/3;
   lgbuff(lb,n,m);
   if(nl>0) lgbuff(l,nl,0);
   return;
}
/* Sottoprogramma lgcmpt */
VOID lgcmpt(x,k)
DOUBLE x[];
int k;
{  unsigned char l1buf[10];
   int i,n,j,kj;
   long int a;
   if(k>3) 
   {  lgerr(LGE_OVFCMPT);
      return;
   }
   l1buf[0]=0;			/* Impacchettamento delle coordinate */
   n=1;
   kj=1;
   for(i=0;i<k;i++)
   {  j=0;
      if((a=x[i])!=0)
      {  for(j=1;j<=3;j++)
	 {  l1buf[n++]=a%256;
	    a/=256;
	    if(a==0) goto registra;
	 }		/* Errore in caso di uscita da questo ciclo: coordinate
   			   non contenute in 24 bit. */
	 lgerr(LGE_OVFINT24BIT);
	 return;
      }
      registra:
      l1buf[0]+=j*kj;
      kj*=4;
   }
/* Inserimento delle coordinate nel buffer di output */
   lgbuff(l1buf,n,0);
   return;
}
/* Sottoprogramma lgwepg */
/* Registrazione estremi della pagina */
VOID lgwepg()
{  double x[2];
   UNSCHAR *zero=NUL;
   lgcmdo(MIZ_PGDEF,zero,(int) 0);
   x[0]=lgbc2d.g2lim[MIZ_GRAFPAG][1];
   x[1]=lgbc2d.g2lim[MIZ_GRAFPAG][3];
   lgcmpt(x,2);
}
/* Sottoprogramma lgwmtr */
/* Registrazione della modalita' di tratteggio */
VOID lgwmtr()
{  int i,k;
   UNSCHAR  mtrbuf[MIZ_L_MOTRA];
   for(i=0;i<MIZ_L_MOTRA;i++)
   {  k=ABS(lgbcge.ktratt[i]);
      if(lgbcge.ktratt[i]<0) k+=128;
      mtrbuf[i]=k;
      if(k==0)
      {  ++i;
	 break;
      }
   }
   lgcmdo(MIZ_DFTRA,mtrbuf,i);
   return;
}
/* Sottoprogramma lgwsmc */
/* Registrazione dei parametri del simbolo centrato */
VOID lgwsmc()
{  double x[2];
   x[0]=lgbc2d.dimsp*MIZ_FTSIM;
   x[1]=lgbc2d.rotsp*MIZ_FTSIM;
   lgcmdo(MIZ_DFSIM,&lgbc2d.knsp,(int) 1);
   lgcmpt(x,2);
}
/* Sottoprogramma lgwpen */
/* Registrazione del numero corrente di penna */
VOID lgwpen()
{  lgcmdo(MIZ_PNCTR,&lgbcge.penna,(int) 1);
}
/* Sottoprogramma lgwdrs */
/* Registrazione dimensioni e angolo di rotazione dei caratteri */
VOID lgwdrs()
{  double pbuf[2];
   UNSCHAR *zero=NUL;
   pbuf[0]=lgbcsa.dimsim*MIZ_FTSIM;
   pbuf[1]=lgbcsa.rotsim*MIZ_FTSIM;
   lgcmdo(MIZ_DFDMR,zero,(int) 0);
   lgcmpt(pbuf,2);
}
/* Sottoprogramma lgwtbo */
/* Registrazione delle posizioni di tabulazione orizzontale */
VOID lgwtbo()
{  int i;
   double tmp;
   UNSCHAR *zero=NUL;
   lgcmdo(MIZ_DFTBO,zero,(int) 0);
   for(i=0;i<MIZ_TABOR;i++)
   {  tmp=lgbcsa.tbor[i]*lgbcge.pcoef[0];
      lgcmpt(&tmp,1);
   }
}
/* Sottoprogramma lgwtbv */
/* Registrazione delle posizioni di tabulazione verticale */
VOID lgwtbv()
{  int i;
   double tmp;
   UNSCHAR *zero=NUL;
   lgcmdo(MIZ_DFTBV,zero,(int) 0);
   for(i=0;i<MIZ_TABVER;i++)
   {  tmp=lgbcsa.tbver[i]*lgbcge.pcoef[1];
      lgcmpt(&tmp,1);
   }
}
/* Sottoprogramma lgwcar */
/* Registrazioni dei parametri riguardanti i caratteri */
VOID lgwcar()
{  UNSCHAR tmpc;
   double ryx1;
   UNSCHAR *zero=NUL;
   tmpc=lgbcsa.kspor;
   lgcmdo(MIZ_DFSPO,&tmpc,(int) 1);
   tmpc=lgbcsa.kspver;
   lgcmdo(MIZ_DFSPV,&tmpc,(int) 1);
   lgcmdo(MIZ_DFRYX,zero,(int) 0);
   ryx1=lgbcsg.dftsc[1]*lgbcsa.dstmax;
   lgcmpt(&ryx1,1);
   lgcmdo(MIZ_DFDST,zero,(int) 0);
   ryx1=(lgbcsg.dstsim+lgbcsa.dstmax)*lgbcsa.dstfat;
   lgcmpt(&ryx1,1);
}
/* Sottoprogramma lgwmrg */
/* Registrazione dei margini utili della pagina */
VOID lgwmrg()
{  double tmp;
   UNSCHAR *zero=NUL;
   lgcmdo(MIZ_DFMAR,zero,(int) 0);
   tmp=lgbcsg.pagmar[0]*lgbcge.pcoef[0];
   lgcmpt(&tmp,1);
   tmp=lgbcsg.pagmar[1]*lgbcge.pcoef[0];
   lgcmpt(&tmp,1);
   tmp=lgbcsg.pagmar[2]*lgbcge.pcoef[1];
   lgcmpt(&tmp,1);
   tmp=lgbcsg.pagmar[3]*lgbcge.pcoef[1];
   lgcmpt(&tmp,1);
}
#endif
#if MIZ_INTERATTIVA
/* Sottoprogramma lgspag */
CHAR lgspag()
{ 
  char c;
  if(lggraf.batch) return(NUL);
  if(lggraf.anim && !lggraf.last_page) {
    fd_set rfds;
    struct timeval tv;
    FD_ZERO(&rfds);  FD_SET(0, &rfds);
    tv.tv_sec= lggraf.req.tv_sec;
    tv.tv_usec=lggraf.req.tv_nsec/1000;
    if(select(1, &rfds, NULL, NULL, &tv)) lggraf.anim=FALSE;
    else return(NUL);
  }
  if(lggraf.prompg) lgwmsg(MIZ_PRMINIPAG);
  if(lggraf.bell) lgwmsg(MIZ_SOUNDBEL);
#if MIZAR_PCVERSION
   c=getch();
#endif
#if MIZAR_LinuxVERSION
 {
   struct termios termios_p,termios_new_p;
   if(lgbcio.kuninp==NULL) lgbcio.kuninp=stdin;
   tcgetattr(STDIN_FILENO,&termios_new_p);
   termios_p = termios_new_p;    /* and make a copy */
   termios_new_p.c_lflag &= !(ICANON);
   if(lggraf.prompg) termios_new_p.c_lflag |= ECHO;
   tcsetattr ( STDIN_FILENO, TCSAFLUSH, &termios_new_p);
   c=linux_getch();  
   tcsetattr ( STDIN_FILENO, TCSAFLUSH, &termios_p);
 }
#endif
/*    if(lggraf.prompg) lgwmsg(MIZ_ACAPO); */
   return(c);
}
#endif
/* Sottoprogramma inizio */
INT inizio(k)
FILE *k;
{  
  int i, lname;
  char risp, *mizar_lib;
  unsigned char *zero=NUL;
				/* Lettura dati di inizializzazione da file */
   mizar_lib = getenv("MIZAR");
   lname=0;
   while(mizar_lib[lname++] != NUL);
   lname += 16;
  {
    char filnam[lname];
    sprintf(filnam,"%s/mizar.dat",mizar_lib);
    lgbcio.kunmiz=fopen(filnam,"rb");
    if(lgbcio.kunmiz==0) lgwmsg(-1);
  }
   fread(&mizhdr,sizeof(union mizhdr),1,lgbcio.kunmiz);
   if(ferror(lgbcio.kunmiz)) lgwmsg(-2);
/* Controllo chiamata multipla. Il numero di pagina deve essere negativo. */
   if(lgbcge.kpag>=0)
   {  lgerr(LGE_INIZIO);
      return(LGE_INIZIO);
   }
   lginit();				/* Inizializzazione aree comuni */
#if MIZ_FILE
/* Apertura del file grafico, se necessaria */
   if(k==0)
   {  lgbcio.kungr=fopen("grafic.dat","w+b");
      if (lgbcio.kungr==0)
      {  lgerr(LGE_OPENFGR);
	 return(LGE_OPENFGR);
      }
   }
   else
   {  lgbcio.kungr=k;
      i=fseek(lgbcio.kungr,0L,SEEK_SET);
      if(i!=0)
      {  lgerr(LGE_FGRSEEK);
	 return(LGE_FGRSEEK);
      }
   }
   {  struct tm *timecr;			/* Data e ora */
      time_t mclock;
      time(&mclock);
      timecr=localtime(&mclock);
      lgfile.kbf=HFG_CRTIM;
      lgfile.kgrbf[lgfile.kbf++]=timecr->tm_mday;
      lgfile.kgrbf[lgfile.kbf++]=timecr->tm_mon+1;
      lgfile.kgrbf[lgfile.kbf++]=timecr->tm_year;
      lgfile.kgrbf[lgfile.kbf++]=timecr->tm_hour;
      lgfile.kgrbf[lgfile.kbf++]=timecr->tm_min;
      lgfile.kgrbf[lgfile.kbf++]=timecr->tm_sec;
   }
/* Scrittura primo record */
   lgbuff(zero,0,1);
#endif
#if MIZ_INTERATTIVA
   risp=lgspag();			/* Conferma inizializzazione */
   lgpag(ICP_INIT);			/* Inizializzazione perif. */
   lggraf.kstpn=MIZ_NUMPEN+1;
   lgpen(-1);
#endif
   pagina();
#if MIZ_INTERATTIVA
   defpag(lggraf.dflim[0]/lggraf.dimug[0],lggraf.dflim[1]/lggraf.dimug[1]);
#endif
   return(0);
}
/* Sottoprogramma lginit */
VOID lginit()
{  int i;
/* Lettura dei blocchi common */
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbcer,SEEK_SET);
   fread(&lgbcer,sizeof(struct lgbcer),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbccs,SEEK_SET);
   fread(&lgbccs,sizeof(struct lgbccs),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbcge,SEEK_SET);
   fread(&lgbcge,sizeof(struct lgbcge),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbc2d,SEEK_SET);
   fread(&lgbc2d,sizeof(struct lgbc2d),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbcsa,SEEK_SET);
   fread(&lgbcsa,sizeof(struct lgbcsa),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbcsg,SEEK_SET);
   fread(&lgbcsg,sizeof(struct lgbcsg),1,lgbcio.kunmiz);
#if MIZ_FILE
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgfile,SEEK_SET);
   fread(&lgfile,sizeof(struct lgfile),1,lgbcio.kunmiz);
#endif
#if MIZ_INTERATTIVA
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbccf,SEEK_SET);
   fread(&lgbccf,sizeof(struct lgbccf),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbcpn,SEEK_SET);
   fread(&lgbcpn,sizeof(struct lgbcpn),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,mizhdr.hdr.lgbccr,SEEK_SET);
   fread(&lgbccr,sizeof(struct lgbccr),1,lgbcio.kunmiz);
   lgpag(ICP_INIDATA);
   for(i=0;i<MIZ_NUMPEN;i++)		/* Inizializzazione tabella penne */
      lgbcpn.kpenna[i]=i%lggraf.knpndf+1;
   lgbccf.kmprz= -2;
#endif
   if(ferror(lgbcio.kunmiz)) lgwmsg(-3);
/* Assegnazione unita' standard di I/O */
   lgbcio.kuninp=stdin;
   lgbcio.kunerr=stderr;
   lgbcio.kunout=stdout;
   return;   
}
/* Sottoprogramma lgerr */
VOID lgerr(k,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)
int k;
char *p0,*p1,*p2,*p3,*p4,*p5,*p6,*p7,*p8,*p9;
{  char erterm=FALSE;
   char buf[20];
   int exicod;
   UNSCHAR *zero=NUL;
   lgbcer.kerult=k;
   if(k<=0 || k>MIZ_NUMMSGERR)
   {  fprintf(lgbcio.kunerr,"MIZ-lgerr : %d ?",k);
      return;
   }
/* Se la statistica e' disabilitata e l'errore non e' grave rientra subito */
   if(((lgbcer.errve[k-1].stato & EST_CODERR)<MSG_C_ERRORE)
   		&&(!lgbcge.kersta)) return;
/* Incremento contatore */
   if(((lgbcer.errve[k-1].stato & EST_CONTAERR)!=0)) ++lgbcer.errve[k-1].cont;
/* Stampa messaggio e gestione livello errore */
   switch(lgbcer.errve[k-1].stato & EST_CODERR)
   {  case MSG_C_ERRORE:
	 exicod=MIZ_E_EXITCODE;
	 goto step0;
      case MSG_C_FATALE:
	 exicod=MIZ_F_EXITCODE;
      step0:
	 erterm=TRUE;
	 lgbcer.errve[k-1].stato|=EST_STAMPAMSG;
	 break;
      case MSG_C_MAXCONT:
	 if(lgbcer.errve[k-1].cont>MIZ_MAXERRCONT) 
	 {  lgbcer.errve[k-1].stato |= EST_STAMPAMSG;
	    erterm=TRUE;
	    exicod=MIZ_E_EXITCODE;
#if MIZAR_PCVERSION
	    itoa(MIZ_MAXERRCONT,buf,10);
#endif
#if MIZAR_LinuxVERSION
	    snprintf(buf,10,"%d",MIZ_MAXERRCONT);
#endif
	    lgwmsg(lgbcer.errve[LGE_CONTOSUP-1].stato & EST_NUMMSGERR,buf);
	 }
	 break;
      case MSG_C_WARNING:
	 break;
   }
   if(lgbcge.kersta && ((lgbcer.errve[k-1].stato & EST_STAMPAMSG) != 0))
   		lgwmsg(lgbcer.errve[k-1].stato & EST_NUMMSGERR,
   		p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
   if((lgbcer.errve[k-1].stato & EST_STPRIMOER) != 0)
   		lgbcer.errve[k-1].stato&=(~EST_STAMPAMSG);
   if(!erterm) return;
/* Interruzione esecuzione */
#if MIZ_INTERATTIVA
   {  char risp;
      risp=lgspag();
      lgpag(ICP_FINE);
   }
#endif
   lgwmsg(MIZ_ESECTERM);
#if MIZ_FILE
   lgfile.kgrbf[0]=MIZ_FLEOF;
   lgcmdo(MIZ_FLEOE,zero,(int) 0);
   lgfine(k);
#endif
   exit(exicod);
}
/* Sottoprogramma lgwmsg */
VOID lgwmsg(nmsg,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)
int nmsg;
char *p0,*p1,*p2,*p3,*p4,*p5,*p6,*p7,*p8,*p9;
{  long int msad;
/* Controllo numero messaggio */
   if(nmsg<0)
   {  fprintf(stderr,"MiZaR - File MIZAR.DAT ? err : %d\n",nmsg);
      exit(MIZ_F_EXITCODE );
   }
   if(nmsg>MIZ_NUMMSG)
   {  fprintf(lgbcio.kunerr,"MIZ-lgwmsg : %d ?\n",nmsg);
      return;
   }
/* Lettura livello e indirizzo testo messaggio */
   msad=mizhdr.hdr.tabmad+nmsg*(sizeof(char)+sizeof(long int));
   fseek(lgbcio.kunmiz,msad,SEEK_SET);
   fread(&lgbcms.admsg,sizeof(long int),1,lgbcio.kunmiz);
   fread(&lgbcms.livmsg,sizeof(char),1,lgbcio.kunmiz);
   fseek(lgbcio.kunmiz,lgbcms.admsg,SEEK_SET);
   fread(lgbcms.idmsg,sizeof(char),MSG_LUNID+1,lgbcio.kunmiz);
   fread(lgbcms.txtmsg,sizeof(char),MSG_LUNTXT+1,lgbcio.kunmiz);
   switch(lgbcms.livmsg)
   {  case MSG_LETTDAT:
	 fprintf(lgbcio.kunout,lgbcms.txtmsg,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	 break;
      case MSG_TESTO:
	 fprintf(lgbcio.kunout,lgbcms.txtmsg,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	 fprintf(lgbcio.kunout,"\n");
	 break;	 
      case MSG_INFORM:
   /*	 fprintf(lgbcio.kunout,"MiZaR - %c - ",lgbcms.livmsg);
	 fprintf(lgbcio.kunout,lgbcms.idmsg);
	 fprintf(lgbcio.kunout,": ");
	 fprintf(lgbcio.kunout,lgbcms.txtmsg,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	 fprintf(lgbcio.kunout,"\n");
	 break;	*/
      case MSG_WARNING:
      case MSG_MAXCONT:
      case MSG_ERRORE:
      case MSG_FATALE:      
	 fprintf(lgbcio.kunerr,"MiZaR - %c - ",lgbcms.livmsg);
	 fprintf(lgbcio.kunerr,lgbcms.idmsg);
	 fprintf(lgbcio.kunerr,": ");
	 fprintf(lgbcio.kunerr,lgbcms.txtmsg,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	 fprintf(lgbcio.kunerr,"\n");
   }
   return;
}
/* Sottoprogramma lgit2c */
VOID lgit2c(k,cb)
int k;
UNSCHAR cb[2];
{  cb[0]=k%256;
   cb[1]=k/256;
   return;
}
/* Sottoprogramma lgli4c */
VOID lgli4c(k,cb)
long k;
UNSCHAR cb[4];
{  long j0;
   int i;
   j0=k;
   for(i=0;i<4;i++)
   {  cb[i]=j0%256;
      j0/=256;
   }
   return;
}
#if MIZ_FILE
/* Sottoprogramma lgfine */
VOID lgfine(k)
int k;
{  fseek(lgbcio.kungr,0L,SEEK_SET);
   fread(lgfile.kgrbf,sizeof(char),MIZ_FGRBUF,lgbcio.kungr);
   lgli4c(lgfile.krec,&lgfile.kgrbf[HFG_NUMREC]);
   lgli4c((long) lgbcge.kpag,&lgfile.kgrbf[HFG_NUMPAG]);
   lgit2c(k,&(lgfile.kgrbf[HFG_CLOSTA]));
   fseek(lgbcio.kungr,0L,SEEK_SET);
   fwrite(lgfile.kgrbf,sizeof(char),MIZ_FGRBUF,lgbcio.kungr);
   if(lgbcge.kersta) errsta(0);
   fclose(lgbcio.kungr);
   lgfile.krpun=0;
   lgfile.krec=0;
   lgbcge.kpag= -1;
   return;
}
#endif
/* Sottoprogramma lgnwpg */
VOID lgnwpg(op)
     char op;
{
   UNSCHAR l1buf[2];
   char risp;
   UNSCHAR *zero=NUL;
   long int ipos;
   ++lgbcge.kpag;
   risp=op;
#if MIZ_INTERATTIVA
/* Svuotamento buffers e inizio pagina successiva */
   if(lgbcge.kpag>1) {
     lgbcpn.kvstpn=-(ABS(lggraf.kstpn));
     if(lgbcpn.kvstpn!=lggraf.kstpn) lgpen(lgbcpn.kvstpn);
     if(lggraf.posfin) {
       lgbc2d.g2ult[MIZ_GRAFPAG][0]=lggraf.pfin[0];
       lgbc2d.g2ult[MIZ_GRAFPAG][1]=lggraf.pfin[1];
       lgploi(MIZ_MOV);
     }
     lgpag(ICP_SVUOTA);
     switch(risp=lgspag()) {
     case '\012':
       risp=op;
       break;
     case 'c':
     case 'C':
     case 'n':
     case 'N':
       risp='c';
       break;
     case 'y':
     case 'Y':
     case 's':
     case 'S':
       risp='s';
       break;
     default:
       risp=op;
     }
   }
   lgpag(lgbcge.kpag);
#endif
#if MIZ_FILE
/* Chiusura pagina precedente (esclusa la prima pagina)*/
   if(lgbcge.kpag>1)
   {  if(MIZ_FGRBUF-lgfile.kbf<=1) lgcmdo(MIZ_CMNOP,zero,(int) 0);
      lgfile.kgrbf[0]=MIZ_PGFIN;
      lgcmdo(MIZ_PGFIN,zero,(int) 0);
   }
/* Apertura pagina successiva */
   lgfile.kgrbf[0]=MIZ_PGINI;
   lgit2c(lgbcge.kpag,l1buf);
   lgcmdo(MIZ_PGINI,l1buf,(int) 2);
				/* 22.10.02
				   Se il carattere letto e` 'c' oppure 'C' elimina
				   la pagina corrente dal file grafico.
				 */
   if(risp == 'c') {
     --lgbcge.kpag;
     lgfile.krec=lgfile.krulpg;
     ipos=lgfile.krec*MIZ_FGRBUF;
     fseek(lgbcio.kungr,ipos,SEEK_SET);
   }
   else				/* Altrimenti comportati come prima */
     lgfile.krulpg=lgfile.krec;
   lgwepg();
   lgwmtr();
   lgwsmc();
   lgwpen();
   lgwdrs();
   lgwtbo();
   lgwtbv();
   lgwcar();
   lgwmrg();
   lgcmdo(MIZ_ENDPR,zero,(int) 0);
#endif
   return;
}
/* Sottoprogramma pagina */
VOID pagina()
{
  lgnwpg('s');
  return;
}
/* Sottoprogramma pagina */
VOID canpag()
{
  lgnwpg('c');
  return;
}
/* Sottoprogramma fine */
VOID fine()
{  char risp;
   UNSCHAR *zero=NUL;
#if MIZ_INTERATTIVA
   lgbcpn.kvstpn=-(ABS(lggraf.kstpn));
   if(lgbcpn.kvstpn!=lggraf.kstpn) lgpen(lgbcpn.kvstpn);
   if(lggraf.posfin) {
     lgbc2d.g2ult[MIZ_GRAFPAG][0]=lggraf.pfin[0];
     lgbc2d.g2ult[MIZ_GRAFPAG][1]=lggraf.pfin[1];
     lgploi(MIZ_MOV);
   }
   lgpag(ICP_SVUOTA);
   lggraf.last_page=TRUE;
   risp=lgspag();
   lgpag(ICP_FINE);
#endif
#if MIZ_FILE
   if((MIZ_FGRBUF-lgfile.kbf)<=2) lgcmdo(MIZ_CMNOP,zero,(int) 0);
   lgfile.kgrbf[0]=MIZ_FLEOF;
   lgcmdo(MIZ_FLEOF,zero,(int) 0);
   lgfine(0);
#endif
   return;
}
/* Sottoprogramma defpag */
INT defpag(gx,gy)
double gx,gy;
{  int i;
/* Controllo condizione di errore*/
   if((gx<=0.) || (gx>lgbcge.plim[0]) || (gy<=0.) || (gy>lgbcge.plim[1])) 
   {  lgerr(LGE_ESTREMIPG);
      return(LGE_ESTREMIPG);
   }
/* Memorizzazione estremi */
   for(i=MIZ_GRAFPAG;i<MIZ_UTENTE;i++)
   {  lgbc2d.g2lim[i][0]=0.;
      lgbc2d.g2lim[i][1]=gx;
      lgbc2d.g2lim[i][2]=0.;
      lgbc2d.g2lim[i][3]=gy;
   }
#if MIZ_FILE
   if(lgbcge.kcmult!=MIZ_PGINI 
   		&& lgbcge.kcmult!=MIZ_PGDEF
   		&& lgbcge.kcmult!=MIZ_ENDPR)
   {  lgerr(LGE_PAGINA);
      return(LGE_PAGINA);
   }
   lgwepg();
#endif
#if MIZ_INTERATTIVA
   defgrl(lgbc2d.g2lim[MIZ_GRAFPAG][0],lgbc2d.g2lim[MIZ_GRAFPAG][1],
   	    lgbc2d.g2lim[MIZ_GRAFPAG][2],lgbc2d.g2lim[MIZ_GRAFPAG][3]);
#endif
   return(0);
}
/* Sottoprogramma defgrl */
VOID defgrl(gxmin,gxmax,gymin,gymax)
double gxmin,gxmax,gymin,gymax;
{  
#if MIZ_INTERATTIVA
/* Controllo ordinamento estremi */
   if(lgbc2d.g2lim[MIZ_GRAFPAG][0]>gxmin || gxmin>=gxmax
     || gxmax>lgbc2d.g2lim[MIZ_GRAFPAG][1] 
     || lgbc2d.g2lim[MIZ_GRAFPAG][2]>gymin || gymin>=gymax 
     || gymax>lgbc2d.g2lim[MIZ_GRAFPAG][3])
   {  lgerr(LGE_AREAGRAF);
      return;
   }	
/* Registrazione estremi */
   lgbccf.gflim[0]=gxmin;
   lgbccf.gflim[1]=gxmax;
   lgbccf.gflim[2]=gymin;
   lgbccf.gflim[3]=gymax;
   lgbccf.gfcen[0]=.5*(lgbccf.gflim[0]+lgbccf.gflim[1]);
   lgbccf.gfcen[1]=.5*(lgbccf.gflim[2]+lgbccf.gflim[3]);
   lgbccf.kcgfdf=FALSE;
#endif
   return;
}
/* Sottoprogramma errsta */
VOID errsta(k)
int k;
{  int n,i,nmsg;
   char l1buf[10];
/* Controlla se la statistica e' abilitata */
   if(!lgbcge.kersta)
   {  lgwmsg(MSG_STATERRNAB);
      return;
   }
/* Stampa la statistica */
   n=0;
   for(i=0;i<MIZ_NUMMSGERR;i++)
   {  if(lgbcer.errve[i].cont==0) continue;
      nmsg=lgbcer.errve[i].stato & EST_NUMMSGERR;
      fseek(lgbcio.kunmiz,
   	   	mizhdr.hdr.tabmad+nmsg*(sizeof(char)+sizeof(long int)),
      		SEEK_SET);
      fread(&lgbcms.admsg,sizeof(long int),1,lgbcio.kunmiz);
      fseek(lgbcio.kunmiz,lgbcms.admsg,SEEK_SET);
      fread(lgbcms.idmsg,sizeof(char),MSG_LUNID+1,lgbcio.kunmiz);
#if MIZAR_PCVERSION
      itoa(lgbcer.errve[i].stato,l1buf,10);
#endif
#if MIZAR_LinuxVERSION
      snprintf(l1buf,10,"%d",lgbcer.errve[i].stato);
#endif
/*       lgwmsg(MSG_NERRSTATP,lgbcms.idmsg,l1buf); */
      n+=lgbcer.errve[i].cont;
   }
#if MIZAR_PCVERSION
   itoa(n,l1buf,10);
#endif
#if MIZAR_LinuxVERSION
   snprintf(l1buf,10,"%d",n);
#endif
   lgwmsg(MSG_NERRSTAT,l1buf);
   if(k==0) return;
/* Azzeramento delle tavole */
   for(i=0;i<MIZ_NUMMSGERR;lgbcer.errve[i++].cont=0);
   return;
}
/* Sottoprogramma svuota */
VOID svuota()
{
#if MIZAR_LinuxVERSION
#if MIZ_INTERATTIVA
  lgpag(ICP_SVUOTA);
#endif
#endif
  return;
}
