/* <grplot> :
Sottoprogrammi per la gestione di:
   -	definizione dell'area grafica
   -	tracciamento in coordinate grafico
*/
#include <stdio.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
extern struct lgbcge lgbcge;
extern struct lgbc2d lgbc2d;
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
/*  */
/* Sottoprogramma grarea */
INT grarea(xgmin,xgmax,ygmin,ygmax)
double xgmin,xgmax,ygmin,ygmax;
{  
/* Controllo delle condizioni di errore */
   if((xgmin>=xgmax) || (ygmin>=ygmax))
   {  lgerr(LGE_ESTREMIARGR);
      return(LGE_ESTREMIARGR);
   }
   if((xgmin<0.) || (xgmax>lgbc2d.g2lim[MIZ_GRAFPAG][1]) ||
   	(ygmin<0.) || (ygmax>lgbc2d.g2lim[MIZ_GRAFPAG][3]))
   {  lgerr(LGE_AREAGRAF);
      return(LGE_AREAGRAF);
   }
/* Definisce l'area */
   lgbc2d.g2lim[MIZ_GRAFAGR][0]=xgmin;
   lgbc2d.g2lim[MIZ_GRAFAGR][1]=xgmax;
   lgbc2d.g2lim[MIZ_GRAFAGR][2]=ygmin;
   lgbc2d.g2lim[MIZ_GRAFAGR][3]=ygmax;
/* Chiede di definire i coefficienti di trasformazione */
   lgbc2d.kcodef=FALSE;
   return(0);
}
/* Sottoprogramma grmov */
INT grmov(gx,gy)
double gx,gy;
{  lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(gx,gy,MIZ_MOV));
}
/* Sottoprogramma grseg */
INT grseg(gx,gy)
double gx,gy;
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(gx,gy,MIZ_SEG));
}
/* Sottoprogramma grpun */
INT grpun(gx,gy)
double gx,gy;
{  lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(gx,gy,MIZ_PUN));
}
/* Sottoprogramma grsim */
INT grsim(gx,gy)
double gx,gy;
{  lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(gx,gy,MIZ_SIM));
}
/* Sottoprogramma grtrt */
INT grtrt(gx,gy)
double gx,gy;
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(gx,gy,MIZ_TRA));
}
/* Sottoprogramma grtra */
INT grtra(gx,gy,motr)
double gx,gy;
INT motr[];
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   lgbc2d.kgrut=MIZ_GRAFPAG;
   if(motr[0]!=0) deftrt(motr);
   return(lgplot(gx,gy,MIZ_TRA));
}
/* Sottoprogramma grmovr */
INT grmovr(gx,gy)
double gx,gy;
{  lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(lgbc2d.g2ult[MIZ_GRAFPAG][0]+gx,
   		lgbc2d.g2ult[MIZ_GRAFPAG][1]+gy,MIZ_MOV));
}
/* Sottoprogramma grsegr */
INT grsegr(gx,gy)
double gx,gy;
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(lgbc2d.g2ult[MIZ_GRAFPAG][0]+gx,
   		lgbc2d.g2ult[MIZ_GRAFPAG][1]+gy,MIZ_SEG));
}
/* Sottoprogramma grpunr */
INT grpunr(gx,gy)
double gx,gy;
{  lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(lgbc2d.g2ult[MIZ_GRAFPAG][0]+gx,
   		lgbc2d.g2ult[MIZ_GRAFPAG][1]+gy,MIZ_PUN));
}
/* Sottoprogramma grsimr */
INT grsimr(gx,gy)
double gx,gy;
{  lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(lgbc2d.g2ult[MIZ_GRAFPAG][0]+gx,
   		lgbc2d.g2ult[MIZ_GRAFPAG][1]+gy,MIZ_SIM));
}
/* Sottoprogramma grtrtr */
INT grtrtr(gx,gy)
double gx,gy;
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   lgbc2d.kgrut=MIZ_GRAFPAG;
   return(lgplot(lgbc2d.g2ult[MIZ_GRAFPAG][0]+gx,
   		lgbc2d.g2ult[MIZ_GRAFPAG][1]+gy,MIZ_TRA));
}
/* Sottoprogramma grtrar */
INT grtrar(gx,gy,motr)
double gx,gy;
INT motr[];
{  if(lgbc2d.kgrut!=MIZ_GRAFPAG) lgagrn(MIZ_GRAFPAG);
   lgbc2d.kgrut=MIZ_GRAFPAG;
   if(motr[0]!=0) deftrt(motr);
   return(lgplot(lgbc2d.g2ult[MIZ_GRAFPAG][0]+gx,
   		lgbc2d.g2ult[MIZ_GRAFPAG][1]+gy,MIZ_TRA));
}
/* Sottoprogramma deftrt */
INT deftrt(modo)
INT modo[];
{  int i,k;
   int kret=0;
   k=modo[0]%128;
   if(k==0) return(kret);
   for(i=0;i<MIZ_L_MOTRA;i++)
   {  lgbcge.ktratt[i]=modo[i]%128;
      if(lgbcge.ktratt[i]==0) break;
   }
   if(i==MIZ_L_MOTRA)
   {  lgerr(LGE_TRATTEGGIO);
      kret=LGE_TRATTEGGIO;
      lgbcge.ktratt[MIZ_L_MOTRA-1]=0;
   }
#if MIZ_FILE
   lgwmtr();
#endif
   return(kret);
}
