#include <time.h>
/* Parametri di controllo dell'interfaccia col periferico */

#define ICP_INIT 0
#define ICP_INIDATA -3
#define ICP_SVUOTA -2
#define ICP_FINE -1
#define ICP_PAGINA 1
#define ICP_PNGIU 1
#define ICP_PNSU -1

/* Blocco di definizione dei parametri per l'interprete.  Questo blocco contiene tutte le
   informazioni necessarie per la gestione delle coordinate fisiche da parte della
   libreria.  

   L'inizializzazione di queste variabili e' nel file $(MIZAR)/util/mizdat.c. I dati
   inizializzati vengono letti dal file di inizializzazione mizar.dat.  La lettura e'
   compito dei sottoprogrammi di interfaccia col periferico.
 */
struct lggraf {
  DOUBLE dlim[2];	/* Limiti correnti dell'area fisica */
  DOUBLE dflim[2];	/* Limiti di default per la pagina in U.G. */
  DOUBLE dimug[2];	/* Rapporto unita' fisica/unita' grafica */
  DOUBLE dlimps[10][2];	/* Tabella limiti della pagina */
  DOUBLE pfin[2];	/* Posizione finale della penna */
  struct timespec req;  /* Strutture dati per attesa animazione, se serve */
  struct timespec rem;  /*  */
  int marg[2];		/* Margine tra pagine successive per plotter */
  int knpen;		/* Numero massimo di penne */
  int knpndf;		/* Numero di penne di default */
  int kstpn;		/* Stato corrente della penna */
  int klimpg;		/* Indice dei limiti di pagina in uso (opz. DIM) */
  int lprmo;		/* Lunghezza stringa stprmo */
  int lprmg;		/* Lunghezza stringa stprmg */
  int lnom;		/* Lunghezza stringa nomint */
  int lnmoug;		/* Lunghezza stringa nomoug */
  int quality;		/* Indice di qualita' per gli interpreti tipo jpg */
  int qltmin;		/* Minimo per l'indice di qualita' */
  int qltmax;		/* Massimo per l'indice di qualita' */
  char stprmo[12];	/*  */
  char stprmg[40];	/* Stringa di prompt per inizio pagina */
  char nomint[20];	/* Nome dell'interprete */
  char nomoug[60];	/* Nome del file di output */
  char prompg;		/* Abilita il prompt di inizio pagina */
  char prompt;		/* Scrivi una stringa di prompt per inizio pagina */
  char bell;		/* Abilita il cicalino per inizio pagina */
  char spool;		/* Abilita lo spooling automatico del file */
  char posfin;		/* Abilita posizionamento finale della penna */
  char ougsep;		/* Abilita lo spooling separato delle pagine */
  char punsim;		/* Sostituire il punto con un simbolo */
  char batch;		/* Esecuzione in modo batch */
  char ansi_term;	/* Il terminale riconosce le sequenza ansi standard */
  char tek_term;	/* Il terminale e' di tipo Tektronix a persistenza */
  char anim;	        /* Abilita l'animazione */
  char last_page;       /* Flag che segnala l'ultima pagina di output (chiamata a fine) */
};
