/* <istogr> : 
Sottoprogramma per il tracciamento di istogrammi
 */
#include <stdio.h>
#include <math.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
#define PRECMC 1.e-6
/* Sottoprogramma istogr */
int istogr(DOUBLE *dati, LONG ndati, DOUBLE *rdint, INT nint, INT imodo,
	   LONG *itot, LONG *ibuoni, DOUBLE xmin, DOUBLE xmax, DOUBLE ymin, DOUBLE ymax,
	   char *testx, int ntestx,char *testy, int ntesty)
{
  DOUBLE gxmin,gxmax,gymin,gymax;
  DOUBLE x,deltax,ddx,tmp;
  INT i,k;
  if(nint <= 0) {
    lgerr(IST_WRNGNINT);
    return(IST_WRNGNINT);
  }
  if(ndati<=0) {
    if((imodo&3)==0) {
      lgerr(IST_ARUTNONDEF);
      return(IST_ARUTNONDEF);
    }
  }
				/* Controlla se prendere 
				   gli estremi dall'area utente */
  if((imodo&1)!=0) {
    gxmin=lgbc2d.g2lim[MIZ_UTENTE][0];
    gxmax=lgbc2d.g2lim[MIZ_UTENTE][1];
    gymin=lgbc2d.g2lim[MIZ_UTENTE][2];
    gymax=lgbc2d.g2lim[MIZ_UTENTE][3];
  }
  else
    gymin=0.;
				/* Definisce gli estremi per X */
  if((imodo&2)!=0) {
    gxmin=xmin;
    gxmax=xmax;
  }
  else 
    lgfmm(dati,ndati,&gxmin,&gxmax);
  if((deltax=gxmax-gxmin)<=0.) {
    lgerr(IST_WRXMINMAX);
    return(IST_WRXMINMAX);
  }
  ddx=deltax/nint;
				/* Calcola i dati per l'istogramma */
  if((imodo&512)==0) {
    *itot = *ibuoni = 0;
    for(i=0;i<nint;rdint[i++]=0.);
  }
  if(ndati>0) {
    for(i=0;i<ndati;i++) {
      tmp = (x=(PRECMC+dati[i]-gxmin)/ddx)-nint;
      if(tmp > 0. && tmp <= (nint*PRECMC)) x=nint-1;
      //      if(tmp > 0. && tmp <= PRECMC) x=nint-1;
      k=x;
      if(k>=0 && k<nint) {
	rdint[k]+=1.;
	(*ibuoni)++;
      }
    }
    *itot += ndati;
  }
  if((imodo&64)!=0) return(0);	/* Se non e' richiesto il
                                   tracciamento, rientra. */
  gymax = ((imodo&32)==0)? *itot : *ibuoni;
  if((imodo&16)!=0) {
    for(i=0;i<nint;rdint[i++]/=gymax);
    gymax=1.;
  }
				/* Determina gymin e gymax */
  if((imodo&1)==0) {
    if((imodo&4)!=0) {
      gymin=ymin;
      gymax=ymax;
    }
    else if((imodo&8)==0){
      DOUBLE y;
      lgfmax(rdint,nint,&y);
      y*=1.05;
      gymax=MIN(y,gymax);
    }
  }
				/* Procede al tracciamento */
  if((imodo&1)==0)  utarea(gxmin,gxmax,gymin,gymax);
  if((imodo&128)==0) {
    if((imodo&256)==0) quadro(testx,ntestx,testy,ntesty);
    else quadre(testx,ntestx,testy,ntesty);
  }
  utmov(gxmin,gymin);
  x=gxmin;
  for(i=0;i<nint;i++) {
    utseg(x,rdint[i]);
    x=gxmin+(i+1)*ddx;
    utseg(x,rdint[i]);
  }
  utseg(gxmax,gymin);
  return(0);
}


