#if MIZ_COMPLETA
#define MIZ_FILE 1
#define MIZ_INTERATTIVA 1
#endif
#ifndef MIZ_FILE
#define MIZ_FILE 0
#endif
#ifndef MIZ_INTERATTIVA
#define MIZ_INTERATTIVA 0
#endif
#ifndef MIZ_INTERPRETE
#define MIZ_INTERPRETE 0
#endif
/*  */
/* Parametri dipendenti dalla macchina */
#define N_BIT_CH 8
                        /* Numero di bit in una variabile di tipo char. */
                        /* Di solito e` 8, ma chi si fida? (vedi UNIVAC 1100) */
#define MAX_FILE_RECORDS 0x01FFFFFF
                        /* Numero massimo di records in un file.  Non voglio 
			   superare 4 Gygabyte per evitare problemi di puntatori */
/*  */
/* Parametri generali della libreria */
#define MIZ_LUNHEAD 64
   			/* Lunghezza header di file dati in int */
#define MIZ_FGRBUF 256
   			/* Lunghezza buffer di gestione file grafico */
#define MIZ_S_EXITCODE 0
#define MIZ_W_EXITCODE 1
#define MIZ_E_EXITCODE 2
#define MIZ_F_EXITCODE 3
   			/* Codici di successo/errore restituiti */
/*  */
/* Parametri relativi alla struttura del file di dati */
#define HDR_V_BYTECNTR '\001'
#define HDR_BYTECNTR 0
   			/* Posizione byte di controllo */
#define HDR_V_BYTESTAT '\377'
#define HDR_BYTESTAT 1
   			/* Posizione byte di stato */
#define HDR_NOME 2
   			/* Posizione scritta MiZaR\000 */
#define HDR_L_NOME 6
   			/* Lunghezza scritta MiZaR\000 */
#define HDR_VERS HDR_NOME+HDR_L_NOME
   			/* Posizione versione */
#define HDR_L_VERS 2
   			/* Lunghezza campo versione */
#define HDR_SITEID HDR_VERS+HDR_L_VERS
   			/* Posizione identificatore installazione */
#define HDR_L_SITEID 10
   			/* Lunghezza identificatore installazione */
#define HDR_CRTIM HDR_SITEID+HDR_L_SITEID
   			/* Posizione data e ora di creazione */
#define HDR_L_CRTIM 6
   			/* Lunghezza data e ora di creazione */
#define HDR_MDTIM HDR_CRTIM+HDR_L_CRTIM
   			/* Posizione data e ora ultima modifica */
#define HDR_L_MDTIM 6
   			/* Lunghezza data e ora ultima modifica */

/* Parametri relativi alla struttura dell'header del file grafico.
   I campi fino a HFG_HDRINFO sono copia dell'header del file dati.
   Seguono le altre informazioni. */
/* Struttura del file grafico
   Offset		Contenuto
   HDR_BYTECNTR		Byte di controllo (contenuto fisso)
   HDR_BYTESTAT 	Byte di stato (tipo installazione, ecc...)
   HDR_NOME 		Scritta ``MiZaR'' terminata da NULL
   HDR_VERS		Versione della libreria
   HDR_SITEID 		Identificatore installazione
   HDR_CRTIM 		Data e ora di creazione del file dati
   HDR_MDTIM 		Data e ora dell'ultima modifica al file dati
   HFG_HDRINFO 		Inizio dati propri
   HFG_ORADAT		Data e ora di creazione del file grafico
   HFG_FREEZONE		Spazio non utilizzato, riservato per il futuro
   HFG_L_FREEZONE	Lunghezza dello spazio non utilizzato
   HFG_CLOSEINF		Informazioni di chiusura
 */
#define HFG_HDRINFO HDR_MDTIM+HDR_L_MDTIM
      			/* Lunghezza campo da riportare in FGR */
#define HFG_CRTIM HFG_HDRINFO 
   			/* Data o ora di creazione */
#define HFG_L_CRTIM 6
   			/* Lunghezza campo data e ora */
#define HFG_FREEZONE HFG_CRTIM+HFG_L_CRTIM
   			/* Indirizzo area libera, riservata per il futuro */
#define HFG_CLOSEINF MIZ_FGRBUF-10
   			/* Offset delle informazioni di chiusura record */
#define HFG_L_FREEZONE HFG_CLOSEINF-HFG_FREEZONE
   			/* Lunghezza area libera */
#define HFG_NUMREC HFG_CLOSEINF
   			/* Numero di record */
#define HFG_NUMPAG HFG_NUMREC+4
   			/* Numero di pagine */
#define HFG_CLOSTA HFG_NUMPAG+4
   			/* Stato di chiusura */

/* Parametri relativi ai messaggi ed alla gestione degli errori */
#define MSG_LUNID 15
   			/* Lunghezza identificatore messaggi */
#define MSG_LUNTXT 127
   			/* Lunghezza massima testo del messaggio */
#define EST_CODERR 0140000
	    		/* Maschera livello errore */
#define EST_STAMPAMSG 020000
	    		/* Stampa messaggio in caso di errore */
#define EST_CONTAERR 010000
	    		/* Abilita conteggio errori */
#define EST_STPRIMOER 04000
	    		/* Stampa solo al primo errore */
#define EST_NUMMSGERR 03777
	    		/* Numero messaggio corrispondente al codice errore */
#define MSG_LETTDAT 'D'
   			/* Richiesta dati, o scritta senza a capo */
#define MSG_N_LETTDAT -2
#define MSG_TESTO 'T'
   			/* Testo con a capo, senza identificatori */
#define MSG_N_TESTO -1
#define MSG_INFORM 'I'
   			/* Messaggio informativo */
#define MSG_N_INFORM 0
#define MSG_WARNING 'W'
#define MSG_N_WARNING 1
#define MSG_C_WARNING 0
   			/* Warning */
#define MSG_MAXCONT 'C'
#define MSG_N_MAXCONT 2
#define MSG_C_MAXCONT 040000
   			/* Errore soggetto a controllo sul conteggio */
#define MSG_ERRORE 'E'
#define MSG_N_ERRORE 3
#define MSG_C_ERRORE 0100000

   			/* Errore grave */
#define MSG_FATALE 'F'
#define MSG_N_FATALE 4
#define MSG_C_FATALE 0140000
   			/* Errore fatale */

/* Parametri relativi a sottoprogrammi di tracciamento */
#define MIZ_NUMCIFPREC 15
   			/* Numero di cifre di precisione in rappr. double */
#define MIZ_LIVPREC 21
   			/* Numero livelli precisione */
#define MIZ_MINPREC 0.1
   			/* Passo minimo (precisione massima) */
#define MIZ_MAXPREC 10.
   			/* Passo massimo (precisione minima) */
#define MIZ_L_MOTRA 11
   			/* Lunghezza vettore definizione tratteggio */
#define MIZ_TABOR 33
   			/* Num. posizioni tabulazione orizzontale */
#define MIZ_TABVER 33
   			/* Num. posizioni tabulazione verticale */
#define MIZ_CARMX 255
      			/* Numero di simboli centrati  */
#define MIZ_DSIMX 255.	
   			/* Dimensione massima dei caratteri */
#define MIZ_SPOMX 255
   			/* Massima spaziatura orizzontale caratteri */
#define MIZ_SPVMX 255
   			/* Massima spaziatura verticale caratteri */
#define MIZ_SPOMI 7
   			/* Minima spaziatura orizzontale caratteri */
#define MIZ_SPVMI 14
   			/* Minima spaziatura verticale caratteri */
#define MIZ_FTDSIM .75
   			/* Fattore riscalamento caratteri per apici, ... */
#define MIZ_DYLIV 10.
	 		/* Unita' gr. per alza/abbassa caratteri */
#define MIZ_FTSIM 8192.	
   			/* Fattore codifica dim. e rot. simboli */
#define MIZ_MAXDST 1023.
   			/* Fattore distorsione massimo per caratteri */
#define MIZ_NUMPEN 255
   			/* Numero massimo di penne */
#define MIZ_L_DIMCAR 21
   			/* Numero livelli di dimensioni caratteri */ 
#define MIZ_LD_DIMCAR 10
   			/* Livello default di dimensione dei caratteri */
#define MIZ_NUMALF 8
   			/* Numero alfabeti disponibili (sovradimensionato) */
#define MIZ_NUMALFC 8
   			/* Numero alfabeti correnti */
#define MIZ_L_KRBRKP 40
   			/* Numero massimo di breakpoint previsti */
#define MIZ_MAXERRCONT 10
   			/* Numero massimo di errori ammessi in caso di 
   								conteggio */
#define MIZ_GRAFPAG 0
	 		/* Coordinate grafico con taglio sulla pagina */
#define MIZ_GRAFAGR 1
	 		/* Coordinate grafico con taglio su area grafica */
#define MIZ_UTENTE 2
	 		/* Coordinate utente con taglio su area utente */
#define MIZ_CLINEARI 1
   			/* Coordinate lineari */
#define MIZ_XLOGYLIN 2
   			/* Asse x logaritmico, asse y lineare */
#define MIZ_XLINYLOG 3
   			/* Asse x lineare, asse y logaritmico */
#define MIZ_CLOG 4
   			/* Assi logaritmici */
#define MIZ_CPOL 5
   			/* Coordinate polari */
#define MIZ_CRDMX 255
   			/* Massimo codice coordinate */
#define MIZ_MOV 0
   			/* Spostamento a penna alzata */
#define MIZ_SEG 1
   			/* Spostamento a penna abbassata (segmento) */
#define MIZ_PUN 2
   			/* Punto */
#define MIZ_SIM 3
   			/* Tracciamento di un simbolo */
#define MIZ_TRA 4
   			/* Tratteggio */
#define MIZ_MSGBUF 128
   			/* Buffer per la memorizzazione di messaggi utente */

/* Parametri di comando per la codifica su file grafico.
   Ai comandi e' associata la tabella lgcmop, dichiarata e inizializzata nel 
   file MIZCMN.C, cosi' definita:
     i.	dimensione MIZ_CMMAX
    ii.	contenuto:
   	-1 se il comando non esiste;
   	 0 se alla lista di specifica non deve essere aggiunto nessun 
   	   carattere terminatore;
   	 1 se la lista di specifica deve essere chiusa (prima dell'inserimento
   	   del comando successivo) con il carattere MIZ_TERMLIST ('\377');
   	 2 se la lista di specifica deve essere chiusa dal carattere NUL;
   	 3 se dopo l'inserimento del comando il record deve essere scritto su 
   	   file anche se incompleto (tipicamente, alla chiusura della pagina).
   Per aggiungere nuovi comandi:
     i. definire il codice tra quelli liberi;
    ii. aggiornare l'inizializzazione delle tabella lgcmop.
 */
#define MIZ_CMMAX 63
   			/* Numero massimo di comandi */
#define MIZ_TERMLIST '\377'
   			/* Terminatore di lista di coordinate o simili */
#define MIZ_PGDEF '\001'
   			/* Definizione estremi pagina */
#define MIZ_PGINI '\002'
   			/* Inizio nuova pagina */
#define MIZ_PGFIN '\003'
   			/* Fine pagina corrente */
#define MIZ_CMNOP '\005'
   			/* Nessuna operazione */
#define MIZ_CMMSG '\006'
   			/* Stringa di messaggio */
#define MIZ_FLEOF '\007'
   			/* Fine ultima pagina del file grafico */
#define MIZ_PNMOV '\010'
   			/* Movimento a penna alzata */
#define MIZ_PNSEG '\011'
   			/* Tracciamento di un segmento */
#define MIZ_PNPUN '\012'
   			/* Tracciamento di un punto */
#define MIZ_PNSIM '\013'
   			/* Tracciamento di un simbolo centrato */
#define MIZ_PNTRA '\014'
   			/* Tracciamento di un segmento tratteggiato */
#define MIZ_DFTRA '\015'
   			/* Modalita di tratteggio */
#define MIZ_DFSIM '\016'
   			/* Simbolo centrato */
#define MIZ_PNCTR '\017'
   			/* Scelta penna */
#define MIZ_DFDMR '\020'
   			/* Dimensioni e angolo di rotazione caratteri */
#define MIZ_DFALF '\021'
   			/* Ordine alfabeti */
#define MIZ_STRCR '\022'
   			/* Stringa di caratteri software */
#define MIZ_DFTBO '\023'
   			/* Posizioni di tabulazione orizzontale */
#define MIZ_DFTBV '\024'
   			/* Posizioni di tabulazione verticale */
#define MIZ_DFSPO '\025'
   			/* Spaziatura orizzontale tra caratteri */
#define MIZ_DFSPV '\026'
   			/* Spaziatura verticale tra righe */
#define MIZ_DFMAR '\027'
   			/* Margini della pagina */
#define MIZ_DFDST '\030'
   			/* Distorsione caratteri */
#define MIZ_DFRYX '\031'
   			/* Rapporto Y/X tra dimensioni caratteri */
#define MIZ_ENDPR '\032'
   			/* Fine registrazione dei parametri correnti */
#define MIZ_FLEOE '\077'
   			/* Ultima pagina chiusa per errore fatale */
/*  */
/* Parametri e struttura dati per l'allocazione dinamica di memoria */
#define MIZ_MAXALLOCMEM 1048576L
                        /* Memoria massima allocabile in bytes */
union memadr {
  char   *charadr;
  int    *intadr;
  long   *longadr;
  float  *floatadr;
  double *doubleadr;
};
/*  */
/* Costanti */
#define TRUE 1
#define FALSE 0
/*  */
/* Codice dei caratteri di controllo (in ottale) */
#define NUL '\000'
#define TAB '\011'
#define LF '\012'
#define FF '\014'
#define CR '\015'
#define BEL '\007'
#define CTRLD '\004'
#define CTRLZ '\032'
#define ESC '\033'
#define BLANK '\040'
#define CCONTR '\000'
#define CRESET '\001'
#define CAPICE '\002'
#define CPEDIC '\003'
#define CALZA '\004'
#define CABBAS '\005'
#define CCTPED '\006'
#define CCTAPI '\007'
#define CBS '\010'
#define CTABOR '\011'
#define CLFEED '\012'
#define CTABVE '\013'
#define CFF '\014'
#define CCR '\015'
#define CLFINV '\016'
#define CCRLF '\017'
#define CALATI '\020'
#define CAGREC '\021'
#define CASPEC '\022'
#define CAMAIU '\030'
#define CAMINU '\031'
#define CDIMIN '\036'
#define CAUMEN '\037'
/*  */
/* Header del file dati.
   I primi HFG_HDRINFO bytes di questo header vengono riportati in
   testa al file grafico. */
/*  */
struct hdr {  
  unsigned char cntsta[2];		   /* Bytes di controllo e stato */
  char nome[HDR_L_NOME];		   /* Scritta MiZaR */	
  unsigned char vers[HDR_L_VERS];	   /* Versione */
  unsigned char siteid[HDR_L_SITEID];      /* Identificatore installazione */
  unsigned char crtim[HDR_L_CRTIM];	   /* Data e ora di creazione */
  unsigned char mdtim[HDR_L_MDTIM];	   /* Data e ora di modifica */
  unsigned int subver;	        /* Numero sottoversione per debugging */
  int nmsg;			/* Numero messaggi presenti */
  int nmer;			/* Numero messaggi di errore */
  long int icpmas;		/* Maschera interpreti */
  long int tabmad;		/* Indirizzo tabella messaggi */
  long int lgbccs;		/* Indirizzo blocco lgbccs */
  long int lgbcge;		/* Indirizzo blocco lgbcge */
  long int lgbc2d;		/* Indirizzo blocco lgbc2d */
  long int lgbcsa;		/* Indirizzo blocco lgbcsa */
  long int lgfile;		/* Indirizzo blocco lgfile */
  long int lgbccf;		/* Indirizzo blocco lgbccf */
  long int lgbcpn;		/* Indirizzo blocco lgbcpn */
  long int lgbcsg;		/* Indirizzo blocco lgbcsg */
  long int lgbccr;		/* Indirizzo blocco lgbccr */
  long int lgbcfi;		/* Indirizzo blocco lgbcfi */
  long int lgbcer;		/* Indirizzo blocco lgbcer */
      			/* ATTENZIONE! il blocco lgbcer deve essere l'ultimo
      			   blocco di interesse generale memorizzato sul file 
      			   dati.  Ricorda che la lunghezza di questo blocco 
      			   e' determinata dal numero di messaggi di errore.
      			   Dopo questo blocco vengono memorizzati SOLO i 
      			   blocchi dati degli interpreti.       */
  long int bldtty;	        /* tty - serve solo per debugging       */
  long int bldpos;	        /* pos - interprete PostScript          */ 
  long int bldtek;	        /* tek - interprete Tektronix 4010      */
  long int bldtps;	        /* tps - produce un file PostScript da 
				  inserire in TeX */
  long int bldbps;		/* bps - produce un file PostScript in
				   formato bitmap                       */
  long int bldfgf;		/* fgf - interprete GIF */
  long int bldjpg;		/* jpg - interprete JPEG */
  long int bldpng;		/* png - interprete PNG */
  long int bldgif;		/* gif - interprete GIF */
  long int bldx11;		/* x11 - interprete X11 */
  /*       long int bldvga; */
  /*       long int bldhpl; */
  /*       long int bldhpj; */
  long int freead;	/* Primo indirizzo libero, per la memorizzazione 
      			   di blocchi dati degli interpreti. */
};
union mizhdr
{  unsigned int hdri[MIZ_LUNHEAD];
   struct hdr hdr;
};
/*  */
/* Blocco costanti */
struct lgbccs
{  double pigrec;		/* Pi greco */
   double angiro;		/* Angolo giro nelle unita' correnti */
   double grarad;		/* Conversione gradi -> radianti */
   double radgra;		/* Conversione radianti -> gradi */
   double precis[MIZ_LIVPREC];	/* Parametri di precisione per curve */
};
/*  */
/* Blocco variabili comuni di utilita' generale */
struct lgbcge
{  double plim[2];		/* Limite massimo della pagina */
   double pult[2];		/* Ultima posizione logica della penna */
   double pcoef[2];		/* Coefficienti di conversione per FGR */
   int kpag;			/* Numero corrente di pagina */
   int kcmult;			/* Ultimo codice di comando memorizzato */
   int ktratt[MIZ_L_MOTRA];	/* Modalita' corrente di tratteggio */
   char kanrad;			/* Unita' corrente di misura angoli (logico) */
   char kcmap;			/* Comando aperto, da chiudere con \000 */
   char kersta;			/* Abilita stampa messaggi di errore */
   UNSCHAR penna;		/* Penna logica in uso */
};
/*  */
/* Blocco delle unita' di I/O */
struct lgbcio
{  FILE *kuninp;		/* Lettura dati (terminale) */
   FILE *kunout;		/* Output dati (terminale) */
   FILE *kunerr;		/* Output messaggi di errore */
   FILE *kunmiz;		/* File dati MiZaR */
   FILE *kungr;			/* File grafico */
   FILE *kuning;		/* Input dati grafici (cursore) */
   FILE *kunoug;		/* Output dati grafici (tracciamento) */
   FILE *kuntmp;		/* Unita' temporanea */
};
/*  */
/* Blocco dati per grafica 2D */
struct lgbc2d
{  double g2lim[4][4];		/* Limiti delle aree grafiche */
   double g2ult[4][2];		/* Ultima posizione penna */
   double co2ug[2];		/* Conversione utente -> grafico */
   double co2gu[2];		/* Conversione grafico -> utente */
   double dimsp;	        /* Dimensioni correnti simbolo centrato */
   double rotsp;	        /* Rotazione corrente simbolo centrato */
   double cosp;			/* Coseno angolo rotazione */
   double sesp;			/* Seno angolo rotazione */
   int kerpnf[4];		/* Codici di errore per penna fuori area */
   int kcmplo[5];		/* Codici di movimento penna in FGR */
   int kp2ult[4];		/* Posizione della penna rispetto all'area */
   char kgrut;			/* Area corrente */
   char kcoord;			/* Coordinate correnti */
   char kcodef;			/* Parametri di conversione definiti */
   UNSCHAR  knsp;		/* Codice simbolo centrato corrente */
};
/*  */
/* Blocco gestione stringhe di caratteri (generale) */
struct lgbcsa
{  double tbor[MIZ_TABOR];	/* Posizioni tabulazione orizzontale */
   double tbver[MIZ_TABVER];	/* Posizioni tabulazione verticale */
   double dstmax;		/* Massima distorsione ammessa */
   double dstfat;		/* Fattore di distorsione */
   double dimsim;		/* Dimensione corrente caratteri */
   double rotsim;		/* Angolo di rotazione scritta */
   int kspor;			/* Spaziatura orizzontale */
   int kspver;			/* Spaziatura verticale */
   int kalf;			/* Alfabeto corrente */
   unsigned char ksim;		/* Simbolo corrente da tracciare */
};
/*  */
/* Blocco di gestione dei messaggi */
struct lgbcms
{  long int admsg;
   char livmsg;
   char idmsg[MSG_LUNID+1];
   char txtmsg[MSG_LUNTXT+1];
};
/*  */
/* Blocco di gestione degli errori */
struct itemer
{  int stato;
   int cont;
};
struct lgbcer
{  int kerult;				/* Codice ultimo errore */
   struct itemer errve[MIZ_NUMMSGERR];	/* Tabella gestione */
};
/*  */
/* Blocco per tracciamento stringhe di caratteri */
struct lgbcsg
{  double dimcar[MIZ_L_DIMCAR];
   double corot;
   double serot;
   double dftsc[2];
   double dstsim;
   double delxy[2];
   double pagmar[4];
   int kliv;
   int koralf[MIZ_NUMALF];
   int kalfu;
   int kpctbo;
   int kpctbv;
   int kpnsim;
   char minusc;
   char kanzer;
};
/*  */
#if MIZ_FILE
/* Blocco di gestione del file grafico */
struct lgfile
{  long int krpun;
   long int krec;		        /* Puntatore al primo record da scrivere */
   long int krulpg;		        /* Puntatore al record inizio pagina corr. */	
   long int krulbr;
   long int krbrkp[MIZ_L_KRBRKP];	/* Breakpoints */
   int kbf;		                /* Puntatore all'ultimo carattere riempito */
   unsigned char kgrbf[MIZ_FGRBUF];	/* Record per buffering dei comandi */
};
#endif
/*  */
#if MIZ_INTERATTIVA
/* Blocco parametri di conversione a coordinate fisiche */
struct lgbccf
{  double flim[4];
   double fcen[2];
   double fatscf[2];
   double cfsc[2];
   double gflim[4];
   double gfcen[2];
   double fatscg[2];
   double dgfcen[2];
   double delgf[2];
   double delf[2];
   double cogf[2][2];
   double cofg[2][2];
   double gfult[2];
   double fvult[2];
   double fult[2];
   double rotgf;
   double crotgf;
   double srotgf;
   double dtrt;
   double persvr;
   double dimpun;
   double rotpun;
   double copun;
   double sepun;
   double simxy[2];
   int kfvult;
   int kmprz;
   int kopult;
   int itrt;
   int npx;
   int npy;
   int kspun;
   char kcgfdf;
};
/*  */
/* Blocco di gestione delle penne */
struct lgbcpn
{  int kvstpn;
   int kpenna[MIZ_NUMPEN];
   int lpnlog;
   char pendis;
};
/*  */
/* Blocco di codifica dei caratteri */
struct lgbccr
{  int kindcr[256];
   unsigned char kposcr[256];
   unsigned char kinfcr[2104];
};
#endif
/*  */
