#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#include "icpcmn.h"
/* Dichiarazioni */
int lgcpst(char *str,char *buf,int maxc);
void lgdcmp(double *x,int k);
void lgord(double *x,double *y,int n);
void lglepg(void );
void lgspm(int k);
void lgtab(int k);
void lgswan(void );
void lgsalf(void );
void lgldrs(void );
void lgdfs(void );
void lglpen(void );
void lgcnpn(int k);
void lglmtr(void );
void lgmes(void );
int lgdcom(void );
int lgcflg(void );
int lgtpag(int n);
int lgppag(void );
void lglegf(void );
int lgcar(void );
int lg2cti(unsigned char *cb);
long lg4ctl(unsigned char *cb);
int lgapre(void );
int lgdpnu(char *buf,int kin,int kfi);
int lgdpun(char *buf,int kin,int kfi);
int lgdtbr(char *buf,int kin,int kfi,double *x,int n);
int lgvrfs(char *buf,int kcar,unsigned char *vf);
void lgopz(void );
INT noansi_lgrdst(CHAR buf[],int nb,CHAR *ctrm);
/*  */
#define INT_USCITA -1
#define INT_OPZIONI -2
#define INT_TRACCIA -3
#define INT_ERRPAG -4
#define INT_CONTINUA -5
#define INT_NGBUF 200
#define FERR_OPZIONI -1
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern unsigned char lgcmop[MIZ_CMMAX];
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lgbccr lgbccr;
extern struct lggraf lggraf;
/*  */
struct lgfile lgfile={0};
/*  */
struct lgbcfi {
  long int kpgmax;
  long int krcult;
  long int krulbf;
  char nomfil[256];
  unsigned char nomess;
  unsigned char filopn;  
} lgbcfi;
struct lgbcbc {
  double xbuf[INT_NGBUF];
  double ybuf[INT_NGBUF];
  char msgbuf[MIZ_MSGBUF];
  unsigned char kcofi;
  unsigned char kcopt;
} lgbcbc;
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
int main(narg,argv)
     int narg;
     char *argv[];
/*
   Libreria grafica

		M  i  Z  a  R

   Main del programma interprete.
*/
{  
  unsigned char tmp[2];
  unsigned char eof=FALSE;
  char *mizar_lib;
  int i, lname;
  int ks=INT_OPZIONI;
				/* Lettura dati di inizializzazione da file */
  mizar_lib = getenv("MIZAR");
  lname=0;
  while(mizar_lib[lname++] != NUL);
  lname += 16;
  {
    char filnam[lname];
    sprintf(filnam,"%s/mizar.dat",mizar_lib);
    lgbcio.kunmiz=fopen(filnam,"rb");
    if(lgbcio.kunmiz==0) lgwmsg(-1);
  }
  fread(&mizhdr,sizeof(union mizhdr),1,lgbcio.kunmiz);
  lginit();			/* Inizializzazione aree comuni */
  lgbcbc.kcofi=FALSE;
  lgbcbc.kcopt=FALSE;
  lgbcfi.nomess=FALSE;
  lgbcfi.krcult=0;
  lgbcfi.krulbf=0;
  lgbcfi.filopn=FALSE;
  if(narg>1) lgcpst(argv[1],lgbcfi.nomfil,256);
  else lgcpst("grafic.dat",lgbcfi.nomfil,256);
  lgwmsg(MIZ_ICPIDENT,lggraf.nomint);
  deferr(FGR_OPENERR,MSG_MAXCONT,1,1);
 vai:
  switch(ks) {
  case INT_OPZIONI:
    if(lgbcge.kpag>0) lgpag(ICP_FINE);
    i=1;
    while(i>0 && i<4) {
      lgopz();
      if(!lgbcfi.filopn) {
	i=lgapre();
	eof=FALSE;
      }
      else {
	i=0;
      }
    }
    ks=lgppag();
    lgpag(ICP_INIT);			/* Inizializzazione perif. */
    lggraf.kstpn=MIZ_NUMPEN+1;
    goto vai;
  case INT_CONTINUA:
    if(eof) break;
  case INT_TRACCIA:
    lgfile.krulpg=lgfile.krec;
    lglegf();
    i=lgcar();
    if(i!=2) lgerr(FGR_RECORDINIPG);
    tmp[0]=lgcar();
    tmp[1]=lgcar();
    lgbcge.kpag=lg2cti(tmp);
    ks=lgcflg();
    if((eof=(ks==MIZ_FLEOF)) || (ks==MIZ_FLEOE)) {
      if(lggraf.anim) lggraf.last_page=TRUE;
    }
    if(ks>0) ks=lgppag();
    if(lggraf.anim) lggraf.last_page=FALSE;
    goto vai;
  case INT_ERRPAG:
    ks=lgppag();
    goto vai;
  case INT_USCITA:
    break;
  }
  lgpag(ICP_FINE);
  exit(0);
}
/*  */
int lgcpst(str,buf,maxc)
     char *str;
     char buf[];
     int maxc;
{
  int i=0;
  while((buf[i]=*str++)!=NUL && i<maxc)
    i++;
  return(i);
}
/*  */
void lgdcmp(x,k)
     double x[];
     int k;
{
  int i,j,j1,l,m;
  double a,d;
  if(k>3) lgerr(LGE_OVFRCMPT);
  j=lgcar();
  lgbcbc.kcofi=j>63;
  if(lgbcbc.kcofi) return;
  for(i=0;i<k;i++) {
    a=0.;
    d=1.;
    j1=j%4;
    j=j/4;
    if(j1!=0) {
      for(l=0;l<j1;l++) {
	m=lgcar();
	a+=m*d;
	d*=256.;
      }
    }
    x[i]=a;
  }
  return;
}
/*  */
void lgord(x,y,n)
double x[],y[];
int n;
{
  double x0,y0,a,b,d,d0;
  int i,j,k,l;
  if(n<=2) return;
  x0=x[0];
  y0=y[0];
  for(i=1;i<n-1;i++) {
    a=ABS(x[i]-x0);
    b=ABS(y[i]-y0);
    d0=MAX(a,b);
    k=i;
    l=i+1;
    for(j=l;j<n;j++) {
      a=ABS(x[j]-x0);
      b=ABS(y[j]-y0);
      d=MAX(a,b);
      if(d<d0) {
	k=j;
	d0=d;
      }
    }
    x0=x[k];
    x[k]=x[i];
    x[i]=x0;
    y0=y[k];
    y[k]=y[i];
    y[i]=y0;
  }
  return;
}
/*  */
void lglepg()
/* Lettura estremi della pagina */
{ 
  double x[2];
  lgdcmp(x,2);
  defpag(x[0],x[1]);
  return;
}
/*  */
void lgspm(k)
int k;
{
  int i,ii;
  switch(k) {
  case MIZ_DFSPO:
    lgbcsa.kspor=lgcar();
    break;
  case MIZ_DFSPV:
    lgbcsa.kspver=lgcar();
    break;
  case MIZ_DFRYX:
    lgdcmp(&lgbcsg.dftsc[1],1);
    lgbcsg.dftsc[1]/=lgbcsa.dstmax;
    lgbcsg.dftsc[0]=1./lgbcsg.dftsc[1];
    break;
  case MIZ_DFDST:
    lgdcmp(&lgbcsg.dstsim,1);
    lgbcsg.dstsim=lgbcsg.dstsim/lgbcsa.dstfat-lgbcsa.dstmax;
    break;
  case MIZ_DFMAR:
    for(i=0;i<4;i++) {
      ii=i/2;
      lgdcmp(&lgbcsg.pagmar[i],1);
      lgbcsg.pagmar[i]/=lgbcge.pcoef[ii];
    }
    break;
  default:
    lgerr(FGR_COMANDO);
  }
  return;
}
/*  */
void lgtab(k)
int k;
{
  int i;
  switch(k) {
  case MIZ_DFTBO:
    for(i=0;i<MIZ_TABOR;i++) {
      lgdcmp(&lgbcsa.tbor[i],1);
      lgbcsa.tbor[i]/=lgbcge.pcoef[0];
    }
    break;
  case MIZ_DFTBV:
    for(i=0;i<MIZ_TABVER;i++) {
      lgdcmp(&lgbcsa.tbver[i],1);
      lgbcsa.tbver[i]/=lgbcge.pcoef[1];
    }
    break;
  default:
    lgerr(FGR_COMANDO);
  }
  return;
}
/*  */
void lgswan()
{
  int kpnpre;
  if(lgbcsg.kpnsim!=0) {
    kpnpre=lgbcpn.lpnlog;
    penna(lgbcsg.kpnsim);
  }
  while((lgbcsa.ksim=lgcar())!=0) {
    if(lgbcsa.ksim<32) {
      lgcntr();
    }
    else {
      if(lgbcsa.ksim>63 && lgbcsa.ksim<128) lgbcsa.ksim+=lgbcsg.kalfu;
      if((lgbcsa.ksim%64)<32) lgbcsa.ksim+=lgbcsg.minusc;
      lgsim(1);
    }
  }
  if(lgbcsg.kpnsim!=0) penna(kpnpre);
  return;
}
/*  */
void lgsalf()
{
  int i;
   for(i=0;i<MIZ_NUMALF;i++) lgbcsg.koralf[i]=lgcar();
   return;
}
/*  */
void lgldrs()
{
  double x[2];
  lgdcmp(x,2);
  x[0]/=MIZ_FTSIM;
  x[1]/=MIZ_FTSIM;
  defdrs(x[0],x[1]);
  return;
}
/*  */
void lgdfs()
{
  double x[2];
  int k;
  k=lgcar();
  lgdcmp(x,2);
  x[0]/=MIZ_FTSIM;
  x[1]/=MIZ_FTSIM;
  defsim(k,x[0],x[1]);
  return ;
}
/*  */
void lglpen()
/* Cambio penna */
{ 
  int i;
  i=lgcar();
  penna(i);
  return;
}
/*  */
void lgcnpn(k)
     int k;
/* Movimento della penna */
{
  double p[2];
  double xtmp,ytmp,a,b,d0,d1;
  int i,l;
  unsigned char pribuf=TRUE;
 vai:
  for(i=0;i<INT_NGBUF;i++) {
    lgdcmp(p,2);
    if(lgbcbc.kcofi) break;
    lgbcbc.xbuf[i]=p[0]/lgbcge.pcoef[0];
    lgbcbc.ybuf[i]=p[1]/lgbcge.pcoef[1];
  }
  if(i==0) return;
  switch(k) {
  case MIZ_MOV:
    lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcbc.xbuf[i-1];
    lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbcbc.ybuf[i-1];
    if(!lgbcbc.kcofi) goto vai;
    break;
  case MIZ_SEG:
  case MIZ_TRA:
    xtmp=lgbcbc.xbuf[i-1];
    ytmp=lgbcbc.ybuf[i-1];
    if(pribuf) {
      if((lgbcbc.kcopt && lgbcbc.kcofi)) {
	a=ABS(lgbccf.gfult[0]-lgbc2d.g2ult[MIZ_GRAFPAG][0]);
	b=ABS(lgbccf.gfult[1]-lgbc2d.g2ult[MIZ_GRAFPAG][1]);
	d0=MAX(a,b);
	if(d0!=0.) {
	  a=ABS(lgbccf.gfult[0]-lgbcbc.xbuf[i-1]);
	  b=ABS(lgbccf.gfult[1]-lgbcbc.ybuf[i-1]);
	  d1=MAX(a,b);
	  if(d1<d0) {
	    a=lgbc2d.g2ult[MIZ_GRAFPAG][0];
	    lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcbc.xbuf[i-1];
	    lgbcbc.xbuf[i-1]=a;
	    a=lgbc2d.g2ult[MIZ_GRAFPAG][1];
	    lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbcbc.ybuf[i-1];
	    lgbcbc.ybuf[i-1]=a;
	    lginv(lgbcbc.xbuf,lgbcbc.ybuf,i-1);
	  }
	}
      }
      lgploi(MIZ_MOV);
    }
    goto traccia;
  case MIZ_PUN:
  case MIZ_SIM:
    xtmp=lgbcbc.xbuf[i-1];
    ytmp=lgbcbc.ybuf[i-1];
    if(lgbcbc.kcopt) lgord(lgbcbc.xbuf,lgbcbc.ybuf,i);
  traccia:
    for(l=0;l<i;l++) {
      lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcbc.xbuf[l];
      lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbcbc.ybuf[l];
      lgploi(k);
    }
    pribuf=FALSE;
    if(!lgbcbc.kcofi) goto vai;
    lgbc2d.g2ult[MIZ_GRAFPAG][0]=xtmp;
    lgbc2d.g2ult[MIZ_GRAFPAG][1]=ytmp;
  }
  return;
}
/*  */
void lglmtr()
/* Lettura della modalita' di tratteggio */
{
  int i,k;
  for(i=0;i<MIZ_L_MOTRA;i++) {
    k=lgcar();
    lgbcge.ktratt[i]=k%128;
    if(lgbcge.ktratt[i]==0) return;
    if(k>=128) lgbcge.ktratt[i]=-lgbcge.ktratt[i];
  }
  lgerr(LGE_TRATTEGGIO);
  return;
}
/*  */
void lgmes()
{
  int l;
  for(l=0;l<MIZ_MSGBUF;l++) {
    lgbcbc.msgbuf[l]=lgcar();
    if(lgbcbc.msgbuf[l]==NUL) goto uscita;
  }
  lgerr(LGE_MESSAGGIO);
  return;
 uscita:
  if(!lgbcfi.nomess) lgwmsg(MIZ_MSGUTEN,lgbcbc.msgbuf);
  return;
}
/*  */
int lgdcom()
{
  int i=MIZ_PGINI;
  int cmprec;
 vai:
  cmprec=i;
  i=lgcar();
  switch(i) {
  case MIZ_PGDEF:
    if((cmprec==MIZ_PGINI) || (cmprec==MIZ_ENDPR) || (cmprec==MIZ_PGDEF)) {
      lglepg();
    }
    else {
      lgerr(FGR_PAGINA);
    }
    goto vai;
  case MIZ_PGINI:
    lgerr(FGR_INIZIOPAG);
  case MIZ_CMNOP:
    goto vai;
  case MIZ_CMMSG:
    lgmes();
    goto vai;
  case MIZ_PNMOV:
    lgcnpn(MIZ_MOV);
    goto vai;
  case MIZ_PNSEG:
    lgcnpn(MIZ_SEG);
    goto vai;
  case MIZ_PNPUN:
    lgcnpn(MIZ_PUN);
    goto vai;
  case MIZ_PNSIM:
    lgcnpn(MIZ_SIM);
    goto vai;
  case MIZ_PNTRA:
    lgcnpn(MIZ_TRA);
    goto vai;
  case MIZ_DFTRA:
    lglmtr();
    goto vai;
  case MIZ_DFSIM:
    lgdfs();
    goto vai;
  case MIZ_PNCTR:
    lglpen();
    goto vai;
  case MIZ_DFDMR:
    lgldrs();
    goto vai;
  case MIZ_DFALF:
    lgsalf();
    goto vai;
  case MIZ_STRCR:
    lgswan();
    goto vai;
  case MIZ_DFTBO:
  case MIZ_DFTBV:
    lgtab(i);
    goto vai;
  case MIZ_DFSPO:
  case MIZ_DFSPV:
  case MIZ_DFMAR:
  case MIZ_DFDST:
  case MIZ_DFRYX:
    lgspm(i);
    goto vai;
  case MIZ_ENDPR:
    goto vai;
  default:
    lgerr(FGR_COMANDO);
  case MIZ_PGFIN:
  case MIZ_FLEOF:
  case MIZ_FLEOE:
    break;
  }
  return(i);
}
/*  */
int lgcflg()
{
  int icom,tmp;
  if(!lgbccf.kcgfdf) lgpfcv();
  tmp=ABS(lgbccf.kmprz);
  if(tmp!=1)
    {  
      /* Disegno senza strisce */
      lgpag(lgbcge.kpag);
      lgpen(-1);
      icom=lgdcom();
      lgbcpn.kvstpn=-(ABS(lggraf.kstpn));
      if(lgbcpn.kvstpn!=lggraf.kstpn) lgpen(lgbcpn.kvstpn);
      if(lggraf.posfin) {
	lgbc2d.g2ult[MIZ_GRAFPAG][0]=lggraf.pfin[0];
	lgbc2d.g2ult[MIZ_GRAFPAG][1]=lggraf.pfin[1];
	lgploi(MIZ_MOV);
      }
      lgpag(ICP_SVUOTA);
    }
  else {
    double gx0,gy0;
    int ix,iy;
    long int ipos;
    /* Disegno a strisce */
    gx0=lgbccf.gfcen[0];
    gy0=lgbccf.gfcen[1];
    for(iy=0;iy<lgbccf.npy;iy++) {
      lgbccf.gfcen[1]=gy0+iy*lgbccf.dgfcen[1];
      for(ix=0;ix<lgbccf.npx;ix++) {
	lgbccf.gfcen[0]=gx0+ix*lgbccf.dgfcen[0];
	if(ix!=0 || iy!=0) {
	  icom=lgppag();
	  if(icom!=INT_CONTINUA) return(icom);
	}
	lgpag(lgbcge.kpag);
	icom=lgdcom();
	lgbcpn.kvstpn=-(ABS(lggraf.kstpn));
	if(lgbcpn.kvstpn!=lggraf.kstpn) lgpen(lgbcpn.kvstpn);
	lgmov(lgbccf.flim[0],lgbccf.flim[2]);
	lgpag(ICP_SVUOTA);
	lgfile.krec=lgfile.krulpg;
	ipos=(lgfile.krec-1)*MIZ_FGRBUF;
	fseek(lgbcio.kungr,ipos,SEEK_SET);
	lglegf();
	lgfile.kbf=lgbcfi.krulbf;
      }
    }
  }
  return(icom);
}
/*  */
int lgtpag(n)
int n;
{
  long int ipos;
  int i,k;
  unsigned char inpg=FALSE;
  unsigned char tmp[2];
  if(n<=0) {
    return(INT_ERRPAG);
  }
  if(n==lgbcge.kpag) {
    lgfile.krec=lgfile.krulpg;
    ipos=(lgfile.krec-1)*MIZ_FGRBUF;
    fseek(lgbcio.kungr,ipos,SEEK_SET);
    return(INT_TRACCIA);
  }
  lgbcfi.krcult=lgfile.krec;
  if(n<lgbcge.kpag) lgfile.krec=2;
  ipos=(lgfile.krec-1)*MIZ_FGRBUF;
  fseek(lgbcio.kungr,ipos,SEEK_SET);
 cerca:
  lglegf();
  lgfile.kbf=0;
  i=lgcar();
  if(inpg) {
    switch(i) {
    case MIZ_PGINI:
      lgerr(FGR_INIZIOPAG);
      break;
    case MIZ_PGFIN:
      inpg=FALSE;
      break;
    case MIZ_FLEOF:
    case MIZ_FLEOE:
      lgfile.krec=lgbcfi.krcult;
      ipos=(lgfile.krec-1)*MIZ_FGRBUF;
      fseek(lgbcio.kungr,ipos,SEEK_SET);
      return(INT_ERRPAG);
    }
  }
  else {
    switch(i) {
    case MIZ_PGINI:
    case MIZ_PGFIN:
    case MIZ_FLEOF:
    case MIZ_FLEOE:
      k=lgcar();
      if(k!=MIZ_PGINI) lgerr(FGR_RECORDINIPG);
      tmp[0]=lgcar();
      tmp[1]=lgcar();
      k=lg2cti(tmp);
      if(k==n) {
	--lgfile.krec;
	ipos=(lgfile.krec-1)*MIZ_FGRBUF;
	fseek(lgbcio.kungr,ipos,SEEK_SET);
	return(INT_TRACCIA);
      }
      else {
	if(i==MIZ_FLEOF || i==MIZ_FLEOE) 
	  {  lgfile.krec=lgbcfi.krcult;
	  ipos=(lgfile.krec-1)*MIZ_FGRBUF;
	  fseek(lgbcio.kungr,ipos,SEEK_SET);
	  return(INT_ERRPAG);
	  }
	if(i==MIZ_PGINI) inpg=TRUE;
      }
      break;
    default:
      break;
    }
  }
  goto cerca;
}
/*  */
INT lgppag()
{
  char risp,ctrm;
  int n,k,lp;
  char buf[13];
  risp=lgspag();
  switch(risp) {
  case 'o':
  case 'O':
    if(lggraf.prompg) lgwmsg(MIZ_ACAPO);
    return(INT_OPZIONI);	 
  case 'e':
  case 'E':
  case 'f':
  case 'F':
  case 'q':
  case 'Q':
  case ESC:
  case CTRLD:
  case CTRLZ:
    if(lggraf.prompg) lgwmsg(MIZ_ACAPO);
    return(INT_USCITA);
  case '=':
  case '+':
  case '-':
    if(!lggraf.prompg) {
      n=lgrdne(buf,12,&ctrm);
    }
    else {
      buf[0]=risp; buf[1]=NUL;
      n=lgrdst(buf,12,&ctrm);
    }
    if(n==0) {
      k=0;
      lp=lgbcge.kpag;
    }
    else {
      k=lgdint(buf,0,n-1,&lp);
      if(k<0)	{
	lgerr(LGE_ERRCVINT);
	return(INT_ERRPAG);
      }
    }
    if(risp=='-') lp=lgbcge.kpag-lp;
    if(risp=='+') lp+=lgbcge.kpag;
    if(lp<=lgbcfi.kpgmax) {
      k=lgtpag(lp);
    }
    else {
      k=INT_ERRPAG;
    }
    if(k==INT_ERRPAG) 
      {  
#if MIZAR_PCVERSION
	itoa(lp,buf,10);
#endif
#if MIZAR_LinuxVERSION
	snprintf(buf,10,"%d",lp);
#endif
	lgerr(LGE_PAGINESIST,buf);
	return(INT_ERRPAG);
      }
    else {
      return(INT_TRACCIA);
    }
  case 'a':
  case 'A':
  case 'c':
  case 'C':
    lggraf.anim=TRUE;
  case NUL:
  default:
    return(INT_CONTINUA);
  }
}
/*  */
void lglegf()
{
  int k;
  k=fread(lgfile.kgrbf,sizeof(char),MIZ_FGRBUF,lgbcio.kungr);
  if(k==MIZ_FGRBUF) {
    ++lgfile.krec;
    lgfile.kbf=1;
    lgbcfi.krcult=lgfile.kgrbf[0];
  }
  else {
    char buf[12];
    /* Errore di lettura */
#if MIZAR_PCVERSION
    itoa(lgfile.krec,buf,10);
#endif
#if MIZAR_LinuxVERSION
    snprintf(buf,10,"%ld",lgfile.krec);
#endif
    lgerr(FGR_READERR,buf);
  }
  return;
}
/*  */
int lgcar()
{
  int k;
   k=lgfile.kgrbf[lgfile.kbf++];
   k&=255;
   if(lgfile.kbf>=MIZ_FGRBUF) lglegf();
   return(k);
}
/*  */
int lg2cti(cb)
unsigned char cb[2];
{
  int k;
  k=cb[0]+256*cb[1];
  return(k);
}
/*  */
long lg4ctl(cb)
unsigned char cb[4];
{
  long k=0;
  int i;
  for(i=3;i>=0;i--) {
    k=256*k+cb[i];
  }
  return(k);
}
/*  */
int lgapre()
{
  char buf0[20],buf1[20],buf2[20],buf3[20],buf4[20],buf5[20];
  int i,nrec;
  unsigned char risp;
  if(lgbcfi.filopn) fclose(lgbcio.kungr);
  lgbcfi.filopn=FALSE;
  lgbcio.kungr=fopen(lgbcfi.nomfil,"rb");
  if(lgbcio.kungr==0) {
     
    /* Errore di apertura del file */
    lgerr(FGR_OPENERR,lgbcfi.nomfil);
    return(1);
  }
  lgfile.krec=1;
  /* Scrittura del nome del file */
  lgwmsg(MIZ_FGRAPERTO,lgbcfi.nomfil);
  /* Controllo del primo record */
  lglegf();
  for(i=0;i<HDR_L_NOME;i++) {
    if(lgfile.kgrbf[i+HDR_NOME]!=mizhdr.hdr.nome[i]) {
      lgerr(LGE_NONFGR,lgbcfi.nomfil);
      fclose(lgbcio.kungr);
      return(2);	/* Primo record non riconoscibile */
    }
  }
#if MIZAR_PCVERSION
  itoa((int) lgfile.kgrbf[HDR_VERS],buf0,10);
  itoa((int) lgfile.kgrbf[HDR_VERS+1],buf1,10);
#endif
#if MIZAR_LinuxVERSION
  snprintf(buf0,10,"%d",(int) lgfile.kgrbf[HDR_VERS]);
  snprintf(buf1,10,"%d",(int) lgfile.kgrbf[HDR_VERS+1]);
#endif
  lgwmsg(MIZ_FGRINFO,buf0,buf1);
  i=HFG_CRTIM;
#if MIZAR_PCVERSION
  itoa((int) lgfile.kgrbf[i++],buf0,10);
  itoa((int) lgfile.kgrbf[i++],buf1,10);
  if(lgfile.kgrbf[i]>99) lgfile.kgrbf[i] -= 100;
  itoa((int) lgfile.kgrbf[i++],buf2,10);
  itoa((int) lgfile.kgrbf[i++],buf3,10);
  itoa((int) lgfile.kgrbf[i++],buf4,10);
  itoa((int) lgfile.kgrbf[i],buf5,10);
#endif
#if MIZAR_LinuxVERSION
  snprintf(buf0,10,"%d",(int) lgfile.kgrbf[i++]);
  snprintf(buf1,10,"%d",(int) lgfile.kgrbf[i++]);
  if(lgfile.kgrbf[i]>99) lgfile.kgrbf[i] -= 100;
  snprintf(buf2,10,"%02d",(int) lgfile.kgrbf[i++]);
  snprintf(buf3,10,"%02d",(int) lgfile.kgrbf[i++]);
  snprintf(buf4,10,"%02d",(int) lgfile.kgrbf[i++]);
  snprintf(buf5,10,"%02d",(int) lgfile.kgrbf[i]);
#endif
  lgwmsg(MIZ_FGRDATE,buf0,buf1,buf2,buf3,buf4,buf5);
  nrec=lg4ctl(&lgfile.kgrbf[HFG_NUMREC]);
  if(nrec==0) {
    lgwmsg(MIZ_FGRMALCLS);
    return(4);	/* File non chiuso correttamente */
  }
  lgwmsg(MIZ_FGRACCETT);
  if(lggraf.ansi_term)
    i=lgrdst(buf5,4,buf5+4);
  else
    i=noansi_lgrdst(buf5,4,buf5+4);
  i=lgvrfs(buf5,0,&risp);
  if(!risp) {
    fclose(lgbcio.kungr);
    return(3);	/* File non accettato dall'utente */
  }
#if MIZAR_PCVERSION
  itoa(nrec,buf0,10);
#endif
#if MIZAR_LinuxVERSION
  snprintf(buf0,10,"%d",nrec);
#endif
  lgbcfi.kpgmax=lg4ctl(&lgfile.kgrbf[HFG_NUMPAG]);
#if MIZAR_PCVERSION
  itoa((int) lgbcfi.kpgmax,buf1,10);
#endif
#if MIZAR_LinuxVERSION
  snprintf(buf1,10,"%d",(int) lgbcfi.kpgmax);
#endif
  lgwmsg(MIZ_FGRSIZE,buf1,buf0);
  i=lg2cti(&lgfile.kgrbf[HFG_CLOSTA]);
  if(i!=0) {
    lgwmsg(MIZ_FGRERRCLS);
    lgwmsg(lgbcer.errve[i-1].stato & EST_NUMMSGERR);
  }
  lgbcfi.filopn=TRUE;
  return(0);
}
/*  */
int lgdpnu(buf,kin,kfi)
char buf[];
int kin,kfi;
{
  int k,l,i,i0,i1,j;
  k=kin;
 vai:
  l=lgdint(buf,k,kfi,&i0);
  k+=(ABS(l));
  if(l>0) goto err99;
  if(i0<=0 || i0>MIZ_NUMPEN) goto err98;
  i0--;
  i1=i0;
  switch(buf[k]) {
  case '-':
    k++;
    l=lgdint(buf,k,kfi,&i1);
    k+=(ABS(l));
    if(l>0) goto err99;
    if(i1<=i0 || i1>MIZ_NUMPEN) goto err98;
    i1--;
  case ':':
    k++;
    l=lgdint(buf,k,kfi,&j);
    k+=(ABS(l));
    if(j>lggraf.knpen) goto err97;
    if(j<=0) j=lggraf.knpen+1;
    break;
  default:
    goto err99;
  }
  for(i=i0;i<=i1;lgbcpn.kpenna[i++]=j);
  if(l>0) return(k-kin);
  if(buf[k]==' ' || buf[k]==',')  {
    k++;
    goto vai;
  }
 err97:
  k++;
 err98:
  return(kin-k+1);
 err99:
  return(l);
}
/*  */
int lgdpun(buf,kin,kfi)
char buf[];
int kin,kfi;
{
  int k,l,ks;
  unsigned char vf;
  double d,r;
  k=kin;
  l=lgvrfs(buf,k,&vf);		/* si/no per sostituzione punto */
  k+=(ABS(l));
  if(l<0) goto err99;
  lggraf.punsim=vf;
  if(lggraf.punsim) {
    ks=1;			/* Sostituzione da fare; valori default */
    d=1.;
    r=0.;
    if(k>kfi) goto esci;
    /* Specifica simbolo */
    if(buf[k]!=' ' && buf[k]!=',') goto err99;
    k++;
    l=lgdint(buf,k,kfi,&ks);
    k+=(ABS(l));
    if(ks<=0 || ks>MIZ_CARMX) goto err99;
    if(l>0) goto esci;
    /* Specifica dimensioni simbolo */
    if(buf[k]!=' ' && buf[k]!=',') goto err99;
    k++;
    l=lgddbl(buf,k,kfi,&d);
    k+=(ABS(l));
    if(l>0) goto esci;
    /* Specifica angolo di rotazione */
    if(buf[k]!=' ' && buf[k]!=',') goto err99;
    k++;
    l=lgddbl(buf,k,kfi,&r);
    k+=(ABS(l));
    if(l<0) {
      switch(buf[k]) {
      case 'g':
      case 'G':
	r*=lgbccs.grarad;
      case 'r':
      case 'R':
	lgbccf.rotpun=r;
	k++;
	break;
      default:
	goto err99;
      }
    }
  esci:
    if(lggraf.punsim) defpun(ks,d,r);
  }
  return(k-kin);
 err99:
  return(kin-k);
}
/*  */
int lgdtbr(buf,kin,kfi,x,n)
char buf[];
int kin,kfi;
double x[];
int n;
{
  int i,k,l,ler;
  double xx;
  k=kin;
  for(i=0;i<n;i++) {
    ler=lgddbl(buf,k,kfi,&xx);
    x[i]=xx;
    k+=(ABS(ler));
    if(ler>0) break;
    if(buf[k-1]!=' ' && buf[k-1]!=',') return(kin-k);
  }
  l=k-kin;
  if(i!=n) l=(-l);
  return(l);
}
/*  */
int lgvrfs(buf,kcar,vf)
char buf[];
int kcar;
unsigned char *vf;
{
  switch(buf[kcar]) {
  case 'v':
  case 'V':
  case 'y':
  case 'Y':
  case 's':
  case 'S':
  case 't':
  case 'T':
  case '1':
    *vf=TRUE;
    break;      
  case 'f':
  case 'F':
  case 'n':
  case 'N':
  case '0':
    *vf=FALSE;
    break;      
  default:
    *vf=FALSE;
    return(-1);
  }
  return(1);
}
/*  */
INT noansi_lgrdst(buf,nb,ctrm)
CHAR buf[];
int nb;
CHAR *ctrm;
{
  int j;
  if(lgbcio.kuninp==NULL) lgbcio.kuninp=stdin;
  fgets(buf,nb,lgbcio.kuninp);
  for(j=0;j<nb;j++) {
    switch(buf[j]) {
    case NUL:
      *ctrm=CTRLZ;
      goto uscita;
    case CR:
    case LF:
      *ctrm=buf[j];
      buf[j]=NUL;
      goto uscita;
    default:
      break;
    }
  }
 uscita:
  return(j);
}
/*  */
#define INT_NUMOPZ 27
#define INT_BUFOPZ 80
char lgtopz[INT_NUMOPZ][3]={
  {'F','I','N'},{'F','A','T'},{'F','T','X'},{'F','T','Y'},
  {'P','U','N'},{'S','C','H'},{'S','V','R'},{'S','T','R'},
  {'F','I','L'},{'O','U','T'},{'A','B','O'},{'R','O','T'},
  {'O','P','Z'},{'P','E','N'},{'S','P','O'},{'B','A','T'},
  {'M','G','X'},{'M','G','Y'},{'D','I','M'},{'X','F','I'},
  {'Y','F','I'},{'S','M','X'},{'S','M','Y'},{'P','N','S'},
  {'S','E','C'},{'A','N','I'},{'Q','L','T'}};
void lgopz()
{
  char buf[INT_BUFOPZ+1];
  int i,k,j,n,ler,kin,kfi,jj;
  unsigned char vf;
  double r,x[4];
  char ctrm;
  FILE *kun;
  kun=lgbcio.kuninp;
 vai:
  if(lggraf.prompt && kun==lgbcio.kuninp)
    lgwmsg(MIZ_OPZIONE);			/* Richiesta opzione */
				/* Lettura opzione */
  if(lggraf.ansi_term) 
    n=lgrdst(buf,INT_BUFOPZ,&ctrm);
  else
    n=noansi_lgrdst(buf,INT_BUFOPZ,&ctrm);
  kin=3;
  if(n==0) goto chktrm;
  n=lgelbl(buf,n);
  for(i=0;i<3;i++) if(buf[i]>='a' && buf[i]<='z') buf[i]-=' ';
  kfi=n-1;
  switch(buf[kin]) {
  case ' ':
    if(buf[kin+1]=='=' || buf[kin+1]==':') kin++;
  case '=':
  case ':':
    if(buf[kin+1]==' ') kin++;
    kin++;
  case NUL:
    break;
  default:
    ler=1;
    goto ersint;
  }
  if(!lggraf.prompt || kun!=lgbcio.kuninp) {
    buf[n]=NUL;
    lgwmsg(MIZ_WRITEOPZ,buf);
  } 
  /* Identifica il comando */
  for(k=0;k<INT_NUMOPZ;k++) {
    for(j=0;j<3;j++) if(buf[j]!=lgtopz[k][j]) break; 
    if(j>=3) break;
  }
 esegui:
  switch(k) {
  case 0:				/* comando FIN */
    if(n<=kin) return;
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    lggraf.posfin=vf;
    goto uscita;
  case 1:	 			/* comando FAT */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler<0 || r<=0.) goto ersint;
    deffat(r);
    break;
  case 2:	 			/* comando FTX */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler<0 || r<=0.) goto ersint;
    defftx(r)	 ;
    break;
  case 3:	 			/* comando FTY */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler<0 || r<=0.) goto ersint;
    deffty(r);
    break;
  case 4:	 			/* comando PUN */
    ler=lgdpun(buf,kin,kfi);
    if(ler<0) goto ersint;
    break;
  case 5:	 			/* comando SCH */
    ler=lgdtbr(buf,kin,kfi,x,4);
    if(ler<0) goto ersint;
    defsch(x[0],x[1],x[2],x[3]);
    break;
  case 6:	 			/* comando SVR */
    ler=lgdint(buf,kin,kfi,&jj);
    if(jj<0 || jj>99 || ler<0) goto ersint;
    lgbccf.persvr=2.-.02*jj;
    break;
  case 7:	 			/* comando STR */
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    jj= (vf)? 1:2;
    lgbccf.kmprz=(lgbccf.kmprz>=0)? jj:-jj;
    break;
  case 8:	 			/* comando FIL */
    if(n>=64) {
      ler=64;
      goto ersint;
    }
    jj=0;
    for(i=kin;i<n;lgbcfi.nomfil[jj++]=buf[i++]);
    lgbcfi.nomfil[jj]=NUL;
    if(lgbcfi.filopn) fclose(lgbcio.kungr);
    lgbcfi.filopn=FALSE;
    break;
  case 9:	 			/* comando OUT */
    ler=n-kin;
    if(n<=4 || n>64) goto ersint;
    jj=0;
    for(i=kin;i<n;lggraf.nomoug[jj++]=buf[i++]);
    lggraf.nomoug[jj]=NUL;
    lggraf.lnmoug=jj;
    break;
  case 10:	 			/* comando ABO */
    lgwmsg(MIZ_FINERICH);
    exit(0);
    break;
  case 11:	 			/* comando ROT */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler>0) {
      r*=lgbccs.grarad;
    }
    else {
      k=kin+(ABS(ler));
      switch(buf[k]) {
      case 'g':
      case 'G':
	r*=lgbccs.grarad;
      case 'r':
      case 'R':
	break;
      default:
	goto ersint;
      }
    }
    defrot(r);
    break;
  case 12:	 			/* comando OPZ */
    ler=0;
    goto ersint;
    /*	if(kun==kuning || n<=4) goto ersint;
	ler=n-3
	open(unit=kuning,name=bufcar(5:n),type='old',err=400)
	kun=kuning
	break;			*/
  case 13:			/* comando PEN */
    ler=lgdpnu(buf,kin,kfi);
    if(ler<0) goto ersint;
    break;
  case 14:			/* comando SPO */
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    lggraf.spool=vf;
    break;
  case 15:			/* comando BAT */
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    lggraf.batch=vf;
    break;
  case 16:			/* comando MGX */
    ler=lgdint(buf,kin,kfi,&jj);
    if(ler<0) goto ersint;
    lggraf.marg[0]=jj;
    break;
  case 17:			/* comando MGY */
    ler=lgdint(buf,kin,kfi,&jj);
    if(ler<0) goto ersint;
    lggraf.marg[1]=jj;
    break;
  case 18:			/* comando DIM */
    ler=lgdint(buf,kin,kfi,&jj);
    if(jj<=0 || jj>10 || ler<0) goto ersint;
    jj--;
    lggraf.klimpg=jj;
    lggraf.dlim[0]=lggraf.dlimps[jj][0];
    lggraf.dlim[1]=lggraf.dlimps[jj][1];
    break;
  case 19:			/* comando XFI */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler<0.) goto ersint;
    lggraf.pfin[0]=r;
    break;
  case 20:			/* comando YFI */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler<0) goto ersint;
    lggraf.pfin[1]=r;
    break;
  case 21:			/* comando SMX */
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    lgbccf.simxy[0]=(vf)? -1.:1.;
    break;
  case 22:			/* comando SMY */
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    lgbccf.simxy[1]= (vf)? -1.:1.;
    break;
  case 23:			/* comando PNS */
    ler=lgdint(buf,kin,kfi,&jj);
    if(ler<0) goto ersint;
    defpns(jj);
    break;
  case 24:			/* comando SEC : secondi di attesa tra due immagini per
                                   l'esecuzione in modalita' animazione */
    ler=lgddbl(buf,kin,kfi,&r);
    if(ler<0) goto ersint;
    lggraf.req.tv_sec=r;
    r=fmod(r,1.);
    lggraf.req.tv_nsec=1000000000.*r;
    lggraf.pfin[1]=r;
    break;
  case 25:			/* comando ANI : esecuzione in animazione */
    ler=lgvrfs(buf,kin,&vf);
    if(ler<0) goto ersint;
    lggraf.anim=vf;
    break;
  case 26:			/* comando QLT: qualita' grafica di output
				   si applica solo a interpreti che producono files
				   in formati compatti non cinservativi, tipo Jpeg */
    ler=lgdint(buf,kin,kfi,&jj);
    if(ler<0) goto ersint;
    defqlt(jj);
    break;
  case FERR_OPZIONI:		/* Errore di I/O in letture delle opzioni.  
				   Tipicamente un EOF nella lettura da file  */
    lgwmsg(ICP_INPFERROR);
    exit(0);

  default:				/* comando non riconosciuto */
    kin=3;
    ler=0;
  ersint: 	 			/* Errore di sintassi nel comando */
    ler=(ABS(ler))+kin;
    lgwmsg(LGE_OPZERR,buf);
    for(j=0;j<ler;buf[j++]='.');
    buf[j++]='?';
    buf[j]=NUL;
    lgwmsg(MIZ_TESTO,buf)	 ;
  }
 chktrm:					/* Controllo carattere terminatore */
  switch(ctrm) {
  case CTRLZ:
    k=0;
    goto esegui;
  case CTRLD:
  case ESC:
    k=10;
    goto esegui;
  case -1:
    k = FERR_OPZIONI;
    goto esegui;
  default:
    goto vai;
  }
 uscita:
  if(kun!=lgbcio.kuning) {
    fclose(kun);
    kun=lgbcio.kuninp;
  }
  return;
}
