/* <numeri>:
Sottoprogramma per:
   -	conversione di numeri dal formato interno al formato ASCII
   -	scrittura di numeri
*/

#include <stdio.h>
#include <math.h>
#include <time.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/* Sottoprogramma lgpow10 */
DOUBLE lgpow10(k)
int k;
{  double x;
   int i;
   x=1.;
   if(k>0)
   {  for(i=0;i<k;i++) x*=10.;
   }
   else if(k<0)
   {  for(i=0;i>k;i--) x/=10.;
   }
   return(x);
}
/* Sottoprogramma lgcint */
INT lgcint(ival,buf,nbuf)
long int ival;
char buf[];
int nbuf;
{  int i;
   long int k;
   k=ABS(ival);
   i=nbuf;
   if(k==0)
   {  buf[--i]='0';
   }
   else
   {  while(i>0 && k!=0)
      {  buf[--i]=48+k%10;
	 k/=10;
      }
      if(k!=0) return(-nbuf);
   }
   if(ival<0)
   {  if(i==0) return(-nbuf);
      buf[--i]='-';
   }
   for(k=0;i<nbuf;buf[k++]=buf[i++]);
   return(k);
}
/* Sottoprogramma lgcrea */
INT lgcrea(rnum,ndec,buf,nbuf)
double rnum;
int ndec;
char buf[];
int nbuf;
{  double fd,x,y,z;
   int l,k;
   fd=lgpow10(ndec);
   if((x=rnum) < 0.) x = -rnum;
   y=fmod(x,1.);
   y=floor(y*fd+.5);
   z=floor(y/fd);
   z+=floor(x);
   y=fmod(y,fd);
/* Segno */
   l=0;
   if(rnum<0.) buf[l++]='-';
/* Parte intera */
   k=lgcreb(z,&buf[l],nbuf-l,0);
   if(k<0) goto errore;
   l+=k;
/* Parte frazionaria */
   if(ndec>0)
   {  buf[l++]='.';
   k=lgcreb(y,&buf[l],nbuf-l,ndec);
   if(k<0) goto errore;
   l+=k;
   }
   return(l);
errore:
   return(k-l);
}
/* Sottoprogramma lgcreb */
INT lgcreb(rval,buf,nbuf,ncmin)
double rval;
char buf[];
int nbuf;
int ncmin;
{  double x;
   int i,l;
   x=ABS(rval);
   i=nbuf;
   if(x<1.)
   {  buf[--i]='0';
   }
   else
   {  while(i>0 && x>=1.)
      {  l=fmod(x,10.);
	 buf[--i]=l+48;
	 x/=10.;
      }
      if(x>=1.) return(-nbuf);
   }
   while(nbuf-i<ncmin) buf[--i]='0';
   if(rval<0.)
   {  if(i==0) return(-nbuf);
      buf[--i]='-';
   }
   for(l=0;i<nbuf;buf[l++]=buf[i++]);
   return(l);
}
/* Sottoprogramma lgcrex */
INT lgcrex(rnum,ndec,buf,nbuf)
double rnum;
int ndec;
char buf[];
int nbuf;
{  double x,y,z;
   int ie,l,le,j,k;
   if(rnum==0.)
   {  z=0.;
      ie=0;
   }
   else
   {  x=ABS(rnum);
      y=log10(x);
      ie=floor(y);
      y=lgpow10(ie);
      z=rnum/y;
   }
   j=0;
   k=lgcrea(z,ndec,buf,nbuf);
   if(k<0) goto errore;
   buf[k++]='x';
   buf[k++]='1';
   buf[k++]='0';
   buf[k++]=CAPICE;
   j=lgcint((long) ie,&buf[k],nbuf-k);
   if(j<0) goto errore;
   return(k+j);
errore:
   l= -(ABS(k)+ABS(j));
   return(l);
}
/* Sottoprogramma numrea */
INT numrea(gx,gy,ipos,rnum,ndec,dim,rot,ncar)
double gx,gy;
int ipos;
double rnum;
int ndec;
double dim,rot;
INT *ncar;
{  int nint,nndec;
   double x,tmp;
   char iffc[40];
/* Sceglie il formato */
   if(ndec<0. && rnum!=0.) 
   {  nndec=MIN(MIZ_NUMCIFPREC,-ndec)-1;
      goto forme;
   }
   if(rnum==0.)
   {  nndec=MIN(ndec,1);
      goto formf;
   }
   else
   {  nint=MAX(1,MIZ_NUMCIFPREC-ndec);
      x=lgpow10(nint);
      tmp=ABS(rnum);
      if(tmp>=x)
      {  nndec=MIZ_NUMCIFPREC-1;
	 goto forme;
      }
      nndec=ndec;
   }
/* Formato F */
formf:
   *ncar=lgcrea(rnum,nndec,iffc,40);
   goto scrivi;
/* Formato E */
forme:
   *ncar=lgcrex(rnum,nndec,iffc,40);
scrivi:
   return(lgwnum(gx,gy,iffc,*ncar,ipos,dim,rot));
}
/* Sottoprogramma numint */
INT numint(gx,gy,ipos,num,dim,rot,ncar)
double gx,gy;
int ipos;
long int num;
double dim,rot;
INT *ncar;
{  char iffc[20];
   *ncar=lgcint((long) num,iffc,20);
   return(lgwnum(gx,gy,iffc,*ncar,ipos,dim,rot));
}
/* Sottoprogramma numesp */
INT numesp(gx,gy,ipos,ibase,iesp,dim,rot,ncar)
double gx,gy;
int ipos,ibase,iesp;
double dim,rot;
INT *ncar;
{  char iffc[28];
   int kc;
   kc=lgcint((long) ibase,iffc,28);
   iffc[kc++]=CAPICE;
   kc+=lgcint((long) iesp,&iffc[kc],28-kc);
   *ncar=kc;
   return(lgwnum(gx,gy,iffc,kc,ipos,dim,rot));
}
/* Sottoprogramma lgwnum */
INT lgwnum(gx,gy,iffc,kc,ipos,dim,rot)
double gx,gy;
char iffc[];
int kc,ipos;
double dim,rot;
{  double dx,dy,gx0,gy0;
/* Scrive su file,se necessario,le dimensioni e l'angolo
   di rotazione. */
   defdrs(dim,rot);
   dx=lgbcsa.kspor*lgbcsa.dimsim*cos(lgbcsa.rotsim);
   dy=lgbcsa.kspor*lgbcsa.dimsim*sin(lgbcsa.rotsim);
/* Determina le condizioni di allineamento */
   if(ipos<0)
/* Allineamento a destra */
   {  gx0=gx-kc*dx;
      gy0=gy-kc*dy;
   }
   else if(ipos==0)
   {  
/* Allineamento al centro */
      gx0=gx-kc*dx*.5;
      gy0=gy-kc*dy*.5;
    }
   else if(ipos>0)
   {  
/* Allineamento a sinistra */
      gx0=gx;
      gy0=gy;
   }
/* Muove la penna nel punto iniziale e scrive il numero */
   lgbc2d.kgrut=MIZ_GRAFPAG;
   lgplot(gx0,gy0,MIZ_GRAFPAG);
   return(stralf(iffc,kc,dim,rot));
}
