/* Interprete per stampante POSTSCRIPT */
#include <stdio.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#include "icpcmn.h"
#define ABS(z) ((z)>=0)? (z):-(z)
/*  */
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
union mizhdr mizhdr;
extern struct lgbcio lgbcio;
extern struct lggraf lggraf;
/*  */
struct
   {  long kxult;		/* Ultime coordinate fisiche. */
      long kyult;
      int lunout;		/* Soglia per stampa buffer di output */
      int koutb;		/* Contatore caratteri per riga */
      int npages;		/* Numero di pagine */
      int lpsg;			/* Stato su o giu' della penna */
      char cpen[16];		/* Larghezza corrispondente alla penna */
      char lstpen[2];		/* Stato della penna per output */
   }  lgcpos={-1,-1,64,0,0,0,
      		{1,3,5,7,9,11,13,15,17,19,21,23,25,27,29,31},
      		{'L','M'}};
/*  */
/* Sottoprogramma LGCUR */
/* Questo sottoprogramma e' previsto solo per le versioni interattive.
   Qui serve solo per evitare errori di "undefined external" in fase di 
   link. */
CHAR lgcur(fx,fy)
DOUBLE *fx,*fy;
{  *fx=lgcpos.kxult;
   *fy=lgcpos.kyult;
   return(CR);
}
/* Sottoprogramma LGZOOM */
/* Questo sottoprogramma e' previsto solo per le versioni interattive.
   Qui serve solo per evitare errori di "undefined external" in fase di 
   link. */
CHAR lgzoom(fx0,fy0,fx1,fy1)
DOUBLE *fx0,*fy0,*fx1,*fy1;
{  *fx0=0.;
   *fy0=lggraf.dflim[0];
   *fx1=0.;
   *fy1=lggraf.dflim[1];
   return(CR);
}
/* Sottoprogramma LGSVUO */
VOID lgsvuo()
{  if(lgcpos.koutb>0)
   {  fprintf(lgbcio.kunoug,"\nS N %ld %ld M\n",lgcpos.kxult,lgcpos.kyult);
      lgcpos.koutb=0;
   }
   return;
}
/* Sottoprogramma LGPAG */
VOID lgpag(kpg)
     int kpg;
{  int kpg1,k;
 kpg1=kpg; if(kpg1>0) kpg1=ICP_PAGINA;
 switch (kpg1) {
 case ICP_INIT:
   lgcpos.npages=0;
   lgbcio.kunoug=fopen(lggraf.nomoug,"w");
   fprintf(lgbcio.kunoug,"%%!PS-Adobe-1.0\n");
   fprintf(lgbcio.kunoug,"%%%%Title: File %s\n",lggraf.nomoug);
   fprintf(lgbcio.kunoug,"%%%%Creator: MiZaR\n");
   fprintf(lgbcio.kunoug,"%%%%Boundingbox 0 0 612 768\n");
   fprintf(lgbcio.kunoug,"%%%%Pages: (atend)\n");
   fprintf(lgbcio.kunoug,"%%%%EndComments\n");
   fprintf(lgbcio.kunoug,"save\n");
   fprintf(lgbcio.kunoug,"%%%%Endprolog\n");
   fprintf(lgbcio.kunoug,"initgraphics\n");
   fprintf(lgbcio.kunoug,"erasepage\n");
   fprintf(lgbcio.kunoug,"/L {lineto} def\n");
   fprintf(lgbcio.kunoug,"/R {rlineto} def\n");
   fprintf(lgbcio.kunoug,"/M {moveto} def\n");
   fprintf(lgbcio.kunoug,"/N {newpath} def\n");
   fprintf(lgbcio.kunoug,"/S {stroke} def\n");
   fprintf(lgbcio.kunoug,"/P {setlinewidth} def\n");
   fprintf(lgbcio.kunoug,"1 setlinewidth 1 setlinecap 1 setlinejoin\n");
   break;
 case ICP_PAGINA:
   if(lgcpos.npages>0) {
     lgsvuo();
     fprintf(lgbcio.kunoug,"%%end(plot)\n");
     fprintf(lgbcio.kunoug,"showpage\n");
   }
   lgcpos.npages++;
   k=ABS(lggraf.kstpn); --k;
   fprintf(lgbcio.kunoug,"%%%%Page: %d\n",lgcpos.npages);
   fprintf(lgbcio.kunoug,"16 40 translate\n");
   fprintf(lgbcio.kunoug,"%%begin(plot)\n");
   fprintf(lgbcio.kunoug,"72 300 div 72 300 div scale\n");
   fprintf(lgbcio.kunoug,"[] 0 setdash\n");
   fprintf(lgbcio.kunoug,
	   "%d setlinewidth 1 setlinecap 1 setlinejoin\n",lgcpos.cpen[k]);
   fprintf(lgbcio.kunoug,"N 0 0 M\n");
   break;
 case ICP_FINE:
   lgsvuo();
   fprintf(lgbcio.kunoug,"0 0 M S\n");
   fprintf(lgbcio.kunoug,"%%end(plot)\n");
   fprintf(lgbcio.kunoug,"showpage\n");
   fprintf(lgbcio.kunoug,"%%%%Trailer\n");
   fprintf(lgbcio.kunoug,"restore\n");
   fprintf(lgbcio.kunoug,"%%%%Pages: %d\n",lgcpos.npages);
   break;
 case ICP_SVUOTA:
   lgsvuo();
   break;
 case ICP_INIDATA:
   fseek(lgbcio.kunmiz,mizhdr.hdr.bldpos,SEEK_SET);
   fread(&lggraf,sizeof(struct lggraf),1,lgbcio.kunmiz);
   break;
 }
 return;
}
/* Sottoprogramma LGMOV */
VOID lgmov(fx,fy)
double fx,fy;
{  if(lgcpos.koutb>=lgcpos.lunout) lgsvuo();
   lgcpos.kxult=fx; lgcpos.kyult=fy;
   lgcpos.koutb+=fprintf(lgbcio.kunoug,"%ld %ld %c ",
   	lgcpos.kxult,lgcpos.kyult,lgcpos.lstpen[lgcpos.lpsg]);
   return;
}
/* Sottoprogramma LGPEN */
VOID lgpen(k)
int k;
{  int kp,kpp;
   if(k!=lggraf.kstpn)
   {  kp=ABS(k);
      kpp=ABS(lggraf.kstpn);
      if(kp!=kpp)
      {  lgsvuo();
	 fprintf(lgbcio.kunoug,"%d setlinewidth\n",lgcpos.cpen[--kp]);
      }
      lgcpos.lpsg=((lggraf.kstpn=k)>0)? 0:1;
   }
   return;
}
