/* <stpiot> : 
Sottoprogrammi di I/O da terminale 
   -	lettura di dati con o senza eco
   -	conversione in input dal formato ASCII al formato binario
   -	azzeramento dello schermo
   -	lettura con modifica opzionale di valori numerici
*/
#include <stdio.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#if MIZAR_PCVERSION
#include <conio.h>
#endif
#if MIZAR_LinuxVERSION
#include <termios.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "mizcmn.h"
extern struct lgbcio lgbcio;
#endif
/*  */
#if MIZAR_PCVERSION
/* 
Codici della tastiera in input 
*/
/* Tasti preceduti dal prefisso SPKB_PREFIX  */
#define SPKB_PREFIX 0
#define SHF_F1 84
#define SHF_F2 85
#define SHF_F3 86
#define SHF_F4 87
#define SHF_F5 88
#define SHF_F6 89
#define SHF_F7 90
#define SHF_F8 91
#define SHF_F9 92
#define SHF_F10 93
#define TASTO_F1 59
#define TASTO_F2 60
#define TASTO_F3 61
#define TASTO_F4 62
#define TASTO_F5 63
#define TASTO_F6 64
#define TASTO_F7 65
#define TASTO_F8 66
#define TASTO_F9 67
#define TASTO_F10 68
#define ALT_F1 104
#define ALT_F2 105
#define ALT_F3 106
#define ALT_F4 107
#define ALT_F5 108
#define ALT_F6 109
#define ALT_F7 110
#define ALT_F8 111
#define ALT_F9 112
#define ALT_F10 113
#define TASTO_INS 82
#define TASTO_HOME 71
#define TASTO_PAGSU 73
#define TASTO_CANC 83
#define TASTO_FINE 79
#define TASTO_PAGIU 81
#define FRECCIA_SU 72
#define FRECCIA_SIN 75
#define FRECCIA_GIU 80
#define FRECCIA_DES 77
#define SHF_TAB 15
#endif
#if MIZAR_LinuxVERSION
#define SPKB_PREFIX '\033'
#define SEQ_TASTO_F1    "\033\117\120"
#define SEQ_TASTO_F2    "\033\117\121"
#define SEQ_TASTO_F3    "\033\117\122"
#define SEQ_TASTO_F4    "\033\117\123"
#define SEQ_SHF_F1      "\033\117\062\120"
#define SEQ_SHF_F2      "\033\117\062\121"
#define SEQ_SHF_F3      "\033\117\062\122" 
#define SEQ_SHF_F4      "\033\117\062\123"
#define SEQ_TASTO_F5    "\033\133\061\065\176"
#define SEQ_TASTO_F6    "\033\133\061\067\176"
#define SEQ_TASTO_F7    "\033\133\061\070\176"
#define SEQ_TASTO_F8    "\033\133\061\071\176"
#define SEQ_TASTO_F9    "\033\133\062\060\176"
#define SEQ_TASTO_F10   "\033\133\062\061\176" 
#define SEQ_SHF_F5      "\033\133\061\065\073\062\176"
#define SEQ_SHF_F6      "\033\133\061\067\073\062\176"
#define SEQ_SHF_F7      "\033\133\061\070\073\062\176"
#define SEQ_SHF_F8      "\033\133\061\071\073\062\176"
#define SEQ_SHF_F9      "\033\133\062\060\073\062\176" 
#define SEQ_SHF_F10     "\033\133\062\061\073\062\176" 
#define SEQ_TASTO_HOME  "\033\133\110"
#define SEQ_TASTO_FINE  "\033\133\106"
#define SEQ_TASTO_INS   "\033\133\062\176"
#define SEQ_TASTO_PAGSU "\033\133\065\176"
#define SEQ_TASTO_CANC  "\033\133\063\176"
#define SEQ_TASTO_PAGIU "\033\133\066\176"
#define SEQ_FRECCIA_SU  "\033\133\101"
#define SEQ_FRECCIA_SIN "\033\133\104" 
#define SEQ_FRECCIA_GIU "\033\133\102"
#define SEQ_FRECCIA_DES "\033\133\103"
#define SEQ_SHF_TAB     "\033\133\132"
#define ETX  '\003'
#define SHF_F1 0x401B
#define SHF_F2 0x411B
#define SHF_F3 0x421B
#define SHF_F4 0x431B
#define SHF_F5 0x441B
#define SHF_F6 0x41B
#define SHF_F7 0x461B
#define SHF_F8 0x471B
#define SHF_F9 0x481B
#define SHF_F10 0x491B
#define TASTO_F1 0x4A1B
#define TASTO_F2 0x4B1B
#define TASTO_F3 0x4C1B
#define TASTO_F4 0x4D1B
#define TASTO_F5 0x4E1B
#define TASTO_F6 0x4F1B
#define TASTO_F7 0x501B
#define TASTO_F8 0x511B
#define TASTO_F9 0x521B
#define TASTO_F10 0x531B
#define TASTO_INS 0x541B
#define TASTO_HOME 0x551B
#define TASTO_PAGSU 0x561B
#define TASTO_CANC 0x571B
#define TASTO_FINE 0x581B
#define TASTO_PAGIU 0x591B
#define FRECCIA_SU 0x5A1B
#define FRECCIA_SIN 0x5B1B
#define FRECCIA_GIU 0x5C1B
#define FRECCIA_DES 0x5D1B
#define SHF_TAB 0x5E09
#endif
/* Tasti non preceduti dal prefisso SPKB_PREFIX  */
#define NUL '\000'
#define BEL '\007'
#define GOMMA '\010'
#define GOMMA_1 '\177'
#define TAB '\011'
#define LF '\012'
#define FF '\014'
#define CR '\015'
#define CTRLD '\004'
#define CTRLU '\025'
#define CTRLX '\030'
#define CTRLZ '\032'
#define ESC '\033'
#define BLANK '\040'
/*  */
/* Costanti */
#define FALSE 0
#define TRUE 1
/*  */
#if MIZAR_PCVERSION
/* Sequenze di controllo in output */
#define SCH_HVP "\033[%d;%dH"
   				/* Horizontal Vertical Position*/
#define SCH_CUU "\033[%dA"
   				/* Cursor Up %d lines*/
#define SCH_CUD "\033[%dB"
   				/* Cursor Down %d lines*/
#define SCH_CUF "\033[%dC"
   				/* Cursor Forward %d columns */
#define SCH_CUB "\033[%dD"
   				/* Cursor Backward %d columns */
#define SCH_ED "\033[2J"
   				/* Erase screen and Home position */
#define SCH_EL "\033[K"
   				/* Erase to end of line */
#define SCH_RESET "\033[0m"
   				/* Reset degli attributi schermo */
#define SCH_BOLD "\033[1m"
   				/* Grassetto */
#define SCH_REVERSE "\033[7m"
   				/* Reverse */
#endif
#if MIZAR_LinuxVERSION
#define SCH_HVP "\033[%d;%dH"
   				/* Horizontal Vertical Position*/
#define SCH_CUU "\033[%dA"
   				/* Cursor Up %d lines*/
#define SCH_CUD "\033[%dB"
   				/* Cursor Down %d lines*/
#define SCH_CUF "\033[%dC"
   				/* Cursor Forward %d columns */
#define SCH_CUB "\033[%dD"
   				/* Cursor Backward %d columns */
#define SCH_ED "\033[2J"
   				/* Erase screen and Home position */
#define SCH_EL "\033[K"
   				/* Erase to end of line */
#define SCH_RESET "\033[0m"
   				/* Reset degli attributi schermo */
#define SCH_BOLD "\033[1m"
   				/* Grassetto */
#define SCH_REVERSE "\033[7m"
   				/* Reverse */
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
#define N_LINBUF 256
/*  */
struct lginbf
{  char *linptr[16];
   char *lfrptr;
   int linmem;
   char linbuf[N_LINBUF];
}  lginbf={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,NUL};
/*  */
/* Sottoprogramma lgdint */
INT lgdint(buf,kin,kfi,i)
CHAR buf[];
int kin,kfi;
INT *i;
{  int j;
   long l;
   j=lgdlng(buf,kin,kfi,&l);
   *i=l;
   return(j);
}
/* Sottoprogramma lgdlng */
INT lgdlng(buf,kin,kfi,i)
CHAR buf[];
int kin,kfi;
LONG *i;
{  unsigned char neg;
   int k,k0,l;
   *i=0;
   if(kfi<kin) return(kfi-kin);
   				/* Elimina eventuali blank iniziali */
   for(k=kin;buf[k]==BLANK;k++);
   				/* Controllo del segno */
   neg=(buf[k]=='-');
   if(neg || buf[k]=='+') k++;
   for(l=k;l<=kfi;l++)
   {  if(buf[l]<'0' || buf[l]>'9')
      {  l=kin-l;
	 goto esci;
      }
      *i=10*(*i)+(buf[l]-'0');
   }
   l-=kin;
esci:
   if(neg) *i=-(*i);
   return(l);
}
/* Sottoprogramma lgdrea */
INT lgdrea(buf,kin,kfi,rea)
CHAR buf[];
int kin,kfi;
FLOAT *rea;
{  double tmp;
   int j;
   j=lgddbl(buf,kin,kfi,&tmp);
   *rea=tmp;
   return(j);
}
/* Sottoprogramma lgddbl */
INT lgddbl(buf,kin,kfi,dbl)
CHAR buf[];
int kin,kfi;
DOUBLE *dbl;
{  unsigned char neg;
   int k,l,j;
   double x;
   				/* Elimina eventuali blank iniziali */
   for(k=kin;buf[k]==BLANK;k++);
   				/* Controllo del segno */
   neg=(buf[k]=='-');
   if(neg || buf[k]=='+') k++;
	    			/* Decodifica la parte intera */
   l=lgddbb(buf,k,kfi,dbl);
   k+=(ABS(l));
   if(l>0) goto esci;
   				/* Decodifica la parte frazionaria */
   if(buf[k]=='.')
   {  l=0;
      k++;
      if(k>kfi) goto esci;
      l=lgddbb(buf,k,kfi,&x);
      if(l!=0)
      {  j=ABS(l);
	 *dbl+=(x*lgpow10(-j));
	 k+=(ABS(l));
	 if(l>0) goto esci;
      } 
   }
      				/* Decodifica l'esponente di 10. */
   switch(buf[k])
   {  case BLANK:
      case TAB:
	 l=-1;
	 break;
      case 'd':
      case 'e':
      case 'D':
      case 'E':
	 k++;
      default:
	 l=lgdint(buf,k,kfi,&j);
	 if(l==0)
	 {  l=-1;
	 }
	 else
	 {  *dbl*=lgpow10(j);
	    k+=(ABS(l));
	 }
   }
esci:
   k-=kin;
   if(l<0) k=(-k);
   if(neg) *dbl=(-(*dbl));
   return(k);
}
/* Sottoprogramma lgddbb */
INT lgddbb(buf,kin,kfi,d)
CHAR buf[];
int kin,kfi;
DOUBLE *d;
{  int k,l;
   *d=0.;
   if(kfi<kin) return(kfi-kin);
   for(l=kin;l<=kfi;l++)
   {  if(buf[l]<'0' || buf[l]>'9') return(kin-l);
      *d=10*(*d)+(buf[l]-'0');
   }
   return(l-kin);
}
/* Sottoprogramma lgelbl */
INT lgelbl(buf,n)
CHAR buf[];
int n;
{  unsigned char prblnk;
   int i,k;
   if(n<=0) return(0);
   prblnk=TRUE;
   k=0;
   for(i=0;i<n;i++)
   {  if(buf[i]==TAB) buf[i]=' ';
      if(buf[i]!=' ' || prblnk) 
      {  /* if(buf[i]>='a' && buf[i]<='z') buf[i]-=' '; */
	 buf[k]=buf[i];
	 prblnk=(buf[k++]!=' ');
      }
   }
   while(buf[k-1]==' ') k--;
   buf[k]=NUL;
   return(k);
}
/* Sottoprogramma lgrdst */
#if MIZAR_PCVERSION
/* Versione PC - Microsoft C */
INT lgrdst(buf,nb,ctrm)
CHAR buf[];
int nb;
CHAR *ctrm;
{  int i=0;
   int j=0;
   int ic=0;
   int jb=0;
   int lnc=-1;
   int jm,l;
   unsigned char stins=FALSE;
   unsigned char nonmod=FALSE;
   char c,*p1,*p2;
   jm=nb-1;
   if(jm<=0) return(0);
   buf[0]=NUL;
vai:
   if(ic>i)
   {  cprintf(SCH_CUB,ic-i);
      cprintf("%s",buf+i);   
   }
   else if((ic<i) || ((ic==i) && (i<j)))
   {  cprintf("%s",buf+ic);   
   }
   cprintf(SCH_EL);
   if(i<j) cprintf(SCH_CUB,j-i);
   ic=i;
becca:
   c=getch();
   if(c<BLANK && c!=TAB)
   {  if(c==SPKB_PREFIX) c=getch();
      switch(c)
      {  case GOMMA:
	    if(i>0)
	    {  i--;
	       for(l=i;l<=j;l++) buf[l]=buf[l+1];
	       j--;
	    }
	    break;
	 case TASTO_CANC:
	    if(i<j)
	    {  for(l=i;l<=j;l++) buf[l]=buf[l+1];
	       j--;
	    }
	    break;
	 case CTRLU:
         case CTRLX:
	    i=0;
	    j=0;
	    buf[0]=NUL;
	    break;
         case TASTO_INS:
	    stins=(!stins);
	    goto becca;
         case CR:
         case LF:
         case CTRLD:
         case CTRLZ:
	 case ESC:
	    *ctrm=c;
	    goto uscita;
         case FRECCIA_SIN:
	    if(i>0)
	    {  i--;
	       cprintf(SCH_CUB,1);
	       ic--;
	    }
	    goto becca;
         case FRECCIA_DES:
	    if(i<j)
	    {  i++;
	       cprintf(SCH_CUF,1);
	       ic++;
	    }
	    goto becca;
	 case TASTO_HOME:
	    i=0;
	    break;
	 case TASTO_FINE:
	    i=j;
	    break;
         case FRECCIA_SU:
	    lnc++; if(lnc>=lginbf.linmem) lnc=0;
	    goto richiama;
         case FRECCIA_GIU:
	    lnc--; if(lnc<0) lnc=lginbf.linmem-1;
richiama:
	    if(lginbf.linmem!=0)
	    {  if(ic!=0) cprintf(SCH_CUB,ic);
	       ic=0;
	       p1=lginbf.linptr[lnc];
	       i=0;
	       while((buf[i++]=(*p1++))!=NUL);
	       i--; j=i;
	       nonmod=TRUE;
	       goto vai;
	    }
	    else
	    {  lnc=-1;
	    }
         default:
	    putch(BEL);
	    goto becca;
      }
   }
   else if(c<'\176')
   {  if(j==jm)
      {  putch(BEL);
	 goto becca;
      }
      else
      {  if(i==j)
	 {  buf[++j]=NUL;
	    buf[i++]=c;
	 }
	 else 
	 {  if(stins)
	    {  for(l=j;l>=i;l--) buf[l+1]=buf[l];
	       buf[i++]=c;
	       buf[++j]=NUL;
	    }
	    else
	    {  buf[i++]=c;
	    }
	 }	 
      }
   }
   nonmod=FALSE;
   goto vai;
uscita:
   if(j<=1 || nonmod) goto crlf;
   if(lginbf.linmem!=0)
   {  lginbf.lfrptr+=(j+1);
      while(lginbf.linmem>=16 || lginbf.lfrptr>lginbf.linbuf+N_LINBUF) 
	 	lginbf.lfrptr=lginbf.linptr[--lginbf.linmem]+j+1;
      if(lginbf.linmem==0) goto uscita;
      for(l=lginbf.linmem;l>0;l--) lginbf.linptr[l]=lginbf.linptr[l-1]+j+1;
      p2=lginbf.lfrptr;
      p1=p2-j-1;
      while(p1>lginbf.linbuf) *(--p2)=*(--p1);
   }
   else
   {  lginbf.linptr[0]=lginbf.linbuf;
      lginbf.lfrptr=lginbf.linbuf+j+1;
   }
   if(j<=N_LINBUF)
   {  p1=lginbf.linbuf;
      for(l=0;l<=j;*p1++=buf[l++]);
      lginbf.linmem++;
   }
crlf:
   cprintf("%c%c",CR,LF);
   return(j);
}
#endif
#if MIZAR_LinuxVERSION
/* Versione Linux - GCC compiler */
#define N_SPEC_CHAR 10
/* ### */
				/* linux_getch : sostituisce la funzione getch: legge un
				   singolo carattere, riconoscendo alcuni tasti
				   funzione */
int linux_getch()
{
  int j;
  char buf[N_SPEC_CHAR];
  if((buf[0]=fgetc(lgbcio.kuninp))!=SPKB_PREFIX) return(buf[0]);
  buf[1]=fgetc(lgbcio.kuninp);
  if((buf[1]!='\117') && (buf[1]!='\133')) {
    ungetc(buf[1],lgbcio.kuninp);
    return(SPKB_PREFIX);
  }
  for(j=2;j<N_SPEC_CHAR-1;) {
    buf[j]=fgetc(lgbcio.kuninp); buf[++j]=NUL;
    if(strncmp(buf,SEQ_TASTO_F1,N_SPEC_CHAR)==0) return(TASTO_F1);
    if(strncmp(buf,SEQ_TASTO_F2,N_SPEC_CHAR)==0) return(TASTO_F2);
    if(strncmp(buf,SEQ_TASTO_F3,N_SPEC_CHAR)==0) return(TASTO_F3);
    if(strncmp(buf,SEQ_TASTO_F4,N_SPEC_CHAR)==0) return(TASTO_F4);
    if(strncmp(buf,SEQ_SHF_F1,N_SPEC_CHAR)==0) return(SHF_F1);
    if(strncmp(buf,SEQ_SHF_F2,N_SPEC_CHAR)==0) return(SHF_F2);
    if(strncmp(buf,SEQ_SHF_F3,N_SPEC_CHAR)==0) return(SHF_F3);
    if(strncmp(buf,SEQ_SHF_F4,N_SPEC_CHAR)==0) return(SHF_F4);
    if(strncmp(buf,SEQ_TASTO_F5,N_SPEC_CHAR)==0) return(TASTO_F5);
    if(strncmp(buf,SEQ_TASTO_F6,N_SPEC_CHAR)==0) return(TASTO_F6);
    if(strncmp(buf,SEQ_TASTO_F7,N_SPEC_CHAR)==0) return(TASTO_F7);
    if(strncmp(buf,SEQ_TASTO_F8,N_SPEC_CHAR)==0) return(TASTO_F8);
    if(strncmp(buf,SEQ_TASTO_F9,N_SPEC_CHAR)==0) return(TASTO_F9);
    if(strncmp(buf,SEQ_TASTO_F10,N_SPEC_CHAR)==0) return(TASTO_F10);
    if(strncmp(buf,SEQ_SHF_F5,N_SPEC_CHAR)==0) return(SHF_F5);
    if(strncmp(buf,SEQ_SHF_F6,N_SPEC_CHAR)==0) return(SHF_F6);
    if(strncmp(buf,SEQ_SHF_F7,N_SPEC_CHAR)==0) return(SHF_F7);
    if(strncmp(buf,SEQ_SHF_F8,N_SPEC_CHAR)==0) return(SHF_F8);
    if(strncmp(buf,SEQ_SHF_F9,N_SPEC_CHAR)==0) return(SHF_F9);
    if(strncmp(buf,SEQ_SHF_F10,N_SPEC_CHAR)==0) return(SHF_F10);
    if(strncmp(buf,SEQ_TASTO_HOME,N_SPEC_CHAR)==0) return(TASTO_HOME);
    if(strncmp(buf,SEQ_TASTO_FINE,N_SPEC_CHAR)==0) return(TASTO_FINE);
    if(strncmp(buf,SEQ_TASTO_INS,N_SPEC_CHAR)==0) return(TASTO_INS);
    if(strncmp(buf,SEQ_TASTO_PAGSU,N_SPEC_CHAR)==0) return(TASTO_PAGSU);
    if(strncmp(buf,SEQ_TASTO_CANC,N_SPEC_CHAR)==0) return(TASTO_CANC);
    if(strncmp(buf,SEQ_TASTO_PAGIU,N_SPEC_CHAR)==0) return(TASTO_PAGIU);
    if(strncmp(buf,SEQ_FRECCIA_SU,N_SPEC_CHAR)==0) return(FRECCIA_SU);
    if(strncmp(buf,SEQ_FRECCIA_SIN,N_SPEC_CHAR)==0) return(FRECCIA_SIN);
    if(strncmp(buf,SEQ_FRECCIA_GIU,N_SPEC_CHAR)==0) return(FRECCIA_GIU);
    if(strncmp(buf,SEQ_FRECCIA_DES,N_SPEC_CHAR)==0) return(FRECCIA_DES);
    if(strncmp(buf,SEQ_SHF_TAB,N_SPEC_CHAR)==0) return(SHF_TAB);
  }
  return(-1);
}
/* ### */
INT lgrdst(buf,nb,ctrm)
CHAR buf[];
int nb;
CHAR *ctrm;
{  int i=0;
   int j=0;
   int ic=0;
   int jb=0;
   int lnc=-1;
   int jm,l;
   unsigned char stins=TRUE;
   unsigned char nonmod=FALSE;
   char *p1,*p2;
   int c;
   struct termios termios_p,termios_new_p;
   fflush(stdout);               /* Svuota il buffer di output, se c'e' qualcosa, */
   if(lgbcio.kuninp==NULL) lgbcio.kuninp=stdin;
   jm=nb-1;
   if(jm<=0) return(0);
   tcgetattr(STDIN_FILENO,&termios_new_p);
   termios_p = termios_new_p;    /* and make a copy */
   termios_new_p.c_lflag &= !(ICANON);
   /*   termios_new_p.c_lflag |= ECHO; Remove this to suppress auto-echo */
   tcsetattr ( STDIN_FILENO, TCSAFLUSH, &termios_new_p);
   buf[0]=NUL;
 vai:
   if(ic>i) {
     printf(SCH_CUB,ic-i);
     printf("%s",buf+i);   
   }
   else if((ic<i) || ((ic==i) && (i<j))) {
     printf("%s",buf+ic);   
   }
   printf(SCH_EL);
   if(i<j) printf(SCH_CUB,j-i);
   ic=i;
 becca:
   c=linux_getch();
   if((c<BLANK && c!=TAB) || c>=GOMMA_1) {
     switch(c) {
     case GOMMA:
     case GOMMA_1:
       if(i>0) {
	 i--;
	 for(l=i;l<=j;l++) buf[l]=buf[l+1];
	 j--;
       }
       break;
     case TASTO_CANC:
       if(i<j) {
	 for(l=i;l<=j;l++) buf[l]=buf[l+1];
	 j--;
       }
       break;
     case CTRLU:
     case CTRLX:
       i=0;
       j=0;
       buf[0]=NUL;
       break;
     case TASTO_INS:
       stins=(!stins);
       goto becca;
     case CR:
     case LF:
     case CTRLD:
     case CTRLZ:
     case ESC:
       *ctrm=c;
       goto uscita;
     case FRECCIA_SIN:
       if(i>0) {
	 i--;
	 printf(SCH_CUB,1);
	 ic--;
       }
       goto becca;
     case FRECCIA_DES:
       if(i<j) {
	 i++;
	 printf(SCH_CUF,1);
	 ic++;
       }
       goto becca;
     case TASTO_HOME:
       i=0;
       break;
     case TASTO_FINE:
       i=j;
       break;
     case FRECCIA_SU:
       lnc++; if(lnc>=lginbf.linmem) lnc=0;
       goto richiama;
     case FRECCIA_GIU:
       lnc--; if(lnc<0) lnc=lginbf.linmem-1;
     case -1:
       *ctrm = -1;
       goto uscita;
     richiama:
       if(lginbf.linmem!=0) {
	 if(ic!=0) printf(SCH_CUB,ic);
	 ic=0;
	 p1=lginbf.linptr[lnc];
	 i=0;
	 while((buf[i++]=(*p1++))!=NUL);
	 i--; j=i;
	 nonmod=TRUE;
	 goto vai;
       }
       else {
	 lnc=-1;
       }
     default:
       putchar(BEL);
       goto becca;
     }
   }
   else if(c<'\176') {
     if(j==jm) {
       putchar(BEL);
       goto becca;
     }
     else {
       if(i==j) {
	 buf[++j]=NUL;
	 buf[i++]=c;
       }
       else  {
	 if(stins) {
	   for(l=j;l>=i;l--) buf[l+1]=buf[l];
	   buf[i++]=c;
	   buf[++j]=NUL;
	 }
	 else {
	   buf[i++]=c;
	 }
       }	 
     }
   }
   nonmod=FALSE;
   goto vai;
uscita:
   if(j<=1 || nonmod) goto crlf;
   if(lginbf.linmem!=0) {
     lginbf.lfrptr+=(j+1);
     while(lginbf.linmem>=16 || lginbf.lfrptr>lginbf.linbuf+N_LINBUF) 
       lginbf.lfrptr=lginbf.linptr[--lginbf.linmem]+j+1;
     if(lginbf.linmem==0) goto uscita;
     for(l=lginbf.linmem;l>0;l--) lginbf.linptr[l]=lginbf.linptr[l-1]+j+1;
     p2=lginbf.lfrptr;
     p1=p2-j-1;
     while(p1>lginbf.linbuf) *(--p2)=*(--p1);
   }
   else {
     lginbf.linptr[0]=lginbf.linbuf;
     lginbf.lfrptr=lginbf.linbuf+j+1;
   }
   if(j<=N_LINBUF) {
     p1=lginbf.linbuf;
     for(l=0;l<=j;*p1++=buf[l++]);
     lginbf.linmem++;
   }
 crlf:
   printf("\n");
   tcsetattr ( STDIN_FILENO, TCSAFLUSH, &termios_p);
   return(j);
}
#endif
/* Sottoprogramma lgrdne */
#if MIZAR_PCVERSION
INT lgrdne(buf,nb,ctrm)
CHAR buf[];
int nb;
CHAR *ctrm;
{  int i=0;
   int jm;
   char c;
   jm=nb-1;
   if(jm<=0) return(0);
   buf[0]=NUL;
vai:
   c=getch();
   if(c<BLANK && c!=TAB)
   {  if(c==SPKB_PREFIX) c=getch();
      switch(c)
      {  case GOMMA:
         case FRECCIA_SIN:
	    if(i>0)
	    {  buf[--i]=NUL;
	    }
	    break;
	 case CTRLU:
         case CTRLX:
	    i=0;
	    buf[0]=NUL;
	    break;
         case CR:
         case LF:
         case CTRLZ:
	 case ESC:
	    *ctrm=c;
	    goto uscita;
         default:
	    putch(BEL);
	    goto vai;
      }
   }
   else if(c<'\176')
   {  if(i==jm)
      {  putch(BEL);
	 goto vai;
      }
      else
      {  buf[i++]=c;
	 buf[i]=NUL;
      }
   }
   goto vai;
uscita:
   return(i);
}
#endif
#if MIZAR_LinuxVERSION
/* Versione Linux - GCC compiler */
INT lgrdne(buf,nb,ctrm)
CHAR buf[];
int nb;
CHAR *ctrm;
{ 
  struct termios termios_p,termios_new_p;
  int i=0;
  int jm;
  int c;
  jm=nb-1;
  if(jm<=0) return(0);
  buf[0]=NUL;
  fflush(stdout);               /* Svuota il buffer di output, se c'e' qualcosa, */
  if(lgbcio.kuninp==NULL) lgbcio.kuninp=stdin;
  tcgetattr(STDIN_FILENO,&termios_new_p);
  termios_p = termios_new_p;    /* and make a copy */
  termios_new_p.c_lflag &= !(ICANON);
  /*   termios_new_p.c_lflag |= ECHO; Remove this to suppress auto-echo */
  tcsetattr ( STDIN_FILENO, TCSAFLUSH, &termios_new_p);
 vai:
  c=linux_getch();
  if((c<BLANK && c!=TAB) || c>=GOMMA_1) {
    switch(c) {
    case GOMMA:
    case GOMMA_1:
    case FRECCIA_SIN:
      if(i>0) {
	buf[--i]=NUL;
      }
      break;
    case CTRLU:
    case CTRLX:
      i=0;
      buf[0]=NUL;
      break;
    case CR:
    case LF:
    case CTRLZ:
    case ESC:
      *ctrm=c;
      goto uscita;
    default:
      putchar(BEL);
      goto vai;
    }
  }
  else if(c<'\176') {
    if(i==jm) {
      putchar(BEL);
      goto vai;
    }
    else {
      buf[i++]=c;
      buf[i]=NUL;
    }
  }
  goto vai;
 uscita:
  tcsetattr ( STDIN_FILENO, TCSAFLUSH, &termios_p);
  return(i);
}
#endif
/* Sottoprogramma lgldln */
INT lgldln(prompt,lval)
CHAR prompt[];
LONG *lval;
{  int j;
   long ltmp;
   char ctrm,buf[10];
   char bufpr[61];
   for(j=0;j<60;j++) if((bufpr[j]=prompt[j])==NUL) break;
   bufpr[61]=NUL;
vai:
   ltmp=*lval;
#if MIZAR_PCVERSION
   cprintf("%s (%ld) : ",bufpr,ltmp);
#endif
#if MIZAR_LinuxVERSION
   fprintf(lgbcio.kuninp,"%s (%ld) : ",bufpr,ltmp);
#endif
   if((j=lgrdst(buf,10,&ctrm))==0) return(j);
   if((j=lgdlng(buf,0,j-1,&ltmp))<=0) {
     lgerr(MIZ_SOUNDBEL);
#if MIZAR_PCVERSION
     cprintf("\n");
#endif
#if MIZAR_LinuxVERSION
     fprintf(lgbcio.kuninp,"\n");
#endif
     goto vai;
   }
   *lval=ltmp;
   return(j);
}
/* Sottoprogramma lgldin */
INT lgldin(prompt,ival)
CHAR prompt[];
INT *ival;
{  long ltmp;
   int j;
   ltmp=*ival;
   j=lgldln(prompt,&ltmp);
   *ival=ltmp;
   return(j);
}
/* Sottoprogramma lglddb */
INT lglddb(prompt,val)
CHAR prompt[];
DOUBLE *val;
{  double tmp;
   int j;
   char ctrm,buf[40];
   char bufpr[61];
   for(j=0;j<60;j++) if((bufpr[j]=prompt[j])==NUL) break;
   bufpr[61]=NUL;
vai:
   tmp=*val;
#if MIZAR_PCVERSION
   cprintf("%s (%le) : ",bufpr,tmp);
#endif
#if MIZAR_LinuxVERSION
   fprintf(lgbcio.kuninp,"%s (%le) : ",bufpr,tmp);
#endif
   if((j=lgrdst(buf,40,&ctrm))==0) return(j);
   if((j=lgddbl(buf,0,j-1,&tmp))<=0) {
     lgerr(MIZ_SOUNDBEL);
#if MIZAR_PCVERSION
     cprintf("\n");
#endif
#if MIZAR_LinuxVERSION
     fprintf(lgbcio.kuninp,"\n");
#endif
     goto vai;
   }
   *val=tmp;
   return(j);
}
/* Sottoprogramma lgldre */
INT lgldre(prompt,val)
CHAR prompt[];
FLOAT *val;
{  double tmp;
   int j;
   tmp=*val;
   j=lglddb(prompt,&tmp);
   *val=tmp;
   return(j);
}
/* Sottoprogramma lgclrs */
VOID lgclrs()
{
#if MIZAR_PCVERSION
  cprintf(SCH_ED);
#endif
#if MIZAR_LinuxVERSION
  system("clear");
#endif
  return;
}
#if MIZAR_PCVERSION
/*

lgposc(riga,colonna)
int riga;
int colonna;
{  cprintf(SCH_HVP,riga,colonna);
   return;
}

lgcsu(n)
int n;
{  cprintf(SCH_CUU,n);
   return;
}

lgcgiu(n)
int n;
{  cprintf(SCH_CUD,n);
   return;
}

lgcsin(n)
int n;
{  cprintf(SCH_CUB,n);
   return;
}

lgcdes(n)
int n;
{  cprintf(SCH_CUF,n);
   return;
}

lgbold()
{  cprintf(SCH_BOLD);
   return;
}

lgrevr()
{  cprintf(SCH_REVERSE);
   return;
}

lgrset()
{  cprintf(SCH_RESET);
   return;
}

lgeeol()
{  cprintf(SCH_EL);
   return;
}
*/
#endif
