/* <stputl> : 
Sottoprogrammi di utilita' generale:
   -	conversione gradi <-> radianti
   -	scelta dell'alfabeto
   -	calcolo di somme, massimi, minimi e medie su vettori
   -	tracciamento di cerchi in coordinate grafico o utente
   -	tracciamento del grafico di una funzione
   -	gestione di tabelle di bit
 */
#include <stdio.h>
#include <math.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/* Sottoprogramma retpag */
VOID retpag()
{  double gx,gy;
   paglim(&gx,&gy);
   grmov(0.,0.);
   grseg(gx,0.);
   grseg(gx,gy);
   grseg(0.,gy);
   grseg(0.,0.);
   return;
}
/* Sottoprogramma paglim */
VOID paglim(gx,gy)
DOUBLE *gx,*gy;
{  *gx=lgbc2d.g2lim[MIZ_GRAFPAG][1];
   *gy=lgbc2d.g2lim[MIZ_GRAFPAG][3];
   return;
}
/* Sottoprogramma alfbet */
VOID alfbet(k)
int k;
{  if(k>0 && k<MIZ_NUMALFC)
   {  
/* Modifica l'alfabeto */
      lgbcsa.kalf=(k-1)*64;
#if MIZ_INTERATTIVA
      lgbcsg.kalfu=lgbcsa.kalf;
#endif
   }
   else
   {  lgerr(LGE_ALFABETO);
   }
   return;
}
/* Sottoprogramma gmsgra */
DOUBLE gmsgra(igra,ipri,isec,icent)
int igra,ipri,isec,icent;
{  return(((.01*icent+isec)/60.+ipri)/60.+igra);
}
/* Sottoprogramma gmsrad */
DOUBLE gmsrad(igra,ipri,isec,icent)
int igra,ipri,isec,icent;
{  return(lgbccs.grarad*gmsgra(igra,ipri,isec,icent));
}
/* Sottoprogramma gradi */
DOUBLE gradi(rad)
double rad;
{  return(lgbccs.radgra*rad);
}
/* Sottoprogramma gragms */
VOID gragms(gra,igra,ipri,isec,icent)
double gra;
INT *igra,*ipri,*isec,*icent;
{  double a;
   a=gra;
   *igra=a;
   a=fmod(a,1.)*60.;
   *ipri=a;
   a=fmod(a,1.)*60.;
   *isec=a;
   a=fmod(a,1.)*100.;
   *icent=a;
   return;
}
/* Sottoprogramma radgms */
VOID radgms(rad,igra,ipri,isec,icent)
double rad;
INT *igra,*ipri,*isec,*icent;
{  gragms(lgbccs.radgra*rad,igra,ipri,isec,icent);
   return;
}
/* Sottoprogramma radian */
DOUBLE radian(gra)
double gra;
{  return(lgbccs.grarad*gra);
}
/* Sottoprogramma angrid */
DOUBLE angrid(ang)
     double ang;
{
  DOUBLE angr;
  if((angr=fmod(ang,lgbccs.angiro)) < 0.) 
    angr += lgbccs.angiro;
  return(angr);
}
/* Sottoprogramma grcer */
VOID grcer(raggio,modo,motra)
double raggio;
int modo;
INT motra[];
{  double xprec,yprec,teta,dteta,gx,gy;
   int kk=MIZ_SEG;
   int npun,kp,i;
   if(modo<0)
   {  kk=MIZ_TRA;
      deftrt(motra);
   }
   npun=2.*lgbccs.pigrec*ABS(raggio)+2;
   grcoor(&xprec,&yprec,&kp);
   dteta=2.*lgbccs.pigrec/(npun-1);
   grmovr(raggio,0.);
   for(i=1;i<npun;i++)
   {  teta=i*dteta;
      gx=xprec+raggio*cos(teta);
      gy=yprec+raggio*sin(teta);
      lgplot(gx,gy,kk);
   }
   grmov(xprec,yprec);
   return;
}
/* Sottoprogramma utcer */
VOID utcer(raggio,modo,motra)
double raggio;
int modo;
INT motra[];
{  int npun,kp,i;
   double gr,xprec,yprec,dteta,teta,x,y;
   int kk=MIZ_SEG;
/* Controllo delle condizioni di errore */
   if(lgbc2d.kcoord!=MIZ_CLINEARI)
   {  lgerr(LGE_SISTCOORD);
      return;
   }
/* Tracciamento */
   if(modo<0)
   {  kk=MIZ_TRA;
      deftrt(motra);
   }
   gr=MAX(lgbc2d.co2ug[0],lgbc2d.co2ug[1]);
   gr*=raggio;
   gr=ABS(gr);
   npun=2.*lgbccs.pigrec*gr+2;
   utcoor(&xprec,&yprec,&kp);
   dteta=2.*lgbccs.pigrec/(npun-1);
   utmovr(raggio,0.);
   for(i=1;i<npun;i++)
   {  teta=i*dteta;
      x=xprec+raggio*cos(teta);
      y=yprec+raggio*sin(teta);
      lgplot(x,y,kk);
   }
   utmov(xprec,yprec);
   return;
}
/* Sottoprogramma grellisse */
VOID grellisse(double sam,double ecc,double psi0,int modo,int *motra)
{  double b,xprec,yprec,teta,dteta,gx,gy,psi;
   int kk=MIZ_SEG;
   int npun,kp,i;
/* Controllo delle condizioni di errore */
   if(ecc < 0. || ecc >= 1.) {
     lgerr(LGE_WRONGECC);
     return;
   }
   b = sam*sqrt(1.-ecc*ecc);
   /* Tracciamento */   
   if(lgbcge.kanrad) psi = psi0;  else psi = psi0*lgbccs.grarad;
   if(modo<0) {
     kk=MIZ_TRA;
     deftrt(motra);
   }
   npun=2.*lgbccs.pigrec*ABS(sam)+2;
   grcoor(&xprec,&yprec,&kp);
   dteta=2.*lgbccs.pigrec/(npun-1);
   gx = xprec+sam*cos(psi)-ecc;
   gy = yprec+b*sin(psi);
   grmov(gx,gy);
   for(i=1;i<npun;i++){
     teta=i*dteta;
     gx=xprec+sam*cos(teta+psi)-ecc;
     gy=yprec+b*sin(teta+psi);
     lgplot(gx,gy,kk);
   }
   grmov(xprec,yprec);
   return;
}
/* Sottoprogramma utellisse */
VOID utellisse(double sam,double ecc,double psi0,int modo,int *motra)
{  int npun,kp,i;
  double b,gr,xprec,yprec,dteta,teta,x,y,psi;
   int kk=MIZ_SEG;
/* Controllo delle condizioni di errore */
   if(lgbc2d.kcoord!=MIZ_CLINEARI)
   {  lgerr(LGE_SISTCOORD);
      return;
   }
   if(ecc < 0. || ecc >= 1.) {
     lgerr(LGE_WRONGECC);
     return;
   }
/* Tracciamento */
   b = sqrt(1.-ecc*ecc);
   if(lgbcge.kanrad) psi = psi0;  else psi = psi0*lgbccs.grarad;
   if(modo<0)
   {  kk=MIZ_TRA;
      deftrt(motra);
   }
   gr=MAX(lgbc2d.co2ug[0],lgbc2d.co2ug[1]);
   gr*=sam;
   gr=ABS(gr);
   npun=2.*lgbccs.pigrec*gr+2;
   utcoor(&xprec,&yprec,&kp);
   dteta=2.*lgbccs.pigrec/(npun-1);
   x = xprec+sam*cos(psi)-ecc;
   y = yprec+b*sin(psi);
   utmov(x,y);
   for(i=1;i<npun;i++)
   {  teta=i*dteta;
      x=xprec+sam*cos(teta+psi)-ecc;
      y=yprec+b*sin(teta+psi);
      lgplot(x,y,kk);
   }
   utmov(xprec,yprec);
   return;
}
/* Sottoprogramma lgclrb */
INT lgclrb(k,nbit)
UNSCHAR k[];
long int nbit;
{  int iw,ib;
   int nbw=sizeof(UNSCHAR);
   unsigned char mask;
   if(nbit<0) return(-1);
   iw=nbit/nbw;
   ib=nbit%nbw;
   mask=1; mask<<=ib;
   if((k[iw]&mask)==0) 
   {  return(0);
   }
   else
   {  k[iw]&=(~mask);
      return(1);
   }
}
/* Sottoprogramma lgsetb */
INT lgsetb(k,nbit)
UNSCHAR k[];
long int nbit;
{  int iw,ib;
   int nbw=sizeof(UNSCHAR);
   unsigned char mask;
   if(nbit<0) return(-1);
   iw=nbit/nbw;
   ib=nbit%nbw;
   mask=1; mask<<=ib;
   if((k[iw]&mask)!=0) 
   {  return(1);
   }
   else
   {  k[iw]|=mask;
      return(0);
   }
}
/* Sottoprogramma lgstab */
INT lgstab(k,nbit)
UNSCHAR k[];
long int nbit;
{  int iw,ib;
   int nbw=sizeof(UNSCHAR);
   unsigned char mask;
   if(nbit<0) return(-1);
   iw=nbit/nbw;
   ib=nbit%nbw;
   mask=1; mask<<=ib;
   if((k[iw]&mask)!=0) 
   {  return(1);
   }
   else
   {  return(0);
   }
}
/* Sottoprogramma lgfmin */
VOID lgfmin(vet,nv,rmin)
DOUBLE vet[];
long int nv;
DOUBLE *rmin;
{  if(nv<=0)
   {  *rmin=0.;
   }
   else
   {  int i;
      *rmin=vet[0];
      for(i=0;i<nv;i++) *rmin=MIN(*rmin,vet[i]);
   }
   return;
}
/* Sottoprogramma lgfmax */
VOID lgfmax(vet,nv,rmax)
DOUBLE vet[];
long int nv;
DOUBLE *rmax;
{  if(nv<=0)
   {  *rmax=0.;
   }
   else
   {  int i;
      *rmax=vet[0];
      for(i=0;i<nv;i++) *rmax=MAX(*rmax,vet[i]);
   }
   return;
}
				/* Sottoprogramma lgfmm */
VOID lgfmm(vet,nv,rmin,rmax)
DOUBLE vet[];
long int nv;
DOUBLE *rmin,*rmax;
{  if(nv<=0)
   {  *rmin=0.;
      *rmax=0.;
   }
   else
   {  int i;
      *rmin=vet[0];
      *rmax=vet[0];
      for(i=0;i<nv;i++) 
      {  *rmin=MIN(*rmin,vet[i]);
	 *rmax=MAX(*rmax,vet[i]);
      }
   }
   return;
}
				/* Sottoprogramma lgfmm_log */
VOID lgfmm_log(DOUBLE vet[], long int nv,DOUBLE *rmin, DOUBLE *rmax)
      /* Determina gli estremi assumendo che i dati dovranno
	 rappresentarsi su scala logaritmica, quindi ignora i valori
	 non positivi.
      */
{  
  if(nv<=0) *rmin = *rmax = 1.;
  else {
    int i0, i;
    for(i0=0; i0<nv; i0++) if(vet[i0] > 0.) break;
    if(i0 == nv) *rmin = *rmax = 1.;
    else {
      *rmin = *rmax = vet[i0];
      for(i=i0; i<nv; i++) {
	if(vet[i] <= 0.) continue;
	*rmin=MIN(*rmin,vet[i]);
	*rmax=MAX(*rmax,vet[i]);
      }
    }
  }
  return;
}
				/* Sottoprogramma lgfmed */
VOID lgfmed(x,n,rmed)
DOUBLE x[];
long int n;
DOUBLE *rmed;
{  lgfsum(x,n,rmed);
   *rmed/=n;
   return;
}
				/* ### */
#define LGSUMB 65
				/* Sottoprogramma lgfsum */
VOID lgfsum(x,n,sum)
DOUBLE x[];
long int n;
DOUBLE *sum;
{  static double sump[LGSUMB];
   double dsum;
   int lm=1;
   int l;
   long int j,k;
   for(k=1;k<=n;k++)
   {  j=1;
      l=1;
      sump[0]=x[k-1];
      while((k&j)==0)
      {  sump[l]+=sump[l-1];
	 l++;
	 if(l>=LGSUMB) lgerr(LGE_LGSUMOVF);
	 j<<=1;
      }
      sump[l]=sump[l-1];
      if(l>lm) lm=l;
   }
   j=1;
   dsum=0.;
   for(l=1;l<=lm;l++)
   {  if((j&n)!=0) dsum+=sump[l];
      j<<=1;
   }
   *sum=dsum;
   return;
}
/* Sottoprogramma funrea */
VOID funrea(f,xmin,xmax,iprec,modo,motr)
DOUBLE (*f)();
double xmin,xmax;
int iprec,modo;
INT motr[];
{  int mm=MIZ_SEG;
   double d,x,x0,x1,dx,y;
   int i,n,ip;
   if(lgbc2d.kcoord!=1) lgerr(LGE_COORD);
   lgbc2d.kgrut=MIZ_UTENTE;
   if(modo<0)
   {  deftrt(motr);
      mm=MIZ_TRA;
   }
   x0=MIN(xmin,xmax);
   x1=MAX(xmin,xmax);
   y=f(x0);
   lgplot(x0,y,MIZ_MOV);
   ip=MAX(1,iprec);
   ip=MIN(MIZ_LIVPREC,ip);
   if(ip!=iprec) lgerr(LGE_PRECISIONE);
   dx=lgbccs.precis[ip-1]*lgbc2d.co2gu[0];
   n=(x1-x0)/dx;
   n*=2;
   for (i=0;i<n;i++)
   {  d=(i+1)*dx;
      x=MIN(x0+d,x1);
      y=f(x);
      lgplot(x,y,mm);
      if(x>=x1) break;
   }
   return;
}
				/* Sottoprogramma lginv */
VOID lginv(x,y,n)
DOUBLE x[],y[];
int n;
{  int i,n2;
   double temp;
   if(n<=1) return;
   n2=n/2;
   for(i=0;i<n2;i++)
   {  temp=x[n-i-1];
      x[n-i-1]=x[i];
      x[i]=temp;
      temp=y[n-i-1];
      y[n-i-1]=y[i];
      y[i]=temp;
   }
   return;
}
				/* Sottoprogramma utlin */
VOID utlin(DOUBLE x[], DOUBLE y[], LONG n, INT modo, INT motra[])
{ 
  int i;
  if(modo<0 || modo>4) {
    lgerr(LGE_MTRACCIAM);
  }
  if(n<=1) return;
  /*  if(modo==4) deftrt(motra); */
  utmov((double) x[0],(double) y[0]);
  for(i=0;i<n;i++) {
    switch(modo) {
    case 1:
      utseg(x[i],y[i]);
      break;
    case 2:
      utpun(x[i],y[i]);
      break;
    case 3:
      utsim(x[i],y[i]);
      break;
    case 4:
      uttrt(x[i],y[i]);
      break;
    }
  }
  return;
}
				/* Sottoprogramma lgarrestr */
int lgarrestr(DOUBLE xinf, DOUBLE xsup, DOUBLE *xmen, DOUBLE *xpiu)
      /* 
	 Arrotonda gli estremi di un intervallo all'ultima cifra significativa.

	 Parametri:

	   xinf, xsup:  dati double con gli estremi in ingresso;
	   xmen, xpiu:  indirizzi degli estremi arrotondati;  e' ammesso 
	                che coincidano con gli indirizzi dei dati originari,
			che in tal caso vengono automaticamente modificati.
	 
	 Valore restituito: 0  : l'esecuzione e' corretta; 
	                    -1 : i valori in ingresso non rispettano i limiti 
			         ovvii.
      */
{
  DOUBLE diff, deca, tmp;
  if((diff = xsup-xinf) <= 0.) return(-1);
  deca = floor(log10(diff))-1.;  deca = pow(10., deca);
  if(xinf < 0.) {
    tmp = ceil(-xinf/deca);  tmp *= -deca; 
  }
  else {
    tmp = floor(xinf/deca);  tmp *=  deca;
  }
  *xmen = tmp;
  if(xsup < 0.) {
    tmp = floor(-xsup/deca);  tmp *= -deca; 
  }
  else {
    tmp = ceil(xsup/deca);    tmp *=  deca;
  }
  *xpiu = tmp;
  return(0);
}
				/* Sottoprogramma lgarrestr_log */
int lgarrestr_log(DOUBLE xinf, DOUBLE xsup, DOUBLE *xmen, DOUBLE *xpiu)
      /* 
	 Arrotonda gli estremi di un intervallo alla prima cifra
	 significativa, assumendo che debbano essere rappresentati su
	 una scala logaritmica.

	 Parametri:

	   xinf, xsup:  dati double con gli estremi in ingresso;
	   xmen, xpiu:  indirizzi degli estremi arrotondati;  e' ammesso 
	                che coincidano con gli indirizzi dei dati originari,
			che in tal caso vengono automaticamente modificati.
	 
	 Valore restituito: 0  : l'esecuzione e' corretta; 
	                    -1 : i valori in ingresso non rispettano i limiti 
			         ovvii.
      */
{
  DOUBLE tmp;
  if(xinf > 0.) {
    tmp = floor(log10(xinf));   tmp = pow(10., tmp);
    *xmen = tmp*floor(xinf/tmp);
  }
  if(xsup > 0.) {
    tmp = floor(log10(xsup));   tmp = pow(10., tmp);
    *xpiu = tmp*ceil(xsup/tmp);
  }
  return(0);
}
				/* Sottoprogramma ut_graf_scala */
VOID ut_graf_scala(DOUBLE *x, DOUBLE *y, int ndati, int karea)
      /* 
	 Traccia il grafico di x in funzione di y "a scala".  Adatto 
	 per il tracciamento di istogrammi.

         Parametri:

         x, y:   indirizzi dei vettori dei dati sui due assi.  
	         Si suppone che i dati in x siano ordinati in modo crescente,
		 ma non ci sono controlli.

         ndati:  intero che specifica il numero di dati utili in x, y.

	 karea:  intero che specifica come determinare l'area utente.
	         = 0  :  accetta l'area utente predefinita;
		 = 1  :  definisci l'area utente mediante il minimo e massimo 
		         dei dati, senza arrotondamenti;
		 = 2  :  definisci l'area utente mediante il minimo e massimo 
		         dei dati, arrotondando i valori degli estremi all'ultima 
			 cifra significativa.
	
	 Limitazioni:

	 ndati deve essere > 1.  In caso contrario la chiamata viene ignorata.

      */
{
  DOUBLE xmin, xmax, ymin, ymax, xtmp, ytmp;
  int j;
  if(ndati <= 1) return;
  if(karea > 0) {
    if((lgbc2d.kcoord==MIZ_XLOGYLIN) || (lgbc2d.kcoord==MIZ_CLOG))
      lgfmm_log(x, ndati, &xmin, &xmax);
    else
      lgfmm(x, ndati, &xmin, &xmax);
    if((lgbc2d.kcoord==MIZ_XLINYLOG) || (lgbc2d.kcoord==MIZ_CLOG))
      lgfmm_log(y, ndati, &ymin, &ymax);
    else
      lgfmm(y, ndati, &ymin, &ymax);
    if(karea == 2) {
      if((lgbc2d.kcoord==MIZ_XLOGYLIN) || (lgbc2d.kcoord==MIZ_CLOG))
	lgarrestr_log(xmin, xmax, &xmin, &xmax);
      else
	lgarrestr(xmin, xmax, &xmin, &xmax);
      if((lgbc2d.kcoord==MIZ_XLINYLOG) || (lgbc2d.kcoord==MIZ_CLOG))
	lgarrestr_log(ymin, ymax, &ymin, &ymax);
      else
	lgarrestr(ymin, ymax, &ymin, &ymax);
    }
    utarea(xmin, xmax, ymin, ymax);
  }
  else {
    xmin=lgbc2d.g2lim[MIZ_UTENTE][0];
    xmax=lgbc2d.g2lim[MIZ_UTENTE][1];
    ymin=lgbc2d.g2lim[MIZ_UTENTE][2];
    ymax=lgbc2d.g2lim[MIZ_UTENTE][3];
  }
  switch(lgbc2d.kcoord) {
  case MIZ_XLOGYLIN:
    xtmp = (x[0] > 0.)? x[0] : 1.e-38;
    ytmp = y[0];
    utmov(xtmp, ytmp);
    for(j=0; j<ndati; j++) {
      utseg(xtmp, ytmp);
      xtmp = (x[j] > 0.)? x[j] : 1.e-38;
      ytmp = y[j];
      utseg(xtmp, ytmp);
    }
    utseg(xtmp, ymin);
    break;
  case MIZ_XLINYLOG:
    xtmp = x[0];
    ytmp = (y[0] > 0.)? y[0] : 1.e-38;
    utmov(xtmp, ytmp);
    for(j=0; j<ndati; j++) {
      utseg(xtmp, ytmp);
      xtmp = x[j];
      ytmp = (y[j] > 0.)? y[j] : 1.e-38;
      utseg(xtmp, ytmp);
    }
    utseg(xtmp, ymin);
    break;
  case MIZ_CLOG:
    xtmp = (x[0] > 0.)? x[0] : 1.e-38;
    ytmp = (y[0] > 0.)? y[0] : 1.e-38;
    utmov(xtmp, ytmp);
    for(j=0; j<ndati; j++) {
      utseg(xtmp, ytmp);
      xtmp = (x[j] > 0.)? x[j] : 1.e-38;
      ytmp = (y[j] > 0.)? y[j] : 1.e-38;
      utseg(xtmp, ytmp);
    }
    utseg(xtmp, ymin);
    break;
  case MIZ_CPOL:
    xtmp = (x[0] >= 0.)? x[0] : 0.;
    ytmp = y[0];
    utmov(xtmp, ytmp);
    for(j=0; j<ndati; j++) {
      utseg(xtmp, ytmp);
      xtmp = (x[j] >= 0.)? x[j] : 0.;
      ytmp = y[j];
      utseg(xtmp, ytmp);
    }
    utseg(xtmp, ymin);
    break;
  case MIZ_CLINEARI:
    utmov(x[0], ymin);
    for(j=0; j<ndati; j++) {
      utseg(x[j-1], y[j-1]);
      utseg(x[j], y[j]);
    }
    utseg(x[j-1], ymin);
    break;
  default:
    break;
  }
  return;
}
