/* <string>:
Sottoprogrammi per la gestione delle stringhe di caratteri
*/
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#if MIZ_INTERATTIVA
#include "icpcmn.h"
#endif
/*  */
union mizhdr mizhdr;
extern struct lgbccs lgbccs;
extern struct lgbcge lgbcge;
extern struct lgbcio lgbcio;
extern struct lgbc2d lgbc2d;
extern struct lgbcsa lgbcsa;
extern struct lgbcsg lgbcsg;
extern struct lgbcms lgbcms;
extern struct lgbcer lgbcer;
extern struct lgbccr lgbccr;
/*  */
#if MIZ_FILE
extern struct lgfile lgfile;
#endif
/*  */
#if MIZ_INTERATTIVA
extern struct lgbccf lgbccf;
extern struct lgbcpn lgbcpn;
extern struct lggraf lggraf;
#endif
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
/* Sottoprogramma defdrs */
INT defdrs(dim,rot)
double dim,rot;
{  int i,kret=0;
   if((dim==lgbcsa.dimsim) && (rot==lgbcsa.rotsim)) return(0);
   if((dim<=0.) || (dim>MIZ_DSIMX))
   {  lgerr(LGE_DIMCARATT);
      kret=LGE_DIMCARATT;
   }
   lgbcsa.dimsim=ABS(dim);
   if(lgbcsa.dimsim==0.)
      lgbcsa.dimsim=1.;
   else
      lgbcsa.dimsim=MIN(lgbcsa.dimsim,MIZ_DSIMX);
   lgbcsa.rotsim=fmod(rot,lgbccs.angiro);
   if(lgbcsa.rotsim<0.) lgbcsa.rotsim+=lgbccs.angiro;
   if(!lgbcge.kanrad) lgbcsa.rotsim*=lgbccs.grarad;
#if MIZ_INTERATTIVA
   lgbcsg.dimcar[MIZ_LD_DIMCAR]=lgbcsa.dimsim;
   for(i=MIZ_LD_DIMCAR+1;i<MIZ_L_DIMCAR;i++)
   {  lgbcsg.dimcar[i]=MIZ_FTDSIM*lgbcsg.dimcar[i-1];
   }
   for(i=MIZ_LD_DIMCAR-1;i>=0;i--)
   {  lgbcsg.dimcar[i]=lgbcsg.dimcar[i+1]/MIZ_FTDSIM;
   }
   lgbcsg.kanzer=lgbcsa.rotsim==0;
   lgbcsg.corot=cos(lgbcsa.rotsim);
   lgbcsg.serot=sin(lgbcsa.rotsim);
#endif
#if MIZ_FILE
   lgwdrs();
#endif
   return(kret);
}
#if MIZ_INTERATTIVA
/* Sottoprogramma lgcntr */
VOID lgcntr()
{  double dor,dver,dx,dy;
   switch(lgbcsa.ksim)
   {  case CRESET:
	 lgbcsg.kalfu=lgbcsa.kalf;
	 lgbcsg.minusc=0;
	 lgbcsg.kliv=MIZ_LD_DIMCAR;
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]-=lgbcsg.delxy[0];
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]-=lgbcsg.delxy[1];
	 lgbcpn.kvstpn= -(ABS(lggraf.kstpn));
	 lgbcsg.delxy[0]=0.;
	 lgbcsg.delxy[1]=0.;
	 break;
      case CAPICE:
	 lgbcsg.kliv=MIN(lgbcsg.kliv+1,MIZ_L_DIMCAR);
	 dver=lgbcsg.dimcar[lgbcsg.kliv];
	 goto sposta;
      case CPEDIC:
	 lgbcsg.kliv=MIN(lgbcsg.kliv+1,MIZ_L_DIMCAR);
	 dver= -lgbcsg.dimcar[lgbcsg.kliv];
	 goto sposta;
      case CALZA:
	 dver=lgbcsg.dimcar[lgbcsg.kliv];
	 goto sposta;
      case CABBAS:
	 dver= -lgbcsg.dimcar[lgbcsg.kliv];
	 goto sposta;
      case CCTPED:
	 dver=lgbcsg.dimcar[lgbcsg.kliv];
	 lgbcsg.kliv=MAX(lgbcsg.kliv-1,0);
	 goto sposta;
      case CCTAPI:
	 dver= -lgbcsg.dimcar[lgbcsg.kliv];
	 lgbcsg.kliv=MAX(lgbcsg.kliv-1,0);
	 goto sposta;
sposta:
	 dver=dver*lgbcsg.dftsc[1]*MIZ_DYLIV;
	 dor=dver*lgbcsg.dstsim;
	 dx=dor*lgbcsg.corot-dver*lgbcsg.serot;
	 lgbcsg.delxy[0]+=dx;
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]+=dx;
	 dy=dor*lgbcsg.serot+dver*lgbcsg.corot;
	 lgbcsg.delxy[1]+=dy;
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]+=dy;
	 break;
      case CBS:
	 dor= -lgbcsa.kspor*lgbcsg.dimcar[lgbcsg.kliv]*lgbcsg.dftsc[0];
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]+=dor*lgbcsg.corot;
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]+=dor*lgbcsg.serot;
	 break;
      case CTABOR:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcsa.tbor[lgbcsg.kpctbo];
	 lgbcsg.kpctbo=MIN(lgbcsg.kpctbo+1,MIZ_TABOR);
	 break;
      case CLFEED:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]-=lgbcsa.kspver*lgbcsg.dimcar[lgbcsg.kliv];
	 break;
      case CTABVE:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbcsa.tbver[lgbcsg.kpctbv];
	 lgbcsg.kpctbv=MIN(lgbcsg.kpctbv+1,MIZ_TABVER);
	 break;
      case CFF:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcsg.pagmar[0];
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]=lgbcsg.pagmar[3];
	 lgbcsg.kpctbo=0;
	 lgbcsg.kpctbv=0;
	 break;
      case CCR:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcsg.pagmar[0];
	 lgbcsg.kpctbo=0;
	 break;
      case CLFINV:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]+=lgbcsa.kspver*lgbcsg.dimcar[lgbcsg.kliv];
	 break;
      case CCRLF:
	 if(!lgbcsg.kanzer) goto errore;
	 lgbc2d.g2ult[MIZ_GRAFPAG][0]=lgbcsg.pagmar[0];
	 lgbc2d.g2ult[MIZ_GRAFPAG][1]-=lgbcsa.kspver*lgbcsg.dimcar[lgbcsg.kliv];
	 lgbcsg.kpctbo=0;
	 break;
      case CALATI:
	 lgbcsg.kalfu=0;
	 break;
      case CAGREC:
	 lgbcsg.kalfu=64;
	 break;
      case CASPEC:
	 lgbcsg.kalfu=128;
	 break;
      case CAMAIU:
	 lgbcsg.minusc=0;
	 break;
      case CAMINU:
	 lgbcsg.minusc=32;
	 break;
      case CDIMIN:
	 lgbcsg.kliv=MIN(lgbcsg.kliv+1,MIZ_L_DIMCAR);
	 break;
      case CAUMEN:
	 lgbcsg.kliv=MAX(lgbcsg.kliv-1,0);
	 break;
      default:
	 goto errore;
   }
   return;
errore:
   lgerr(LGE_CARATTCNTR);
   return;
}
#endif
/* Sottoprogramma stralf */
INT stralf(istr,ncar,dim,rot)
CHAR istr[];
int ncar;
double dim,rot;
{  unsigned char kout;
   double gx1[2];
   int i,kret;
/* Scrive su file, se necessario, le dimensioni e 
   l'angolo di rotazione. */
   kret=defdrs(dim,rot);
/* Controlla che il punto iniziale sia contenuto
   nella pagina. */
   if(lgbc2d.kp2ult[lgbc2d.kgrut]!=0)
   {  lgagrn(MIZ_GRAFPAG);
      lgbc2d.kgrut=MIZ_GRAFPAG;
      gx1[0]=lgbc2d.g2ult[MIZ_GRAFPAG][0];
      gx1[1]=lgbc2d.g2ult[MIZ_GRAFPAG][1];
      if(lgbc2d.kp2ult[MIZ_GRAFPAG]!=0)
      {  lgerr(LGE_STRALF);
	 return(LGE_STRALF);
      }
      lgplot(gx1[0],gx1[1],MIZ_MOV);
   }
#if MIZ_FILE
   if(lgbcge.kcmult!=MIZ_STRCR) lgcmdo(MIZ_STRCR,0,0);
#endif
#if MIZ_INTERATTIVA
   lgbcsg.kalfu=lgbcsa.kalf;
#endif
   for(i=0;i<ncar && istr[i]!=NUL;i++)
   {  lgbcsa.ksim=istr[i];
#if MIZ_FILE
      if(lgbcsa.ksim>'\077' && lgbcsa.ksim<='\177') lgbcsa.ksim+=lgbcsa.kalf;
      lgbuff(&lgbcsa.ksim,1,0);
#endif
#if MIZ_INTERATTIVA
      if(lgbcsa.ksim<'\040')
      {  lgcntr();
      }
      else
      {  if(lgbcsa.ksim>'\077' && lgbcsa.ksim<(unsigned char) '\200') 
	    lgbcsa.ksim+=lgbcsg.kalfu;
	 if((lgbcsa.ksim%64)<'\040') lgbcsa.ksim+=lgbcsg.minusc;
	 lgsim(1);
      }
#endif
   }
   lgbcsa.ksim=CRESET;
#if MIZ_FILE
   lgbuff(&lgbcsa.ksim,1,0);
#endif
#if MIZ_INTERATTIVA
   lgcntr();
#endif
   lgbcsa.ksim=NUL;
   return(kret);
}
