/* Interprete per figure PostScript da inserire in TeX */
#include <stdio.h>
#include <string.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
#include "icpcmn.h"
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
#define TPS_OUTSFX ".tps"
/*  */
union mizhdr mizhdr;
extern struct lgbcio lgbcio;
extern struct lggraf lggraf;
/*  */
struct {  
  long kxult;			/* Ultime coordinate fisiche. */
  long kyult;
  long kxmin;			/* Minimo e massimo effettivamente */
  long kxmax;		        /* raggiunti durante il tracciamento */
  long kymin;			/* Serve per definire la */
  long kymax;			/* BoundingBox */
  long bndboxadr;		/* Indirizzo della linea "BoundingBox" su file */
  long curadr;			/* Indirizzo corrente del puntatore al file */
  int lunout;		        /* Soglia per stampa buffer di output */
  int koutb;			/* Contatore caratteri per riga */
  int npages;			/* Numero di pagine */
  int lpsg;			/* Stato su o giu' della penna */
  char cpen[16];		/* Larghezza corrispondente alla penna */
  char lstpen[2];		/* Stato della penna per output */
}  lgctps={-1,-1,0,0,0,0,0,0,64,0,0,0,
	   {1,3,5,7,9,11,13,15,17,19,21,23,25,27,29,31},
	   {'L','M'}};
char lgtps_outprefix[60];
char lgtps_outname[84];
char *lgtps_outsfx;
/*  */
/* Sottoprogramma LGCUR */
/* Questo sottoprogramma e' previsto solo per le versioni interattive.
   Qui serve solo per evitare errori di "undefined external" in fase di 
   link. */
CHAR lgcur(fx,fy)
DOUBLE *fx,*fy;
{  *fx=lgctps.kxult;
   *fy=lgctps.kyult;
   return(CR);
}
/* Sottoprogramma LGZOOM */
/* Questo sottoprogramma e' previsto solo per le versioni interattive.
   Qui serve solo per evitare errori di "undefined external" in fase di 
   link. */
CHAR lgzoom(fx0,fy0,fx1,fy1)
DOUBLE *fx0,*fy0,*fx1,*fy1;
{  *fx0=0.;
   *fy0=lggraf.dflim[0];
   *fx1=0.;
   *fy1=lggraf.dflim[1];
   return(CR);
}
/* Sottoprogramma LGSVUO */
VOID lgsvuo()
{  if(lgctps.koutb>0)
   {  fprintf(lgbcio.kunoug,"\nS N %ld %ld M\n",lgctps.kxult,lgctps.kyult);
      lgctps.koutb=0;
   }
   return;
}
/* Sottoprogramma LGPAG */
VOID lgpag(kpg)
     int kpg;
{  int kpg1,k;
 kpg1=kpg; if(kpg1>0) kpg1=ICP_PAGINA;
 switch (kpg1) {
 case ICP_INIT:
   {
     int ldot,lnam;
     lnam=strlen(lggraf.nomoug);
     for(ldot=lnam-1;ldot>=0;ldot--) if(lggraf.nomoug[ldot]=='.') break;
     if(ldot==0) ldot=lnam;
     strncpy(lgtps_outprefix,lggraf.nomoug,60);
     lgtps_outsfx=lggraf.nomoug+ldot;
     lgtps_outprefix[ldot]=NUL;
   }
   strncpy(lgtps_outname,lggraf.nomoug,60);
   lgctps.npages=0;
/*    printf("lggraf.nomoug: %s\n",lggraf.nomoug); */
/*    printf("lgtps_outprefix: %s\n",lgtps_outprefix); */
/*    printf("lgtps_outsfx: %s\n",lgtps_outsfx); */
/*    printf("lgtps_outname: %s\n",lgtps_outname); */
   break;
 case ICP_PAGINA:
   if(lgctps.npages>0) {
     lgsvuo();
     if((lgctps.kxmin=0.24*((double) lgctps.kxmin)-0.5)<0)
       lgctps.kxmin=0;
     if((lgctps.kymin=0.24*((double) lgctps.kymin)-0.5)<0)
       lgctps.kymin=0;
     lgctps.kxmax= 0.24*((double) lgctps.kxmax)+0.5;
     lgctps.kymax= 0.24*((double) lgctps.kymax)+0.5;
     lgctps.curadr = ftell(lgbcio.kunoug);
     fseek(lgbcio.kunoug,lgctps.bndboxadr,SEEK_SET);
     fprintf(lgbcio.kunoug,"%%%%BoundingBox: %10ld %10ld %10ld %10ld\n",
	     lgctps.kxmin,lgctps.kymin,lgctps.kxmax,lgctps.kymax);
     fseek(lgbcio.kunoug,lgctps.curadr,SEEK_SET);
     fprintf(lgbcio.kunoug,"%%end(plot)\n");
     fclose(lgbcio.kunoug);
     sprintf(lgtps_outname,"%s_%05d%s",lgtps_outprefix,lgctps.npages,lgtps_outsfx);
   }
   lgctps.npages++;
/*    printf("Apro il file %s... ",lgtps_outname); */
   lgbcio.kunoug=fopen(lgtps_outname,"w");
/*     printf("risposta: %p\n",lgbcio.kunoug); */
   fprintf(lgbcio.kunoug,"%%!PS-Adobe-1.0\n");
   fprintf(lgbcio.kunoug,"%%%%Title: File %s\n",lggraf.nomoug);
   fprintf(lgbcio.kunoug,"%%%%Creator: MiZaR\n");
   lgctps.bndboxadr = ftell(lgbcio.kunoug);
   fprintf(lgbcio.kunoug,"%%%%BoundingBox: %10ld %10ld %10ld %10ld\n",
	   lgctps.kxmin,lgctps.kymin,lgctps.kxmax,lgctps.kymax);
   fprintf(lgbcio.kunoug,"%%%%EndComments\n");
   fprintf(lgbcio.kunoug,"%%%%Endprolog\n");
   fprintf(lgbcio.kunoug,"/L {lineto} def\n");
   fprintf(lgbcio.kunoug,"/R {rlineto} def\n");
   fprintf(lgbcio.kunoug,"/M {moveto} def\n");
   fprintf(lgbcio.kunoug,"/N {newpath} def\n");
   fprintf(lgbcio.kunoug,"/S {stroke} def\n");
   fprintf(lgbcio.kunoug,"/P {setlinewidth} def\n");
   fprintf(lgbcio.kunoug,"1 setlinewidth 1 setlinecap 1 setlinejoin\n");
   lgctps.kxmin=lggraf.dflim[0]+1;
   lgctps.kxmax= -1;
   lgctps.kymin=lggraf.dflim[1]+1;
   lgctps.kymax= -1;
/*    lgctps.npages=kpg; */
   k=ABS(lggraf.kstpn); --k;
   fprintf(lgbcio.kunoug,"72 300 div 72 300 div scale\n");
   fprintf(lgbcio.kunoug,"[] 0 setdash\n");
   fprintf(lgbcio.kunoug,
	   "%d setlinewidth 1 setlinecap 1 setlinejoin\n",lgctps.cpen[k]);
   fprintf(lgbcio.kunoug,"N 0 0 M\n");
   break;
 case ICP_FINE:
   lgsvuo();
   fprintf(lgbcio.kunoug,"0 0 M S\n");
   if((lgctps.kxmin=0.24*((double) lgctps.kxmin))<0)
     lgctps.kxmin=0;
   if((lgctps.kymin=0.24*((double) lgctps.kymin))<0)
     lgctps.kymin=0;
   lgctps.kxmax= 0.24*((double) lgctps.kxmax)+0.5;
   lgctps.kymax= 0.24*((double) lgctps.kymax)+0.5;
   lgctps.curadr = ftell(lgbcio.kunoug);
   fseek(lgbcio.kunoug,lgctps.bndboxadr,SEEK_SET);
   fprintf(lgbcio.kunoug,"%%%%BoundingBox: %10ld %10ld %10ld %10ld\n",
	   lgctps.kxmin,lgctps.kymin,lgctps.kxmax,lgctps.kymax);
   fseek(lgbcio.kunoug,lgctps.curadr,SEEK_SET);
   fprintf(lgbcio.kunoug,"%%end(plot)\n");
   break;
 case ICP_SVUOTA:
   lgsvuo();
   break;
 case ICP_INIDATA:
   fseek(lgbcio.kunmiz,mizhdr.hdr.bldtps,SEEK_SET);
   fread(&lggraf,sizeof(struct lggraf),1,lgbcio.kunmiz);
   break;
 }
 return;
}
/* Sottoprogramma LGMOV */
VOID lgmov(fx,fy)
double fx,fy;
{  if(lgctps.koutb>=lgctps.lunout) lgsvuo();
   if(lgctps.lpsg==0)		/* Se penna abbassata, aggiorna 
      				   gli estremi del tracciamento
      				   sia alla posizione precedente
      				   che a quella corrente */
   {  lgctps.kxmin=MIN(lgctps.kxmin,lgctps.kxult);
      lgctps.kxmax=MAX(lgctps.kxmax,lgctps.kxult);
      lgctps.kymin=MIN(lgctps.kymin,lgctps.kyult);
      lgctps.kymax=MAX(lgctps.kymax,lgctps.kyult);
      lgctps.kxult=fx; lgctps.kyult=fy;
      lgctps.kxmin=MIN(lgctps.kxmin,lgctps.kxult);
      lgctps.kxmax=MAX(lgctps.kxmax,lgctps.kxult);
      lgctps.kymin=MIN(lgctps.kymin,lgctps.kyult);
      lgctps.kymax=MAX(lgctps.kymax,lgctps.kyult);
   }
   else
      lgctps.kxult=fx; lgctps.kyult=fy;
   lgctps.koutb+=fprintf(lgbcio.kunoug,"%ld %ld %c ",
   	lgctps.kxult,lgctps.kyult,lgctps.lstpen[lgctps.lpsg]);
   return;
}
/* Sottoprogramma LGPEN */
VOID lgpen(k)
int k;
{  int kp,kpp;
   if(k!=lggraf.kstpn)
   {  kp=ABS(k);
      kpp=ABS(lggraf.kstpn);
      if(kp!=kpp)
      {  lgsvuo();
	 fprintf(lgbcio.kunoug,"%d setlinewidth\n",lgctps.cpen[--kp]);
      }
      lgctps.lpsg=((lggraf.kstpn=k)>0)? 0:1;
   }
   return;
}
