/* Programma di test del sottoprogramma istogr.
   Traccia un istogramma a partire da un unico 
   vettore di dati
*/
#include <stdio.h>
#include <math.h>
#include "mizar.h"
/*  */
#define NDATI 200000
#define NINT 200
double dati[NDATI];
double rdint[NINT];
/*  */
int main()
{
  double xmin,xmax;
  double x=0.12345678;
  LONG j,itot,ibuoni;
  xmin=0.;  xmax=1.;		/* definisco gli estremi in x */
  for(j=0;j<NDATI;j++) {	/* Riempio il vettore di dati */
    dati[j] = x;
    x = 4.*x*(1.-x);
  }
  inizio(0);			/* Inizializzo MiZaR */
  defpag(1023.,1023.);		/* Estremi della pagina */
  grarea(200.,950.,100.,950.);	/* Estremi area grafica */
				/* Chiama istogr:
				   - voglio NINT intervalli
				   - gli estremi xmin,xmax sono forniti
				   - ymin,ymax sono adattati alla 
				     distribuzione
				*/

  istogr(dati,NDATI,rdint,NINT,16+256,
	   &itot,&ibuoni,xmin,xmax,0.,0.,
	 "x",1,"Distribuzione",13);
  fine();
  return(0);
}
