/* Programma di test del sottoprogramma istogr .
   Traccia un istogramma con dati generati a blocchi.
*/
#include <stdio.h>
#include <math.h>
#include "mizar.h"
/*  */
#define NDATI 100000
#define NINT 200
double dati[NDATI];
double rdint[NINT];
/*  */
int main()
{
  double xmin,xmax;
  double x=0.12345678;
  int j,k,itot,ibuoni;
  xmin=0.;  xmax=1.;		/* definisco gli estremi in x */
  inizio(0);			/* Inizializzo MiZaR */
  defpag(1023.,1023.);		/* Estremi della pagina */
  grarea(100.,950.,100.,950.);	/* Estremi area grafica */
				/* Chiamata di inizializzazione a istogr:
				   - voglio NINT intervalli
				   - gli estremi xmin,xmax sono forniti
				   - per ora azzera solo i contatori
				*/
  istogr(dati,0,rdint,NINT,2+64,
	 &itot,&ibuoni,xmin,xmax,0.,0.,
	 "",0,"",0);
  for(k=0;k<10;k++) {		/* Genero i dati in 10 rate */
    for(j=0;j<NDATI;j++) {	/* Riempio il vettore di dati */
      dati[j] = x;
      x = 4.*x*(1.-x);
    }
				/* e chiamo istogr perche' li accumuli. */
    istogr(dati,NDATI,rdint,NINT,2+64+512,
	   &itot,&ibuoni,xmin,xmax,0.,0.,
	   "",0,"",0);
  }
				/* Chiamata finale a istogr:
				   - la scala e' sul numero totale
				   - ymin,ymax sono adattati alla 
				     distribuzione.
				*/
  istogr(dati,NDATI,rdint,NINT,2+512,
	 &itot,&ibuoni,xmin,xmax,0.,0.,
	 "x",1,"Distribuzione",13);
  fine();
  return(0);
}
