/* Programma di test generale delle curve di livello */
#include <stdio.h>
#include <math.h>
#include "mizar.h"
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
#define MAX(z,w) ((z)>=(w))? (z):(w)
#define MIN(z,w) ((z)<=(w))? (z):(w)
/*  */
#define NGRIDX 10
#define NGRIDY 20
#define NLIV 2
double fmat[NGRIDX][NGRIDY];
double av[NLIV];
/*  */
int main()
{  
  int jx,jy;
  double x,y,dx,dy,zmin,zmax,t,dt;
  dx=2./(NGRIDX-1);
  dy=2./(NGRIDY-1);
  zmin=1.e38; zmax=-zmin;
  for(jx=0;jx<NGRIDX;jx++) {
    x=jx*dx-1.;
    for(jy=0;jy<NGRIDY;jy++) {
      y=jy*dy-1.;
      fmat[jx][jy]=x*x+y*y;
/*        printf("%10.2le",fmat[jx][jy]); */
      zmin=MIN(zmin,fmat[jx][jy]);
      zmax=MAX(zmax,fmat[jx][jy]);
    }
    printf("\n");
  }
  dt=1./NLIV;
  for(jx=0;jx<NLIV;jx++) {
    t=(jx+.5)*dt;
    av[jx]=zmin*(1.-t)+zmax*t;
  }
  inizio(0);
  defpag(1023.,1023.);
  grarea(100.,950.,100.,950.);
  utarea(-1.,1.,-1.,1.);
  utmov(-1.,-1.);
  utseg(1.,-1.);
  utseg(1.,1.);
  utseg(-1.,1.);
  utseg(-1.,-1.);
  for(jx=1;jx<NGRIDX-1;jx++) {
    x=jx*dx-1.;
    utmov(x,-1.);
    uttrt(x,1.);
  }
  for(jy=1;jy<NGRIDY-1;jy++) {
    y=jy*dy-1.;
    utmov(-1.,y);
    uttrt(1.,y);
  }
  curliv(fmat,NGRIDX,NGRIDY,.49*(zmax-zmin),-1.e38);
  fine();
  return;
}



