/* Programma di preparazione del file di dati della libreria. 

Input: 
   o	il file di messaggi MIZMSG.TXT.

Output:
   o	Il file MIZAR.DAT contenente:
   	    i.	tutto il necessario per l'uso dei messaggi durante
   		l'esecuzione del programma;
   	   ii.	i dati per il tracciamento di caratteri e simboli.
   o	Il file MIZMSG.H contenente le definizioni da richiamare nei moduli di
   	gestione degli errori.

  */
#include <stdio.h>
#include <time.h>
#define MIZ_COMPLETA 1
#define MIZ_NUMMSGERR 1
#include "/mizar/src/mizcmn.h"
#include "/mizar/src/icpcmn.h"
#define MAXMES 511
#define MAXREC MSG_LUNID+MSG_LUNTXT+3

FILE *fp;		/* File di input dati */
FILE *fout;		/* File MIZAR.DAT */
FILE *fdef;		/* File MIZMSG.DAT */
char str[MAXREC];
long int offmes[MAXMES];
struct itemer errmes[MAXMES];
char ident[MAXMES][MSG_LUNID+1];
char level[MAXMES];
int pnt[3];
struct tm *timecr;
time_t mclock;

union mizhdr mizhdr;
struct lgbccs lgbccs;
struct lgbcge lgbcge;
struct lgbcio lgbcio;
struct lgbc2d lgbc2d;
struct lgbcsa lgbcsa;
struct lgbcms lgbcms;
struct lgbcer lgbcer;

#if MIZ_FILE
struct lgfile lgfile;
#endif

#if MIZ_INTERATTIVA
struct lgbccf lgbccf;
struct lgbcpn lgbcpn;
struct lgbcsg lgbcsg;
struct lgbccr lgbccr;
struct lggraf lggraf;
#endif
/* Blocchi dei parametri degli interpreti */
struct lggraf bldtty;
struct lggraf bldpos;
struct lggraf bldtek;
struct lggraf bldtps;
struct lggraf bldbps;
/* struct lggraf bldvga; */
/* struct lggraf bldhpl; */
/* struct lggraf bldhpj; */
/* Blocco common dell'interprete */
struct lgbcfi
   {	long int kpgmax;
	long int krcult;
   	long int krulbf;
   	char nomfil[60];
   	unsigned char nomess;
   	unsigned char filopn;  
   } lgbcfi;
/*  */
void bldata();
/*  */
int main()
{  int curmes=0;
   int lriga;
   int i;
   int nmsger=0;

   fp=fopen("/mizar/util/mizmsg.txt","r");

/* Apertura ed inizializzazione del file dati */
   if((sizeof(struct hdr))>(sizeof(int)*(MIZ_LUNHEAD-1)))
   {  printf("Errore dimensionamento header: necessari almeno %d bytes.\n",
	      sizeof(struct hdr)+sizeof(int));
      return;
   }

/* Header del file dati. */

   mizhdr.hdr.cntsta[0]=HDR_V_BYTECNTR; 
   mizhdr.hdr.cntsta[1]=HDR_V_BYTESTAT;
   mizhdr.hdr.nome[0]='M';
   mizhdr.hdr.nome[1]='i';
   mizhdr.hdr.nome[2]='Z';
   mizhdr.hdr.nome[3]='a';
   mizhdr.hdr.nome[4]='R';
   mizhdr.hdr.nome[5]=NUL;
   mizhdr.hdr.vers[0]=2;
   mizhdr.hdr.vers[1]=1;
   for(i=0;i<HDR_L_SITEID;mizhdr.hdr.siteid[i++]=NUL);
   for(i=0;i<HDR_L_CRTIM;mizhdr.hdr.crtim[i++]=NUL);
   for(i=0;i<HDR_L_MDTIM;mizhdr.hdr.mdtim[i++]=NUL);
   mizhdr.hdr.subver=-1;
   mizhdr.hdr.icpmas=0;
   mizhdr.hdr.tabmad=0;
   mizhdr.hdr.nmsg=0;
   mizhdr.hdr.nmer=0;

   fout=fopen("/mizar/lib/mizar.dat","r+b");
   if(fout==0)
   {  fout=fopen("/mizar/lib/mizar.dat","wb");
      fwrite(&mizhdr,sizeof(union mizhdr),1,fout);
      rewind(fout);
   }
   i=fread(&mizhdr,sizeof(union mizhdr),1,fout);
   rewind(fout);
   mizhdr.hdr.subver+=1;
   time(&mclock);
   timecr=localtime(&mclock);
   mizhdr.hdr.crtim[0]=timecr->tm_mday;
   mizhdr.hdr.crtim[1]=timecr->tm_mon+1;
   mizhdr.hdr.crtim[2]=timecr->tm_year;
   mizhdr.hdr.crtim[3]=timecr->tm_hour;
   mizhdr.hdr.crtim[4]=timecr->tm_min;
   mizhdr.hdr.crtim[5]=timecr->tm_sec;
   mizhdr.hdr.mdtim[0]=timecr->tm_mday;
   mizhdr.hdr.mdtim[1]=timecr->tm_mon+1;
   mizhdr.hdr.mdtim[2]=timecr->tm_year;
   mizhdr.hdr.mdtim[3]=timecr->tm_hour;
   mizhdr.hdr.mdtim[4]=timecr->tm_min;
   mizhdr.hdr.mdtim[5]=timecr->tm_sec;
   mizhdr.hdr.nmsg=0;
   fwrite(&mizhdr,sizeof(union mizhdr),1,fout);
   printf("MiZaR V %d.%d:%d \n",mizhdr.hdr.vers[0],mizhdr.hdr.vers[1],
   		mizhdr.hdr.subver);
   printf("      File MIZAR.DAT, creato il %2d-%02d-%04d %2d:%02d:%02d\n",
   		mizhdr.hdr.crtim[0],mizhdr.hdr.crtim[1],1900+mizhdr.hdr.crtim[2],
   		mizhdr.hdr.crtim[3],mizhdr.hdr.crtim[4],mizhdr.hdr.crtim[5]);

/* Inizializzazione blocchi common */
   bldata();

/* Apertura del file delle definizioni relative ai messaggi*/
   fdef=fopen("/mizar/src/mizmsg.h","w");

   while((lriga=riga())>0)
   {  mizhdr.hdr.nmsg++;
      if(mizhdr.hdr.nmsg>MAXMES)
      {  printf("Il numero di messaggi supera %d\n",MAXMES);
	 return;
      }
      if(pnt[1]>MSG_LUNID)
      {  printf("Piu' di %d caratteri nell'identificatore %s/n",
	 	MSG_LUNID,str);
	 return;
      }
      for(i=0;i<MSG_LUNID;ident[curmes][i++]=NUL);
      for(i=0;str[i]!=NUL;i++)
	 ident[curmes][i]=str[i];
      i=pnt[1]+1;
      level[curmes]=str[i++];
      switch (level[curmes])
      {  case MSG_WARNING:
	    errmes[nmsger].stato=MSG_C_WARNING;
	    goto coderr;
	 case MSG_MAXCONT:
	    errmes[nmsger].stato=MSG_C_MAXCONT;
	    errmes[nmsger].stato|=EST_STAMPAMSG;
	    errmes[nmsger].stato|=EST_CONTAERR;
	    errmes[nmsger].stato|=EST_STPRIMOER;
	    goto coderr;
	 case MSG_ERRORE:
	    errmes[nmsger].stato=MSG_C_ERRORE;
	    errmes[nmsger].stato|=EST_STAMPAMSG;
	    goto coderr;
	 case MSG_FATALE:
	    errmes[nmsger].stato=MSG_C_FATALE;
	    errmes[nmsger].stato|=EST_STAMPAMSG;
	 coderr:
	    errmes[nmsger].stato|=curmes;
	    errmes[nmsger++].cont=0;
	    fprintf(fdef,"#define %s %d\n",ident+curmes,nmsger);
	    if(nmsger>EST_NUMMSGERR)
	    {  printf("Troppi codici di errore\n");
	       return;
	    }
	    goto cntmsg;
	 case MSG_LETTDAT:
	 case MSG_TESTO:
	 case MSG_INFORM:
	    fprintf(fdef,"#define %s %d\n",ident+curmes,curmes);
	 cntmsg:
	    if((pnt[2]-pnt[1])==2) break;
	    printf("Numero di caratteri errato nel codice di livello %s\n",
	    	pnt[2]-pnt[1]-1);
	    return;
	 default:
	    printf("Codice di livello errato nel messaggio %s: %c\n",
	    	ident+curmes,level[curmes]);
	    return;
      }
      offmes[curmes]=ftell(fout);
      fwrite(ident+curmes,sizeof(char),MSG_LUNID,fout);
      fwrite(str+i,sizeof(char),lriga-i,fout);
      curmes++;
   }
/* Registrazione della tabella dei codici dei messaggi */
   mizhdr.hdr.tabmad=ftell(fout);
   for(i=0;i<curmes;i++)
   {  fwrite(offmes+i,sizeof(long),1,fout);
      fwrite(level+i,sizeof(char),1,fout);
   }
/* Registrazione dei blocchi common */
   mizhdr.hdr.lgbccs=ftell(fout);
   fwrite(&lgbccs,sizeof(struct lgbccs),1,fout);
   mizhdr.hdr.lgbcge=ftell(fout);
   fwrite(&lgbcge,sizeof(struct lgbcge),1,fout);
   mizhdr.hdr.lgbc2d=ftell(fout);
   fwrite(&lgbc2d,sizeof(struct lgbc2d),1,fout);
   mizhdr.hdr.lgbcsa=ftell(fout);
   fwrite(&lgbcsa,sizeof(struct lgbcsa),1,fout);
   mizhdr.hdr.lgfile=ftell(fout);
   fwrite(&lgfile,sizeof(struct lgfile),1,fout);
   mizhdr.hdr.lgbccf=ftell(fout);
   fwrite(&lgbccf,sizeof(struct lgbccf),1,fout);
   mizhdr.hdr.lgbcpn=ftell(fout);
   fwrite(&lgbcpn,sizeof(struct lgbcpn),1,fout);
   mizhdr.hdr.lgbcsg=ftell(fout);
   fwrite(&lgbcsg,sizeof(struct lgbcsg),1,fout);
   mizhdr.hdr.lgbccr=ftell(fout);
   fwrite(&lgbccr,sizeof(struct lgbccr),1,fout);
   mizhdr.hdr.lgbcfi=ftell(fout);
   fwrite(&lgbcfi,sizeof(struct lgbcfi),1,fout);
   mizhdr.hdr.lgbcer=ftell(fout);
   fwrite(&lgbcer.kerult,sizeof(int),1,fout);
   fwrite(errmes,sizeof(struct itemer),nmsger,fout);

/* Registrazione dei blocchi degli interpreti */
   mizhdr.hdr.bldtty=ftell(fout);
   fwrite(&bldtty,sizeof(struct lggraf),1,fout);
   mizhdr.hdr.bldpos=ftell(fout);
   fwrite(&bldpos,sizeof(struct lggraf),1,fout);
   mizhdr.hdr.bldtek=ftell(fout);
   fwrite(&bldtek,sizeof(struct lggraf),1,fout);
   mizhdr.hdr.bldtps=ftell(fout);
   fwrite(&bldtps,sizeof(struct lggraf),1,fout);
   mizhdr.hdr.bldbps=ftell(fout);
   fwrite(&bldbps,sizeof(struct lggraf),1,fout);
/* Commentati perche' da aggiornare per Linux */
/*    mizhdr.hdr.bldvga=ftell(fout); */
/*    fwrite(&bldvga,sizeof(struct lggraf),1,fout); */
/*    mizhdr.hdr.bldhpl=ftell(fout); */
/*    fwrite(&bldhpl,sizeof(struct lggraf),1,fout); */
/*    mizhdr.hdr.bldhpj=ftell(fout); */
/*    fwrite(&bldhpj,sizeof(struct lggraf),1,fout); */
/*    mizhdr.hdr.freead=ftell(fout); */
/* Calcolo checksum dell'header */
   mizhdr.hdr.nmer=nmsger;
   mizhdr.hdri[MIZ_LUNHEAD-1]=0;
   for(i=0;i<MIZ_LUNHEAD-1;mizhdr.hdri[MIZ_LUNHEAD-1]+=mizhdr.hdri[i++]);

/* Registrazione del numero totale di messaggi 
   e dell'indirizzo della tabella dei codici */
   fprintf(fdef,"#define MIZ_NUMMSGERR %d\n",nmsger);
   fprintf(fdef,"#define MIZ_NUMMSG %d\n",mizhdr.hdr.nmsg);
   rewind(fout);
   fwrite(&mizhdr,sizeof(union mizhdr),1,fout);
   printf(" Numero messaggi di errore : %d\n",nmsger);
   printf(" Numero messaggi registrati: %d\n",mizhdr.hdr.nmsg);

   fclose(fp);
   fclose(fout);
   fclose(fdef);
   return;
}
int riga()
{  int j=-1;
   int i=0;

   char c;
   while(j<MAXREC)
   {   c=getc(fp);
      switch (c)
      {  case CR:
         case LF:
	    break;
         case EOF:
   	    return(-1);
         case '{':
   	    j=0;
	    pnt[i++]=j;
   	    break;
	 case '|':
	    pnt[i++]=j;
	    if (i>3) return(-2);
	    str[j++]=NUL;
	    break;
	 case '\001':
	    str[j++]=CR;
	    str[j++]=LF;
	    break;
         case '}':
	    str[j++]=NUL;
	    return(j);
         default:
	    str[j++]=c;
      }
   }
   return(-4);
}
void bldata()
{  int i;
   char *pnt;

/* Blocco costanti */
   lgbccs.pigrec=3.1415926653589793;
   lgbccs.angiro=2.*lgbccs.pigrec;
   lgbccs.grarad=lgbccs.pigrec/180.;
   lgbccs.radgra=180./lgbccs.pigrec;
   for(i=0;i<MIZ_LIVPREC;i++)
    lgbccs.precis[i]=(i*MIZ_MINPREC+(MIZ_LIVPREC-i-1)*MIZ_MAXPREC)/MIZ_LIVPREC;
   
/* Blocco variabili comuni di utilita' generale */
   lgbcge.plim[0]=lgbcge.plim[1]=32767.;
   lgbcge.pult[0]=lgbcge.pult[1]=0.;
   lgbcge.pcoef[0]=lgbcge.pcoef[1]=512.;
   lgbcge.kpag=0;
   lgbcge.kcmult=0;
   lgbcge.ktratt[0]=5;
   lgbcge.ktratt[1]=-5;
   for(i=2;i<MIZ_L_MOTRA;lgbcge.ktratt[i++]=0);
   lgbcge.kanrad=TRUE;
   lgbcge.kcmap=FALSE;
   lgbcge.kersta=TRUE;
   lgbcge.penna=1;

/* Blocco dati per grafica 2D */
   lgbc2d.g2lim[0][0]=lgbc2d.g2lim[0][2]=0.;
   lgbc2d.g2lim[0][1]=lgbc2d.g2lim[0][3]=1023.;
   lgbc2d.g2lim[1][0]=lgbc2d.g2lim[1][2]=0.;
   lgbc2d.g2lim[1][1]=lgbc2d.g2lim[1][3]=1023.;
   lgbc2d.g2lim[2][0]=lgbc2d.g2lim[2][2]=0.;
   lgbc2d.g2lim[2][1]=lgbc2d.g2lim[2][3]=1023.;
   lgbc2d.g2lim[3][0]=lgbc2d.g2lim[3][2]=0.;
   lgbc2d.g2lim[3][1]=lgbc2d.g2lim[3][3]=1023.;
   lgbc2d.g2ult[0][0]=lgbc2d.g2ult[0][1]=0.;
   lgbc2d.g2ult[1][0]=lgbc2d.g2ult[1][1]=0.;
   lgbc2d.g2ult[2][0]=lgbc2d.g2ult[2][1]=0.;
   lgbc2d.g2ult[3][0]=lgbc2d.g2ult[3][1]=0.;
   lgbc2d.co2ug[0]=lgbc2d.co2ug[1]=1.;
   lgbc2d.co2gu[0]=lgbc2d.co2gu[1]=1.;
   lgbc2d.dimsp=1.;
   lgbc2d.rotsp=0.;
   lgbc2d.cosp=1.;
   lgbc2d.sesp=0.;
   lgbc2d.kerpnf[MIZ_GRAFPAG]=10;
   lgbc2d.kerpnf[MIZ_GRAFAGR]=11;
   lgbc2d.kerpnf[MIZ_UTENTE]=11;
   lgbc2d.kerpnf[3]=0;
   lgbc2d.kcmplo[MIZ_MOV]=MIZ_PNMOV;
   lgbc2d.kcmplo[MIZ_SEG]=MIZ_PNSEG;
   lgbc2d.kcmplo[MIZ_PUN]=MIZ_PNPUN;
   lgbc2d.kcmplo[MIZ_SIM]=MIZ_PNSIM;
   lgbc2d.kcmplo[MIZ_TRA]=MIZ_PNTRA;
   lgbc2d.kp2ult[0]=lgbc2d.kp2ult[1]=lgbc2d.kp2ult[2]=lgbc2d.kp2ult[3]=0;
   lgbc2d.kgrut=1;
   lgbc2d.kcoord=1;
   lgbc2d.kcodef=FALSE;
   lgbc2d.knsp=1;

/* Blocco gestione stringhe di caratteri (generale) */
   for(i=0;i<MIZ_TABOR;lgbcsa.tbor[i++]=0.)
   for(i=0;i<MIZ_TABVER;lgbcsa.tbver[i++]=0.)
   lgbcsa.dstmax=MIZ_MAXDST;
   lgbcsa.dstfat=512.;
   lgbcsa.dimsim=1.;
   lgbcsa.rotsim=0.;
   lgbcsa.kspor=8;
   lgbcsa.kspver=20;
   lgbcsa.kalf=0;
   lgbcsa.ksim=' ';

/* Blocco di gestione degli errori. Viene inizializzato solo il primo
   dato; la tabella viene inizializzata dal programma mizdat stesso. */
   lgbcer.kerult=0;
#if MIZ_FILE
/* Blocco di gestione del file grafico */
   pnt=mizhdr.hdr.cntsta;

   lgfile.krpun=0;
   lgfile.krec=0;
   lgfile.kbf=0;
   lgfile.krulpg=0;
   lgfile.krulbr=1;
   for(i=0;i<MIZ_L_KRBRKP;lgfile.krbrkp[i++]=0);
   for(i=0;i<HFG_HDRINFO;lgfile.kgrbf[i++]=*pnt++);
   for(i=HFG_HDRINFO;i<MIZ_FGRBUF;lgfile.kgrbf[i++]=NUL);
#endif

#if MIZ_INTERATTIVA
/* Blocco parametri di conversione a coordinate fisiche */
   lgbccf.flim[0]=lgbccf.flim[1]=lgbccf.flim[2]=lgbccf.flim[3]=0.;
   lgbccf.fcen[0]=lgbccf.fcen[1]=0.;
   lgbccf.fatscf[0]=lgbccf.fatscf[1]=1.;
   lgbccf.cfsc[0]=lgbccf.cfsc[1]=0.;
   lgbccf.gflim[0]=lgbccf.gflim[2]=0.;
   lgbccf.gflim[1]=lgbccf.gflim[3]=1023.;
   lgbccf.gfcen[0]=lgbccf.gfcen[1]=0.;
   lgbccf.fatscg[0]=lgbccf.fatscg[1]=1.;
   lgbccf.dgfcen[0]=lgbccf.dgfcen[1]=0.;
   lgbccf.delgf[0]=lgbccf.delgf[1]=0.;
   lgbccf.delf[0]=lgbccf.delf[1]=0.;
   lgbccf.cogf[0][0]=lgbccf.cogf[0][1]=1.;
   lgbccf.cogf[1][0]=lgbccf.cogf[1][1]=0.;
   lgbccf.cofg[0][0]=lgbccf.cofg[0][1]=1.;
   lgbccf.cofg[1][0]=lgbccf.cofg[1][1]=0.;
   lgbccf.gfult[0]=lgbccf.gfult[1]=0.;
   lgbccf.fvult[0]=lgbccf.fvult[1]=0.;
   lgbccf.fult[0]=lgbccf.fult[0]=0.;
   lgbccf.rotgf=0.;
   lgbccf.crotgf=1.;
   lgbccf.srotgf=0.;
   lgbccf.dtrt=0.;
   lgbccf.persvr=1.9;
   lgbccf.dimpun=1.;
   lgbccf.rotpun=0.;
   lgbccf.copun=1.;
   lgbccf.sepun=0.;
   lgbccf.simxy[0]=lgbccf.simxy[1]=1.;
   lgbccf.kfvult=0;
   lgbccf.kmprz=-2;
   lgbccf.kopult=0;
   lgbccf.itrt=0;
   lgbccf.npx=1;
   lgbccf.npy=1;
   lgbccf.kspun=1;
   lgbccf.kcgfdf=FALSE;

/* Blocco di gestione delle penne */
   lgbcpn.kvstpn=-1;
   for(i=0;i<MIZ_NUMPEN;lgbcpn.kpenna[i++]=1);
   lgbcpn.lpnlog=1;
   lgbcpn.pendis=FALSE;

/* Blocco per tracciamento stringhe di caratteri */
   for(i=0;i<MIZ_L_DIMCAR;lgbcsg.dimcar[i++]=1.);
   lgbcsg.corot=1.;
   lgbcsg.serot=0.;
   lgbcsg.dftsc[0]=lgbcsg.dftsc[1]=1.;
   lgbcsg.dstsim=0.;
   lgbcsg.delxy[0]=lgbcsg.delxy[1]=0.;
   lgbcsg.pagmar[0]=lgbcsg.pagmar[2]=0.;
   lgbcsg.pagmar[1]=lgbcsg.pagmar[3]=1023.;
   lgbcsg.kliv=10;
   for(i=1;i<=MIZ_NUMALF;lgbcsg.koralf[i++]=i);
   lgbcsg.kalfu=0;
   lgbcsg.kpctbo=0;
   lgbcsg.kpctbv=0;
   lgbcsg.kpnsim=0;
   lgbcsg.minusc=0;
   lgbcsg.kanzer=TRUE;

/* Blocco di codifica dei caratteri */
#include "/mizar/util/lgbccr.h"

/* Blocco common dell'interprete */
   lgbcfi.kpgmax=0;
   lgbcfi.krcult=0;
   lgbcfi.krulbf=0;
   copyst("grafic.dat",lgbcfi.nomfil,60);
   lgbcfi.nomess=FALSE;
   lgbcfi.filopn=FALSE;  

/* Blocchi di parametri per i vari interpreti. 
   I nomi hanno la forma bldXXX, ma vengono letti dalla versione interattiva 
   della libreria nel blocco lggraf di ciascun interprete. */

/* Blocco common TTY */
   bldtty.dlim[0]=1023.;
   bldtty.dlim[1]=1023.;
   bldtty.dflim[0]=1023.;
   bldtty.dflim[1]=1023.;
   bldtty.dimug[0]=bldtty.dimug[1]=1.;
   for(i=0;i<10;i++)
   {  bldtty.dlimps[i][0]=1023.;
      bldtty.dlimps[i][1]=1023.;
   }
   bldtty.pfin[0]=bldtty.pfin[1]=0.;
   bldtty.marg[0]=bldtty.marg[1]=0;
   bldtty.knpen=64;
   bldtty.knpndf=64;
   bldtty.kstpn=1;
   bldtty.klimpg=0;
   bldtty.lprmo=copyst(">",bldtty.stprmo,10);
   bldtty.lprmg=copyst(">",bldtty.stprmg,40);
   bldtty.lnom=copyst("TTY",bldtty.nomint,20);
   bldtty.lnmoug=copyst("stdout",bldtty.nomoug,60);
   bldtty.prompg=TRUE;
   bldtty.prompt=TRUE;
   bldtty.bell=FALSE;
   bldtty.spool=FALSE;
   bldtty.posfin=TRUE;
   bldtty.ougsep=FALSE;
   bldtty.punsim=FALSE;
   bldtty.batch=FALSE;
   bldtty.ansi_term=TRUE;
   bldtty.tek_term=FALSE;

/* Blocco common POS */
   bldpos.dlim[0]=2290.;
   bldpos.dlim[1]=3200.;
   bldpos.dflim[0]=bldpos.dlim[0];
   bldpos.dflim[1]=bldpos.dlim[1];
   bldpos.dimug[0]=bldpos.dimug[1]=3.;
   for(i=0;i<10;i++)
   {  bldpos.dlimps[i][0]=bldpos.dlim[0];
      bldpos.dlimps[i][1]=bldpos.dlim[1];
   }
   bldpos.pfin[0]=bldpos.pfin[1]=0.;
   bldpos.marg[0]=bldpos.marg[1]=0;
   bldpos.knpen=16;
   bldpos.knpndf=16;
   bldpos.kstpn=1;
   bldpos.klimpg=0;
   bldpos.lprmo=copyst(">",bldpos.stprmo,10);
   bldpos.lprmg=copyst(">",bldpos.stprmg,40);
   bldpos.lnom=copyst("PostScript",bldpos.nomint,20);
   bldpos.lnmoug=copyst("grafico.ps",bldpos.nomoug,60);
   bldpos.prompg=TRUE;
   bldpos.prompt=TRUE;
   bldpos.bell=FALSE;
   bldpos.spool=FALSE;
   bldpos.posfin=TRUE;
   bldpos.ougsep=FALSE;
   bldpos.punsim=FALSE;
   bldpos.batch=TRUE;
   bldpos.ansi_term=TRUE;
   bldpos.tek_term=FALSE;

/* Blocco common TEK */
   bldtek.dlim[0]=1023.;
   bldtek.dlim[1]=780.;
   bldtek.dflim[0]=1023.;
   bldtek.dflim[1]=780.;
   bldtek.dimug[0]=bldtek.dimug[1]=1.;
   for(i=0;i<10;i++)
   {  bldtek.dlimps[i][0]=1023.;
      bldtek.dlimps[i][1]=780.;
   }
   bldtek.pfin[0]=bldtek.pfin[1]=0.;
   bldtek.marg[0]=bldtek.marg[1]=0;
   bldtek.knpen=1;
   bldtek.knpndf=1;
   bldtek.kstpn=1;
   bldtek.klimpg=0;
   bldtek.lprmo=copyst(">",bldtek.stprmo,10);
   bldtek.lprmg=copyst(">",bldtek.stprmg,40);
   bldtek.lnom=copyst("Tektronix 4010",bldtek.nomint,20);
   bldtek.lnmoug=copyst("stdout",bldtek.nomoug,60);
   bldtek.prompg=FALSE;
   bldtek.prompt=TRUE;
   bldtek.bell=TRUE;
   bldtek.spool=FALSE;
   bldtek.posfin=TRUE;
   bldtek.ougsep=FALSE;
   bldtek.punsim=FALSE;
   bldtek.batch=FALSE;
   bldtek.ansi_term=FALSE;
   bldtek.tek_term=TRUE;

/* Blocco common TPS */
   bldtps.dlim[0]=2300.;
   bldtps.dlim[1]=3300.;
   bldtps.dflim[0]=2300.;
   bldtps.dflim[1]=3300.;
   bldtps.dimug[0]=bldtps.dimug[1]=3.;
   for(i=0;i<10;i++)
   {  bldtps.dlimps[i][0]=2300.;
      bldtps.dlimps[i][1]=3300.;
   }
   bldtps.pfin[0]=bldtps.pfin[1]=0.;
   bldtps.marg[0]=bldtps.marg[1]=0;
   bldtps.knpen=16;
   bldtps.knpndf=16;
   bldtps.kstpn=1;
   bldtps.klimpg=0;
   bldtps.lprmo=copyst(">",bldtps.stprmo,10);
   bldtps.lprmg=copyst(">",bldtps.stprmg,40);
   bldtps.lnom=copyst("PostScript per TeX",bldtps.nomint,20);
   bldtps.lnmoug=copyst("grafico.tps",bldtps.nomoug,60);
   bldtps.prompg=TRUE;
   bldtps.prompt=TRUE;
   bldtps.bell=FALSE;
   bldtps.spool=FALSE;
   bldtps.posfin=TRUE;
   bldtps.ougsep=TRUE;
   bldtps.punsim=FALSE;
   bldtps.batch=FALSE;
   bldtps.ansi_term=TRUE;
   bldtps.tek_term=FALSE;

/* Blocco common HPJ */
   bldbps.dlim[0]=2945.;
   bldbps.dlim[1]=2129.;
   bldbps.dflim[0]=2945.;
   bldbps.dflim[1]=2129.;
   bldbps.dimug[0]=bldbps.dimug[1]=3.;
   bldbps.dlimps[0][0]=2947.;
   bldbps.dlimps[0][1]=2115.;
   bldbps.dlimps[1][0]=2945.;
   bldbps.dlimps[1][1]=2111.;
   bldbps.dlimps[2][0]=2945.;
   bldbps.dlimps[2][1]=2129.;
   bldbps.dlimps[3][0]=2944.;
   bldbps.dlimps[3][1]=2136.;
   bldbps.dlimps[4][0]=3115.;
   bldbps.dlimps[4][1]=2371.;
   bldbps.dlimps[5][0]=3113.;
   bldbps.dlimps[5][1]=2378.;
   bldbps.dlimps[6][0]=3113.;
   bldbps.dlimps[6][1]=2385.;
   bldbps.dlimps[7][0]=3112.;
   bldbps.dlimps[7][1]=2392.;
   bldbps.dlimps[8][0]=3112.;
   bldbps.dlimps[8][1]=2392.;
   bldbps.dlimps[9][0]=3112.;
   bldbps.dlimps[9][1]=2392.;
   bldbps.pfin[0]=bldbps.pfin[1]=0.;
   bldbps.marg[0]=bldbps.marg[1]=0;
   bldbps.knpen=1;
   bldbps.knpndf=1;
   bldbps.kstpn=1;
   bldbps.klimpg=2;
   bldbps.lprmo=copyst(">",bldbps.stprmo,10);
   bldbps.lprmg=copyst(">",bldbps.stprmg,40);
   bldbps.lnom=copyst("PostScript in bitmap",bldbps.nomint,20);
   bldbps.lnmoug=copyst("bitmap.ps",bldbps.nomoug,60);
   bldbps.prompg=TRUE;
   bldbps.prompt=TRUE;
   bldbps.bell=FALSE;
   bldbps.spool=FALSE;
   bldbps.posfin=TRUE;
   bldbps.ougsep=FALSE;
   bldbps.punsim=FALSE;
   bldbps.batch=TRUE;
   bldbps.ansi_term=TRUE;
   bldbps.tek_term=FALSE;

/* Blocco common VGA */
/*    bldvga.dlim[0]=639.; */
/*    bldvga.dlim[1]=479.; */
/*    bldvga.dflim[0]=639.; */
/*    bldvga.dflim[1]=479.; */
/*    bldvga.dimug[0]=bldvga.dimug[1]=1.; */
/*    for(i=0;i<10;i++) */
/*    {  bldvga.dlimps[i][0]=639.; */
/*       bldvga.dlimps[i][1]=479.; */
/*    } */
/*    bldvga.pfin[0]=bldvga.pfin[1]=0.; */
/*    bldvga.marg[0]=bldvga.marg[1]=0; */
/*    bldvga.knpen=16; */
/*    bldvga.knpndf=16; */
/*    bldvga.kstpn=1; */
/*    bldvga.klimpg=0; */
/*    bldvga.lprmo=copyst(">",bldvga.stprmo,10); */
/*    bldvga.lprmg=copyst(">",bldvga.stprmg,40); */
/*    bldvga.lnom=copyst("VGA",bldvga.nomint,20); */
/*    bldvga.lnmoug=copyst("stdout",bldvga.nomoug,60); */
/*    bldvga.prompg=FALSE; */
/*    bldvga.prompt=TRUE; */
/*    bldvga.bell=TRUE; */
/*    bldvga.spool=FALSE; */
/*    bldvga.posfin=TRUE; */
/*    bldvga.ougsep=FALSE; */
/*    bldvga.punsim=FALSE; */
/*    bldvga.batch=FALSE; */

/* Blocco common HPL */
/*    bldhpl.dlim[0]=7819.; */
/*    bldhpl.dlim[1]=11219.; */
/*    bldhpl.dflim[0]=7819.; */
/*    bldhpl.dflim[1]=11219.; */
/*    bldhpl.dimug[0]=bldhpl.dimug[1]=10.2; */
/*    for(i=0;i<10;i++) */
/*    {  bldhpl.dlimps[i][0]=7819.; */
/*       bldhpl.dlimps[i][1]=11219.; */
/*    } */
/*    bldhpl.pfin[0]=bldhpl.pfin[1]=0.; */
/*    bldhpl.marg[0]=bldhpl.marg[1]=0; */
/*    bldhpl.knpen=16; */
/*    bldhpl.knpndf=16; */
/*    bldhpl.kstpn=1; */
/*    bldhpl.klimpg=0; */
/*    bldhpl.lprmo=copyst(">",bldhpl.stprmo,10); */
/*    bldhpl.lprmg=copyst(">",bldhpl.stprmg,40); */
/*    bldhpl.lnom=copyst("HP LaserJet IIIP",bldhpl.nomint,20); */
/*    bldhpl.lnmoug=copyst("grafico.hpl",bldhpl.nomoug,60); */
/*    bldhpl.prompg=TRUE; */
/*    bldhpl.prompt=TRUE; */
/*    bldhpl.bell=FALSE; */
/*    bldhpl.spool=FALSE; */
/*    bldhpl.posfin=TRUE; */
/*    bldhpl.ougsep=FALSE; */
/*    bldhpl.punsim=FALSE; */
/*    bldhpl.batch=TRUE; */

/* Blocco common HPJ */
/*    bldhpj.dlim[0]=2945.; */
/*    bldhpj.dlim[1]=2129.; */
/*    bldhpj.dflim[0]=2945.; */
/*    bldhpj.dflim[1]=2129.; */
/*    bldhpj.dimug[0]=bldhpj.dimug[1]=3.; */
/*    bldhpj.dlimps[0][0]=2947.; */
/*    bldhpj.dlimps[0][1]=2115.; */
/*    bldhpj.dlimps[1][0]=2945.; */
/*    bldhpj.dlimps[1][1]=2111.; */
/*    bldhpj.dlimps[2][0]=2945.; */
/*    bldhpj.dlimps[2][1]=2129.; */
/*    bldhpj.dlimps[3][0]=2944.; */
/*    bldhpj.dlimps[3][1]=2136.; */
/*    bldhpj.dlimps[4][0]=3115.; */
/*    bldhpj.dlimps[4][1]=2371.; */
/*    bldhpj.dlimps[5][0]=3113.; */
/*    bldhpj.dlimps[5][1]=2378.; */
/*    bldhpj.dlimps[6][0]=3113.; */
/*    bldhpj.dlimps[6][1]=2385.; */
/*    bldhpj.dlimps[7][0]=3112.; */
/*    bldhpj.dlimps[7][1]=2392.; */
/*    bldhpj.dlimps[8][0]=3112.; */
/*    bldhpj.dlimps[8][1]=2392.; */
/*    bldhpj.dlimps[9][0]=3112.; */
/*    bldhpj.dlimps[9][1]=2392.; */
/*    bldhpj.pfin[0]=bldhpj.pfin[1]=0.; */
/*    bldhpj.marg[0]=bldhpj.marg[1]=0; */
/*    bldhpj.knpen=1; */
/*    bldhpj.knpndf=1; */
/*    bldhpj.kstpn=1; */
/*    bldhpj.klimpg=2; */
/*    bldhpj.lprmo=copyst(">",bldhpj.stprmo,10); */
/*    bldhpj.lprmg=copyst(">",bldhpj.stprmg,40); */
/*    bldhpj.lnom=copyst("HP Deskjet 500",bldhpj.nomint,20); */
/*    bldhpj.lnmoug=copyst("PRN",bldhpj.nomoug,60); */
/*    bldhpj.prompg=TRUE; */
/*    bldhpj.prompt=TRUE; */
/*    bldhpj.bell=FALSE; */
/*    bldhpj.spool=FALSE; */
/*    bldhpj.posfin=TRUE; */
/*    bldhpj.ougsep=FALSE; */
/*    bldhpj.punsim=FALSE; */
/*    bldhpj.batch=TRUE; */

#endif

   return;
}
int copyst(str,buf,maxc)
char *str;

char buf[];
int maxc;
{  int i=0;
   while((buf[i]=*str++)!=NUL && i<maxc)
      i++;
   return(i);
}
